c===============================================================================
c
      subroutine table(ptbl,ttbl,pt
     .                ,rdq,rdth,rdp,rdthe,pl,thl,qs0,sqs,sthe,the0)
c
c     implicit none
c
c *** Generate values for look-up tables used in convection.
c
      integer*4 itb,jtb
      parameter (itb=76,jtb=134)
      real*4 thh,ph,pq0,a1,a2,a3,a4,r,cp,eliwv,eps
Cmp      parameter (thh=350.,ph=105000.
C	changed 3/8/99 to make more like operation grdeta stuff
C	appeared to have no change on underflow problem
      parameter (thh=365.,ph=105000.
     .          ,pq0=379.90516
     .          ,a1=610.78,a2=17.2693882,a3=273.16,a4=35.86
     .          ,r=287.04,cp=1004.6,eliwv=2.683e6,eps=1.e-10)
c
      real*4 ptbl(itb,jtb),ttbl(jtb,itb),qsold (jtb),pold(jtb)
     .      ,qs0 (jtb),sqs   (jtb),qsnew(jtb)
     .      ,y2p (jtb),app   (jtb),aqp  (jtb),pnew(jtb)
     .      ,told(jtb),theold(jtb),the0 (itb),sthe(itb)
     .      ,y2t (jtb),thenew(jtb),apt  (jtb),aqt (jtb),tnew(jtb)
c_______________________________________________________________________________
c
c *** Coarse look-up table for saturation point.
c
      kthm=jtb
      kpm=itb
      kthm1=kthm-1
      kpm1=kpm-1
c
      pl=pt
c
      dth=(thh-thl)/real(kthm-1)
      dp =(ph -pl )/real(kpm -1)
c
      rdth=1./dth
      rdp=1./dp
      rdq=kpm-1
c
      th=thl-dth
c
      do kth=1,kthm
         th=th+dth
         p=pl-dp
         do kp=1,kpm
            p=p+dp
            ape=(100000./p)**(r/cp)
            qsold(kp)=pq0/p*exp(a2*(th-a3*ape)/(th-a4*ape))
            pold(kp)=p
         enddo
c
         qs0k=qsold(1)
         sqsk=qsold(kpm)-qsold(1)
         qsold(1  )=0.
         qsold(kpm)=1.
c
         do kp=2,kpm1
            qsold(kp)=(qsold(kp)-qs0k)/sqsk
c
c ********* Fix due to cyber half prec. limitation.
c
            if (qsold(kp)-qsold(kp-1) .lt. eps) 
     .         qsold(kp)=qsold(kp-1)+eps
c
c ********* End fix.
c
         enddo
c
         qs0(kth)=qs0k
         sqs(kth)=sqsk
         qsnew(1  )=0.
         qsnew(kpm)=1.
         dqs=1./real(kpm-1)
c
         do kp=2,kpm1
            qsnew(kp)=qsnew(kp-1)+dqs
         enddo
c
         y2p(1   )=0.
         y2p(kpm )=0.
c
         call spline(jtb,kpm,qsold,pold,y2p,kpm,qsnew,pnew,app,aqp)
c
         do kp=1,kpm
            ptbl(kp,kth)=pnew(kp)
         enddo
c
      enddo
c
c *** Coarse look-up table for t(p) from constant the.
c
      p=pl-dp
      do kp=1,kpm
         p=p+dp
         th=thl-dth
         do kth=1,kthm
            th=th+dth
            ape=(100000./p)**(r/cp)
            qs=pq0/p*exp(a2*(th-a3*ape)/(th-a4*ape))
            told(kth)=th/ape
            theold(kth)=th*exp(eliwv*qs/(cp*told(kth)))
         enddo
c
         the0k=theold(1)
         sthek=theold(kthm)-theold(1)
         theold(1   )=0.
         theold(kthm)=1.
c
         do kth=2,kthm1
            theold(kth)=(theold(kth)-the0k)/sthek
c
            if (theold(kth)-theold(kth-1) .lt. eps)
     .         theold(kth)=theold(kth-1)+eps
c
         enddo
c
         the0(kp)=the0k
         sthe(kp)=sthek
         thenew(1  )=0.
         thenew(kthm)=1.
         dthe=1./real(kthm-1)
         rdthe=1./dthe
c
         do kth=2,kthm1
            thenew(kth)=thenew(kth-1)+dthe
         enddo
c
         y2t(1   )=0.
         y2t(kthm)=0.
c
         call spline(jtb,kthm,theold,told,y2t,kthm,thenew,tnew,apt,aqt)
c
         do kth=1,kthm
            ttbl(kth,kp)=tnew(kth)
            write(6001,*)kth,kp,ttbl(kth,kp)
         enddo
c
      enddo
c
      return
      end

      SUBROUTINE SNOHIRES (SI,   SM,GLAT,GLON,LIST,LUSAF,DTR)
C
C  INPUTS:  SM (ETA LAND/SEA MASK)
C            GLAT (LATITUDE ARRAY OF ETA GRID)
C            GLON (LONGITUDE ARRAY OF ETA GRID)
C            LIST (UNIT NUMBER OF PRINTOUT)
C            LUSAF (LOGICAL - TRUE:USE IMS SNOW AND USAF SNOW, 
C                            FALSE: USE IMS SNOW ONLY)
C            DTR   (DEGREES TO RADIANS CONVERSION FACTOR)
C
C  OUTPUTS: SI (SNOWDEPTH AND SEA-ICE ON ETA GRID, SEE CALLING
C                SUBROUTINE CNSTS FOR MORE DETAILS ON SI OUTPUT)
C
      IMPLICIT REAL (A-H, O-Z)
C
      INCLUDE "parmeta"
C
      LOGICAL  LUSAF
C
      REAL         AFSNO   (512,512)
      INTEGER      MSKAF   (512,512)
C
      REAL         SCVH    (1024,1024)
      INTEGER      MSKSCVH (1024,1024)
C
      REAL         SI(IM,JM), SM(IM,JM), GLAT(IM,JM), GLON(IM,JM)
C
C  INPUT UNITS (45-NESDIS DAILY SNOW/ICE, 41-USAF DAILY SNOW/ICE,
C                43-NESDIS 1/16-BEDIENT LAND/SEA MASK,
C                42-USAF   1/8-BEDIENT LAND/SEA MASK)
C 
      DATA   INSNOIMS/45/, INSNOAF/41/, INMSKAF/42/, INMSKIMS/43/
C
C  SET LOWER THRESHOLD FOR SNODEPTH IN TENTHS OF INCHES (MININUM
C  SNOW DEPTH IS 1.5" WHERE THERE IS SNOW COVERAGE).
C
      DATA     IDEPTH /15/
C
C**************************  BEGIN EXECUTION ***********************
C
C     SPECIFY THE UNIT NUMBER OF THE PRINTER.
      IOUTUPRT = LIST
C
C     SPECIFY PARAMETERS OF THE N.H. 1024X1024 IMS 1/16-MESH GRID
C
C     LOCATION OF THE POLE:
      XPNMC8 = 513.
      YPNMC8 = 512.
C     N -- THE NUMBER OF GRID INTERVALS FROM THE POLE TO THE EQUATOR:
      ENNMC8 = 16.0E0 * 31.2043316E0
C     THE LONGITUDINAL ROTATION ANGLE OF THE GRID
      ALNMC8 = 10.E0
C     THE ORIENTATION WEST LONGITUDE OF THE GRID:
      ORIENT8 = 80.E0
C
C  SPECIFY PARAMETERS OF THE N.H. 512 X 512 GRID TYPE 88 (USAF GRID).
C
C  LOCATION OF POLE:
      XPNMCAF = 257.E0
      YPNMCAF = 256.E0
C  GRID MESH LENGTH AT 60N IN KM (FYI, BUT NOT NEEDED)
C.... XMESHL  = 47.625E0
C  NUMBER OF GRID INTERVALS FROM POLE TO EQUATOR
      ENNMCAF = 8.0 * 31.2043316E0
C  THE LONGITUDE ROTATION ANGLE OF THE GRID
      ALNMCAF = 10.E0
C  THE ORIENTATION WEST LONGITUDE OF THE GRID
      ORIENTAF  = 80.E0
C
C  CALL TO READ NESDIS/IMS 1/16-BEDIENT DAILY N.H. SNOW/ICE VIA SNO16GET
C  
      write(6,*) 'calling SNO16GET'
      CALL SNO16GET(SCVH,IYEAR,IMONTH,IDAY,  INSNOIMS,LIST)
      write(6,*) 'back from SNO16GET'
Ctest
Ctest      write(60,7701) IYEAR, IMONTH, IDAY
Ctest  7701 format('IMS DATA : ', 3i2.2)
Ctest
C
C At present time the IMS file has a 2-digit year.  Add century:
C Now IYEAR from SNO16GET is 4-digits so we don't need to do this
c     IF (IYEAR .GT. 90) THEN
c        IYEAR = IYEAR + 1900
c     ELSE
c        IYEAR = IYEAR + 2000
c     ENDIF
C
C Calculate Julian date:
      NDAY = IW3JDN(IYEAR,IMONTH,IDAY)
      WRITE (IOUTUPRT, 1) INSNOIMS, IYEAR, IMONTH, IDAY, NDAY 
    1 FORMAT(1H ,' DAILY NESDIS SNOW READ IN VIA UNIT NO.=',I3/
     2       1H ,' FOR VALID DATE OF Y-M-D =',I4,'-',I2,'-',I2/
     3       1H ,' WHICH IS JULIAN DAY =', I10) 
C
C   READ THE NESDIS-IMS LAND-WATER MASK
C                                          (SEA=0,LAND=1)
      DO 10 J = 1, 1024
         READ(INMSKIMS,'(80I1)') (MSKSCVH(I,J),I=1,1024)
 10   CONTINUE
C
      CALL PRINTIMS (SCVH, MSKSCVH)
C
C  PRINT SPECIFIED USAF SNOW PROCESSING FLAG
      WRITE(IOUTUPRT,2211)   LUSAF
 2211 FORMAT(//1H ,5X,'SUBROUTINE SNOHIRES                    '/
     1     1H ,1X,'  WILL TRY TO PROCESS USAF SNOWCOVER: LUSAF = ',L2)
C
      IF (LUSAF) THEN
C
C  READ AIR FORCE 1/8-BEDIENT DAILY N.H. SNOW/ICE VIA SNO8GET
C
	write(6,*) 'calling SNO8GET'
      CALL SNO8GET(AFSNO,IYEAR,IMONTH,IDAY,   INSNOAF,LIST,LUSAF)
Ctest
Ctest      write(60,7702) IYEAR, IMONTH, IDAY
Ctest  7702 format('USAF DATA: ', 3i2.2)
Ctest
C
C  IF I/O ERROR ENCOUNTERED IN SNO8GET, THEN LUSAF IS RETURNED FALSE
C  
        IF (.NOT. LUSAF) THEN
          WRITE(IOUTUPRT,56)
   56     FORMAT(1H ,'WARNING: FILE ERR IN USAF SNOW ANAL')
        ELSE 
C  The USAF snow header has a 2-digit year.  Add century:
C  Now IYEAR from SNO8GET is 4-digits so we don't need to do this
c         IF (IYEAR .GT. 90) THEN
c           IYEAR = IYEAR + 1900
c         ELSE
c           IYEAR = IYEAR + 2000
c         ENDIF
C
C Calculate Julian date:
          NAFDAY = IW3JDN(IYEAR,IMONTH,IDAY)
C
          WRITE(IOUTUPRT,2) INSNOAF, IYEAR, IMONTH, IDAY, NAFDAY 
    2     FORMAT(1H ,' DAILY USAF SNOW READ IN VIA UNIT NO.=',I3/
     1           1H ,' FOR VALID DATE OF Y-M-D ='I4,'-',I2,'-',I2/
     2           1H ,' WHICH IS JULIAN DAY =', I10) 
C
           IF (NAFDAY .LT. NDAY-4) THEN
             LUSAF = .FALSE.
             WRITE(IOUTUPRT,2644) NDAY,NAFDAY
 2644        FORMAT(/1H ,'******  WARNING   ****** WARNING ******'/
     1            1H ,'DATE OF USAF SNOW ANAL MORE THAN 4 DAYS OLD'/
     1            1H ,' -  WILL FALL-BACK TO NESDIS IMS SNOW COVER'/
     2            1H ,43X,'   NESDIS SNOW ANAL JULDAY=',I7/
     3            1H ,43X,'     USAF SNOW ANAL JULDAY=',I7)
C 
           ENDIF
        ENDIF
      ENDIF
C
C    NOTE:  UPON RETURN FROM CALL SNO8GET ABOVE, USAF SNOW/ICE FIELD
C            HAS FOLLOWING PHYSICAL RANGES:
C         - VALUES OVER SEA POINTS ARE 0.0 OR 11.0 (SEA-ICE FLAG)
C         - VALUES OVER LAND/COAST ARE 0.0 OR POS DEPTH IN METERS
C         - SNOWDEPTH OVER LAND IS ACTUAL, NOT WATER EQUIVALENT YET
C
C   READ THE USAF AFGWC LAND/COAST/SEA MASK
C                           (SEA=1,LAND=2,COASTAL-LAND=4,OFFWORLD=9)
      READ(INMSKAF)  MSKAF
C
C---------- I/O OF PRIMARY INPUT FIELDS IS COMPLETE -------------
C                        INIT RADIANS TO DEGREES
      RTD = 1./DTR
C
C IDEPTH IS CRITERION OF SNOWDEPTH THRESHOLD IN TENTHS OF
C INCHES BELOW WHICH USAF SNOWDEPTH WILL BE ASSUMED ZERO.
C HERE CONVERT IDEPTH TO METERS
C
       DEPTH = FLOAT(IDEPTH) * 2.54E-3   
C
       IF ( LUSAF) THEN
         WRITE(IOUTUPRT,2321) LUSAF,IDEPTH
 2321    FORMAT(1H //' USAF SNODEP ANAL WILL BE USED, LUSAF=',L2/
     1    1H , 35X,'SNODEPTH THRESHOLD (TENTHS OF INCHES) =',I3)
         CALL PRINTAF (AFSNO,MSKAF)
      ELSE
         WRITE(IOUTUPRT,2322) LUSAF
 2322    FORMAT(1H //' USAF SNODEP ANALYSIS WILL BE IGNORED'/
     1          1H , 35X,'LOGICAL FLAG LUSAF=',L2)
      ENDIF
C
C----------INITIALIZE SNOW/ICE ARRAYS TO ZERO ON ETA GRID------------
C
      SI = 0.0
C--------------------------------------------------------------------
C
C ****** NOW BEGIN MAJOR LOOP OVER ALL ETA GRIDS AND POINTS *******
C
         DO J=1,JM
         DO I=1,IM
C
C--------------- DETERMINE LAT/LON OF ETA GRID POINT -------------
C                    (HERE LONG WILL BE EAST LONG)
C
      YYLAT = GLAT(I,J)*RTD
      XLONG = 360. - GLON(I,J)*RTD
C
C  WHERE ETA DOMAIN SOUTH OF 22 N LAT (INCLUDING ANY S.H.),
C  WE KEEP DEFAULT ZERO SNOW/ICE 
C
      IF (YYLAT.LT.22.0E0) GO TO 4300
C----------------------------------------------------------------
C
C  DETERMINE LOCATION OF ETA POINT ON THE 1024 X 1024 NESDIS/IMS GRID
C
         RM= ENNMC8*COS(YYLAT * DTR) / (1.E0 + SIN(YYLAT * DTR))
         RAD = (XLONG - ALNMC8) * DTR
         X = XPNMC8 + RM * COS(RAD)
         Y = YPNMC8 + RM * SIN(RAD)
C
      IS  = INT(X)
      IP1 = IS + 1
      JS  = INT(Y)
      JP1 = JS + 1
C
C--------------------------------------------------------------------
C.......FIRST INTERPOLATE NESDIS SNOW/ICE AS PRIMARY DEFAULT......
C
C     THE VALUE OF SNOW COVER OR SEA ICE ON THE 1024 X 1024
C     NESDIS/IMS GRID IS 1 FOR SNOW/ICE POINTS, 0 FOR SNOW/ICE-FREE.
C     WE UTILIZE AN 1024 X 1024 LAND MASK
C     FROM IMS TO DISTINGUISH SEA ICE FROM SNOW POINTS
C     (ACTUALLY, THE DATA WE GOT FROM IMS HAVE DIFFERENT VALUES FOR
C     SNOW AND FOR ICE.  BUT SINCE WE WANT TO USE AS MUCH OF THE ORIGINAL
C     PROGRAM [WRITTEN FOR THE 1/2-MESH SAB SNOW/ICE] AS POSSIBLE, WE GIVE
C     SNOW COVER AND SEA ICE THE SAME VALUE (=1) AND LET THE MASK DO THE
C     JOB.
C
C  NOW USE ETA AND IMS LAND-SEA MASKS TO ENSURE ONLY LAND
C  POINTS ARE INTERPOLATED TO LAND POINTS (TO DETERMINE SNOW)
C  AND ONLY SEA POINTS ARE INTERPOLATED TO SEA POINTS (FOR ICE)
C  (NESDIS/IMS LAND MASK: SEA=0,LAND=1, WHILE THE ETA MASK IS THE
C  OTHER WAY ROUND).
C
      ILAND = 1
      IF( SM(I,J) .GT. 0.9 ) ILAND=0
C
      IPOINT = NINT(X)
      JPOINT = NINT(Y)
      IF ( MSKSCVH(IPOINT,JPOINT) .EQ. ILAND ) THEN
        SI(I,J) = SCVH(IPOINT,JPOINT)
        GO TO 3351
      ENDIF
C
C  NEAREST NEIGHBOR NOT SAME SFC TYPE, SO USE ALL 4 SURROUNDING POINTS
C
      KOUNT = 0
C
      XRATIO = X - REAL(IS)
      YRATIO = Y - REAL(JS)
C
      AREA11 = (1.0E0 - XRATIO) * (1.0E0 - YRATIO)
      AREA21 = XRATIO * (1.0E0 - YRATIO)
      AREA12 = (1.0E0 - XRATIO) * YRATIO
      AREA22 = XRATIO * YRATIO
C
      IF( MSKSCVH(IS, JS) .EQ. ILAND) THEN
         KOUNT  = KOUNT + 1
         AREA   = AREA11
         IPOINT = IS
         JPOINT = JS
      END IF
C
      IF( MSKSCVH(IS, JP1) .EQ. ILAND ) THEN
         KOUNT = KOUNT +1
         IF (KOUNT .EQ. 1) THEN
            IPOINT = IS
            JPOINT = JP1
         ELSEIF (AREA12 .GT. AREA) THEN
            AREA   = AREA12
            IPOINT = IS
            JPOINT = JP1
         END IF
      END IF
C
      IF( MSKSCVH(IP1, JS) .EQ. ILAND ) THEN
         KOUNT = KOUNT + 1
         IF (KOUNT .EQ. 1) THEN
            AREA   = AREA21
            IPOINT = IP1
            JPOINT = JS
         ELSEIF (AREA21 .GT. AREA) THEN
            AREA   = AREA21
            IPOINT = IP1
            JPOINT = JS
         END IF
      END IF
C
      IF( MSKSCVH(IP1, JP1) .EQ. ILAND ) THEN
         KOUNT = KOUNT + 1
         IF (KOUNT .EQ. 1) THEN
            AREA   = AREA22
            IPOINT = IP1
            JPOINT = JP1
         ELSEIF (AREA22 .GT. AREA) THEN
            AREA   = AREA22
            IPOINT = IP1
            JPOINT = JP1
         END IF
      END IF
C
C     DETERMINE SNO/ICE USING NEAREST NEIGHBOR WITH SAME SFC TYPE 
C
      IF(KOUNT .GT. 0) THEN
         SI(I,J) = SCVH(IPOINT,JPOINT)
      ELSE
C
C         NO IMMEDIATELY SURROUNDING POINTS IN THE 1024 X 1024 FIELD OF
C         SNOW/ICE HAVE THE SAME LAND-SEA TYPE AS THE ETA POINT.  THE
C         ETA POINT MAY BE SMALL ISLAND OR LAKE OR SMALL BAY OR PENNIN.
C         (INVARIABLY A SMALL LAKE IN ETA GRID)
C         SO EXPAND SEARCH RADIUS AND TAKE FIRST SFC TYPE MATCH
C
          IPOINT = NINT(X)
          JPOINT = NINT(Y)
C
          do3346: DO LL=1,4
           JPE = MIN (1024, JPOINT+LL)
           JPB = MAX (1 , JPOINT-LL)
           IPE = MIN (1024, IPOINT+LL)
           IPB = MAX (1 , IPOINT-LL)
C
             doout2346: DO MK=JPB,JPE
             doin2346: DO  NK=IPB,IPE
               IF (MSKSCVH(NK,MK) .EQ. ILAND) THEN
               SI(I,J) = SCVH(NK,MK)
               GO TO 3351
               ENDIF

            END DO doin2346
            END DO doout2346
          END DO do3346
C
C  NO LAND/SEA MASK MATCHES FOUND, SO 
C     A) NORTH OF 55N, WE ASSIGN SNOW/ICE IRRESPECTIVE OF SFC TYPE
C     B) SOUTH OF 55N, WE KEEP A PRIORI ZERO DEFAULT
C   (THE "B" OPTION BEST FOR WARMER LATS OF U.S., WHERE THIS CONDITION 
C   IS VIRTUALLY ALWAYS A SMALL ETA LAKE WITH NO COUNTERPART WATER 
C   NEARBY IN THE NESDIS/IMS GRID, E.G., SALT LAKE, WHERE WE MUST  
C   AVOID GETTING SEA-ICE OWING TO SURROUNDING SNOW COVER)
C
       WRITE (IOUTUPRT, 3347) I,J,YYLAT,XLONG,IPOINT,JPOINT,ILAND
 3347   FORMAT(1H ,'**NO IMS MSK MATCH,',
     1         'ETA-I,J,ELAT,ELON,IMS-I,IMS-J,LND:',2I6,2F7.2,2I3,I2)
C
             IF (YYLAT .GE. 55.0 ) THEN
               SI(I,J) = SCVH(IPOINT,JPOINT) 
             ELSE
               SI(I,J) = 0.0
             ENDIF 
      ENDIF
C
 3351 CONTINUE
C 
      IF (.NOT. LUSAF) GO TO 4300
C
C
C-------------- BEGIN USAF SNOW/ICE INTERPOLATION------------------
c  If current USAF snow/ice anal was successfully read (lusaf=true), 
c  add the USAF information as follows:
C
c  The quality of NESDIS/IMS sea-ice cover and snow coverage (especially
c  in areas with small amounts of snow) are better than the usaf data.
c  We do not use usaf sea-ice cover data at all.  Over land, the
c  presence/absence of snow is determined by the IMS snow coverage, i.e., 
c  at a given location, if the IMS data indicate no snow, then we assume 
c  there is no snow, no matter what the USAF data say.  if the IMS data
c  show snow but the USAF data have no snow or less than 1.5" of snow at
c  the location, we assume there is a 1.5" of snow.  if both the IMS data
c  and USAF data indicate snow, and the USAF snow depth is more than 1.5",
c  then we use the USAF snow depth.
c
c     On the 512 x 512 USAF grid, the data values are 0.0 for
c     no snow or ice, 11.0 for ice points, and positive but
c     less than 11.0 for snow points.
C
C--------------------------------------IF ETA SEA POINT, SKIP USAF ANL
      IF ( SM(I,J) .GT. 0.9 ) GO TO 4300
C
C If the IMS data indicate no snow on this point, also skip USAF ANL:
      IF (SI(I,J).LT.0.001) GO TO 4300
C
C Otherwise, set snow depth to be the lower threshold, 1.5":
      SI(I,J) = DEPTH
C
C-------------------------------------------------------------------
C  THIS IS AN ETA LAND POINT, SO APPLY USAF SNOWDEPTH ANAL
C
C  DETERMINE LOCATION OF ETA POINT ON THE 512 X 512 USAF GRID
C
         RM= ENNMCAF*COS(YYLAT * DTR) / (1.E0 + SIN(YYLAT * DTR))
         RAD = (XLONG - ALNMCAF) * DTR
         X = XPNMCAF + RM * COS(RAD)
         Y = YPNMCAF + RM * SIN(RAD)
C
      IS  = INT(X)
      IP1 = IS + 1
      JS  = INT(Y)
      JP1 = JS + 1
C
C-----IF OUTSIDE OF USAF GRID DOMAIN (I.E. S.H.) WE KEEP ZERO DEFAULT--
C
      IF ((IS .LT. 1) .OR. (IS .GT. 511) .OR. (JS .LT. 1)
     1         .OR. (JS .GT. 511))  THEN
        GO TO 4300
      ENDIF
C--------------------------------------------------------------------
C
C  NOW USE ETA AND USAF LAND-SEA MASK TO ENSURE ONLY LAND POINTS ARE 
C  INTERPOLATED TO LAND POINTS (TO DETERMINE SNOW)
C   (USAF LAND MASK: SEA=1,LAND=2,COASTAL-LAND=4,OFFWORLD=9)
C   NOTE: IN REACHING THIS STAGE, WE HAVE ALREADY INSURED WE ARE ON 
C   ETA LAND POINT AND IN N.H., I.E. NOT MSKAF=9 (I.E. NOT OFFWORLD)
C  
      ILAND = 2
C
      IPOINT = NINT(X)
      JPOINT = NINT(Y)
      IF ( MSKAF(IPOINT,JPOINT) .GE. ILAND) THEN
        SI(I,J) = AFSNO(IPOINT,JPOINT)
        SI(I,J) = AMAX1(DEPTH,SI(I,J))
        GO TO 4300
      ENDIF
C
      KOUNT = 0
C
      XRATIO = X - REAL(IS)
      YRATIO = Y - REAL(JS)
C
      AREA11 = (1.0E0 - XRATIO) * (1.0E0 - YRATIO)
      AREA21 = XRATIO * (1.0E0 - YRATIO)
      AREA12 = (1.0E0 - XRATIO) * YRATIO
      AREA22 = XRATIO * YRATIO
C
      IF( MSKAF(IS, JS) .GE. ILAND) THEN
         KOUNT  = KOUNT + 1
         AREA   = AREA11
         IPOINT = IS
         JPOINT = JS
      END IF
C
      IF( MSKAF(IS, JP1) .GE. ILAND ) THEN
         KOUNT = KOUNT +1
         IF (KOUNT .EQ. 1) THEN
            IPOINT = IS
            JPOINT = JP1
         ELSEIF (AREA12 .GT. AREA) THEN
            AREA   = AREA12
            IPOINT = IS
            JPOINT = JP1
         END IF
      END IF
C
      IF( MSKAF(IP1, JS) .GE. ILAND ) THEN
         KOUNT = KOUNT + 1
         IF (KOUNT .EQ. 1) THEN
            AREA   = AREA21
            IPOINT = IP1
            JPOINT = JS
         ELSEIF (AREA21 .GT. AREA) THEN
            AREA   = AREA21
            IPOINT = IP1
            JPOINT = JS
         END IF
      END IF
C
      IF( MSKAF(IP1, JP1) .GE. ILAND ) THEN
         KOUNT = KOUNT + 1
         IF (KOUNT .EQ. 1) THEN
            AREA   = AREA22
            IPOINT = IP1
            JPOINT = JP1
         ELSEIF (AREA22 .GT. AREA) THEN
            AREA   = AREA22
            IPOINT = IP1
            JPOINT = JP1
         END IF
      END IF
C
C     DETERMINE SNO/ICE CONSIDERING THE NUMBER OF POINTS SURROUNDING
C     ETA GRID POINT WITH THE SAME LAND-SEA MASK FLAG
C
      IF (KOUNT .GT. 0) THEN
          SI(I,J) = AFSNO(IPOINT,JPOINT)
          SI(I,J) = AMAX1(DEPTH,SI(I,J))
C
      ELSE
C
C         NO IMMEDIATELY SURROUNDING POINTS IN THE 512 X 512 FIELD OF
C         SNO/ICE HAVE THE SAME LAND-SEA MASK AS THE ETA POINT.
C         THE ETA POINT MAY BE AN ISLAND OR LAKE OR BAY OR PENNINSULA.
C         SO EXPAND SEARCH RADIUS AND TAKE FIRST MASK FLAG MATCH
C
          IPOINT = NINT(X)
          JPOINT = NINT(Y)
C
          do7346: DO LL=1,7
           JPE = MIN (512, JPOINT+LL)
           JPB = MAX (1 ,  JPOINT-LL)
           IPE = MIN (512, IPOINT+LL)
           IPB = MAX (1 ,  IPOINT-LL)
C
             doout6346: DO MK=JPB,JPE
             doin6346:  DO NK=IPB,IPE
               IF (MSKAF(NK,MK) .GE. ILAND) THEN
               SI(I,J) = AFSNO(NK,MK)
               SI(I,J) = AMAX1(DEPTH,SI(I,J))
               GO TO 4300
               ENDIF
             END DO doin6346
             END DO doout6346
         END DO do7346
C
C   NO LAND MASK MATCH FOUND, SO WE PRINT WARNING AND STAY
C   WITH EARLIER VALUE DETERMINED FROM NESDIS/IMS ANAL, WHICH 
C   WE CONVERT FROM COVER FLAG (0,1) TO DEFAULT DEPTH OF 1.5".
C
          SI(I,J) = DEPTH
          WRITE (IOUTUPRT, 7347) I,J,YYLAT,XLONG,IS,JS,SI(I,J)
 7347      FORMAT(1H ,'*** WARNING ***..NO USAF LAND MSK MATCH ',
     1 ' AT ETA-I,J,ELAT,ELON,USAF-I,J:',2I6,2F7.2,2I3/
     2 1H ,' DEFAULT TO NESDIS VALUE OF ',F5.1,' TIMES .10 M')
C
      ENDIF
C     
C
C******************** END MAJOR ETA GRID POINT LOOP ****************
C
 4300 CONTINUE
         ENDDO
         ENDDO
C
C  PRINT SAMPLE OF SNOW/ICE ON ETA GRID
C
      CALL PRINTETA (SI,SM)
Ctest CALL PRINTYL(SI,SM)

      RETURN

      END

      REAL FUNCTION FRH2O(TKELV,SMC,SH2O,SMCMAX,B,PSIS)

      IMPLICIT NONE

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CC  PURPOSE:  CALCULATE AMOUNT OF SUPERCOOLED LIQUID SOIL WATER CONTENT
CC  IF TEMPERATURE IS BELOW 273.15K (T0).  REQUIRES NEWTON-TYPE ITERATION
CC  TO SOLVE THE NONLINEAR IMPLICIT EQUATION GIVEN IN EQN 17 OF
CC  KOREN ET AL. (1999, JGR, VOL 104(D16), 19569-19585).
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C New version (FEB 2001): much faster and more accurate newton iteration
c achieved by first taking log of eqn cited above -- less than 4
c (typically 1 or 2) iterations achieves convergence.  Also, explicit
c 1-step solution option for special case of parameter Ck=0, which reduces
c the original implicit equation to a simpler explicit form, known as the
c ""Flerchinger Eqn". Improved handling of solution in the limit of
c freezing point temperature T0.
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C INPUT:
C
C   TKELV.........Temperature (Kelvin)
C   SMC...........Total soil moisture content (volumetric)
C   SH2O..........Liquid soil moisture content (volumetric)
C   SMCMAX........Saturation soil moisture content (from REDPRM)
C   B.............Soil type "B" parameter (from REDPRM)
C   PSIS..........Saturated soil matric potential (from REDPRM)
C
C OUTPUT:
C   FRH2O.........supercooled liquid water content.
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      REAL B
      REAL BLIM
      REAL BX
      REAL CK
      REAL DENOM
      REAL DF
      REAL DH2O
      REAL DICE
      REAL DSWL
      REAL ERROR
      REAL FK
      REAL FRH2O
      REAL GS
      REAL HLICE
      REAL PSIS
      REAL SH2O
      REAL SMC
      REAL SMCMAX
      REAL SWL
      REAL SWLK
      REAL TKELV
      REAL T0

      INTEGER NLOG
      INTEGER KCOUNT

      PARAMETER (CK=8.0)
C      PARAMETER (CK=0.0)
      PARAMETER (BLIM=5.5)
C      PARAMETER (BLIM=7.0)
      PARAMETER (ERROR=0.005)

      PARAMETER (HLICE=3.335E5)
      PARAMETER (GS = 9.81)
      PARAMETER (DICE=920.0)
      PARAMETER (DH2O=1000.0)
      PARAMETER (T0=273.15)

C  ###   LIMITS ON PARAMETER B: B < 5.5  (use parameter BLIM)  ####
C  ###   SIMULATIONS SHOWED IF B > 5.5 UNFROZEN WATER CONTENT  ####
C  ###   IS NON-REALISTICALLY HIGH AT VERY LOW TEMPERATURES    ####
C##################################################################
C
      BX = B
      IF ( B .GT. BLIM ) BX = BLIM
C------------------------------------------------------------------

C INITIALIZING ITERATIONS COUNTER AND ITERATIVE SOLUTION FLAG.
      NLOG=0
      KCOUNT=0

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C  IF TEMPERATURE NOT SIGNIFICANTLY BELOW FREEZING (T0), SH2O = SMC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      IF (TKELV .GT. (T0 - 1.E-3)) THEN

        FRH2O=SMC

      ELSE

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
       IF (CK .NE. 0.0) THEN

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCC OPTION 1: ITERATED SOLUTION FOR NONZERO CK CCCCCCCCCCC
CCCCCCCCCCCC IN KOREN ET AL, JGR, 1999, EQN 17 CCCCCCCCCCCCCCCCC
C
C INITIAL GUESS FOR SWL (frozen content)
        SWL = SMC-SH2O
C KEEP WITHIN BOUNDS.
        IF(SWL .GT. (SMC-0.02)) THEN
          SWL=SMC-0.02
c         SWL=MAX(0.,SMC-0.02)
        ENDIF
        IF(SWL .LT. 0.)  THEN
          SWL=0.
        ENDIF
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C  START OF ITERATIONS
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
        DO WHILE (NLOG .LT. 10 .AND. KCOUNT .EQ. 0)
         NLOG = NLOG+1
         DF = ALOG(( PSIS*GS/HLICE ) * ( ( 1.+CK*SWL )**2. ) *
     &        ( SMCMAX/(SMC-SWL) )**BX) - ALOG(-(TKELV-T0)/TKELV)
         DENOM = 2. * CK / ( 1.+CK*SWL ) + BX / ( SMC - SWL )
         SWLK = SWL - DF/DENOM
         DSWL=ABS(SWLK-SWL)
         SWL=SWLK
C KEEP WITHIN BOUNDS.
         IF(SWL .GT. (SMC-0.02)) THEN
           SWL=SMC-0.02
c          SWL=MAX(0.,SMC-0.02)
         ENDIF
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CC IF MORE THAN 10 ITERATIONS, USE EXPLICIT METHOD (CK=0 APPROX.)
CC WHEN DSWL LESS OR EQ. ERROR, NO MORE ITERATIONS REQUIRED.
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
         IF ( DSWL .LE. ERROR )  THEN
           KCOUNT=KCOUNT+1
         END IF
        END DO
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C  END OF ITERATIONS
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C LOWER BOUND FOR SWL (ICE CONTENT)
        IF(SWL .LT. 0.)  THEN
          SWL=0.
        ENDIF
C UPPER BOUND FOR SWL ALREADY APPLIED WITHIN DO-BLOCK
        FRH2O = SMC - SWL
C
CCCCCCCCCCCCCCCCCCCCCCCC END OPTION 1 CCCCCCCCCCCCCCCCCCCCCCCCCCC

       ENDIF

       IF (KCOUNT .EQ. 0) THEN
         Print*,'Flerchinger used. Iterations=',NLOG

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCC OPTION 2: EXPLICIT SOLUTION FOR FLERCHINGER EQ. i.e. CK=0 CCCCCCCC
CCCCCCCCCCCCC IN KOREN ET AL., JGR, 1999, EQN 17  CCCCCCCCCCCCCCC
C
        FK=(((HLICE/(GS*(-PSIS)))*((TKELV-T0)/TKELV))**(-1/BX))*SMCMAX
        IF (FK .LT. 0.02) FK = 0.02
        FRH2O = MIN ( FK, SMC )
C
CCCCCCCCCCCCCCCCCCCCCCCCC END OPTION 2 CCCCCCCCCCCCCCCCCCCCCCCCCC

       ENDIF

      ENDIF

      RETURN
      END 

      subroutine eta_interp(nnn)
c
      implicit none

      include 'ecommons.h'
c
      integer*4 nxin,nyin,nzin
     .         ,jday,idat(5)
     .         ,i,l,n,ll,NN,nsfcfld,j,nnn
c
	integer gds(200)
C
      real,allocatable:: htin(:,:,:)
     .      ,mrin(:,:,:),uwin(:,:,:),vwin(:,:,:),sfcgrid(:,:,:)

	real prin(nzin),dtr
c
      real*4 hthi(im,jm,nzin)
     .      ,mrhi(im,jm,nzin)
     .      ,uwhi(im,jm,nzin)
     .      ,vwhi(im,jm,nzin)
     .	    ,sfcgridhi(im,jm,12),qmn,qmx

C	real coh(3,im,jm),inh(4,im,jm),jnh(4,im,jm)
C     &,cov(3,im,jm),inv(4,im,jm),jnv(4,im,jm)
C     &,ald(im,jm),apd(im,jm),hgt(im,jm),sm(im,jm)

	real,allocatable:: hgt(:,:)
	real sm(im,jm)

        integer k

	parameter(dtr=.017453293)
c
      character*2 gproj

CDANIEL
      logical moistdan
      real,allocatable:: nsmoist(:,:)     
      real prop1,prop2,prop3,prop4      
      
c
      logical first
      data first/.true./
c
      common /sectorsize/nxin,nyin,nzin

CDANIEL
      namelist/DANMOIST/moistdan
      namelist/DANPROP/prop1,prop2,prop3,prop4
      
c
      save idat
c_______________________________________________________________________________
c
      print*, imjm,nzin,im,jm

CDANIEL
	write(6,*) 'lendo SOILMOIST '
      open(1,file='SOILMOIST',form='formatted',status='old')
      read(1,DANMOIST)
      close(1)
	write(6,*) 'leu SOILMOIST '

c
c *** Get time increment for boundary conditions.
c
      if (first) then
         idat(5)=-nint(tboco)
         first=.false.
c        print *,'first:',idat(5)
      endif
c
c *** Fill date stamps.
c        idat(1) = month
c        idat(2) = day
c        idat(3) = year
c        idat(4) = start time (UTC)
c        idat(5) = fcst hour
c
      idat(1)=imonth
      idat(2)=idate
      idat(3)=iyear
      idat(4)=istrtim
      idat(5)=idat(5)+nint(tboco)
c
c *** Read in input upper air gridded data set.
c
	ALLOCATE(HTIN(NXIN,NYIN,NZIN))
	ALLOCATE(UWIN(NXIN,NYIN,NZIN))
	ALLOCATE(VWIN(NXIN,NYIN,NZIN))
	ALLOCATE(MRIN(NXIN,NYIN,NZIN))
	ALLOCATE(SFCGRID(NXIN,NYIN,12))
      call getdata(init_in(nnn),prin,uwin,vwin,htin,mrin,sfcgrid)

C	write(6,*) 'Q after getdata'
	do L=1,NZIN
	qmn=99999.
	qmx=-99999.
	DO J=1,NYIN
	do I=1,NXIN
	if (mrin(i,j,l) .gt. qmx) qmx=mrin(i,j,l)
	if (mrin(i,j,l) .lt. qmn) qmn=mrin(i,j,l)
	enddo
	enddo
C	write(6,*) 'raw mrin extremes: ', L,qmn,qmx
	enddo
	
Chou print 
	 open(unit=3,file='avnin.dat',form='unformatted',
     &        access='sequential')
	do k=nzin,1,-1
	write(3) ((htin(i,j,k),i=1,nxin),j=1,nyin) 
	enddo
	do k=nzin,1,-1
	write(3) ((uwin(i,j,k),i=1,nxin),j=1,nyin) 
	enddo
	do k=nzin,1,-1
	write(3) ((vwin(i,j,k),i=1,nxin),j=1,nyin) 
	enddo
	do k=nzin,1,-1
	write(3) ((mrin(i,j,k),i=1,nxin),j=1,nyin) 
	enddo
	do k=12,1,-1
	write(3) ((sfcgrid(i,j,k),i=1,nxin),j=1,nyin) 
	enddo

C	write(6,*) 'back from getdata, prin(20) ', prin(20)
C	write(6,*) 'some ht vals ', htin(50,50,20)
c
c *** Horizontally interpolate input data from native grid to ETA grid.
c
	n=index(init_gdsdir,' ')-1

	write(6,*) 'trying to open ', init_gdsdir(1:n)

	open(unit=14,file=init_gdsdir(1:n),form='unformatted',
     +	access='sequential')
	rewind 14

	read(14) GDS

	write(6,*) 'gds(1-14): ', (gds(I),I=1,14)


	call hinterp(htin,gproj,hthi,nzin,1,gds)
	DEALLOCATE(HTIN)
	call hinterp(mrin,gproj,mrhi,nzin,2,gds)
	DEALLOCATE(MRIN)
Cmp
      do J=1,nzin
C      write(6,*) 'J,mrhi(16,53,J): ', J,mrhi(16,53,J)
      enddo
Cmp

	
	write(6,*) 'calling wind interp'
	call hinterp_wind(uwin,vwin,gproj,uwhi,vwhi,nzin,5,gds)
	DEALLOCATE(UWIN)
	DEALLOCATE(VWIN)


	call hinterp(sfcgrid,gproj,sfcgridhi,12,6,gds)

C
	ALLOCATE(HGT(IM,JM))
      open(1,file=topo_out,status='old',form='unformatted')
      rewind(1)
      read(1) hgt,sm
      close(1)
	DEALLOCATE(HGT)
C

	if (.not. REAN .and. GRIBSOIL .and. idat(5) .eq. 0) then
	write(6,*) 'calling coastal!!!!!!!'
	call coastalfix(sfcgridhi,sfcgrid,sm,im,jm,nxin,nyin,dphd,dlmd,
     +		wbd,sbd,tph0d,tlm0d,gds)
	write(6,*) 'return coastal'
	endif
	
CDANIEL
       if (moistdan) then
	write(6,*) 'lendo MOISTPROP '
        open(1,file='MOISTPROP',form='formatted',status='old')
        read(1,DANPROP)
        close(1)
	write(6,*) 'liu MOISTPROP '
        allocate(nsmoist(im,jm))
	rewind(48)
	read(48)nsmoist
c	read(21,*)por1,por2,por3,por4
        open(75, file='moistdan.asc', status='unknown')
	do J=jm,1,-1
	write(75,430) (nsmoist(I,J),I=1,im,1)
430	format(100(f10.4,x))
	enddo
        close(75)
       	write(6,*) 'writing soil moist'
	do j=1,jm
		do I=1,im
			sfcgridhi(i,j,6)=nsmoist(i,j)*prop1
			sfcgridhi(i,j,8)=nsmoist(i,j)*prop2
			sfcgridhi(i,j,10)=nsmoist(i,j)*prop3
			sfcgridhi(i,j,12)=nsmoist(i,j)*prop4
		enddo
	enddo
        open(75, file='moistdan_sfc.asc', status='unknown')
	do J=jm,1,-1
	write(75,430) (sfcgridhi(I,J,6),I=1,im,1)
431	format(100(f10.4,x))
	enddo
        close(75)
	write(6,*) 'read new soil moisture'
       endif
       	
	DEALLOCATE(SFCGRID)

c
c *** Vertically interpolate input data from native grid to ETA grid.
c *** And write output files.
c

	if (SIGMA) then
      call pusi   (prin,hthi,mrhi,uwhi,vwhi,sfcgridhi,nzin,idat)
	else
      call vinterp(prin,hthi,mrhi,uwhi,vwhi,sfcgridhi,nzin,idat)
	endif
c
      return
      end


C ********************* END MAIN ROUTINE ************************************
C
C
	subroutine hinterp(fieldin,gproj,fieldint,nzmax,mark,gds)
c
      implicit none
c
      include 'ecommons.h'
c
c *** Input data on native grid.
c
      integer*4 nxsec,nysec,nzsec,mark,L,nzmax,n
c
      real*4 fieldin(nxsec,nysec,nzsec)
c
c *** Input data on horizontal eta grid, native vertical grid.
c
      real*4 fieldint(im,jm,nzsec)

	REAL,ALLOCATABLE:: tmpout(:,:),tmp(:,:)
c
      real*4 coh(3,im,jm),inh(4,im,jm),jnh(4,im,jm)     
     .      ,cov(3,im,jm),inv(4,im,jm),jnv(4,im,jm)
     .      ,ald(im,jm),apd(im,jm)

      integer i,j,k
	integer GDS(200)
      character*2 gproj
c
      common /sectorsize/nxsec,nysec,nzsec
c
      print *,'Horizontally interpolate data to ETA grid.... ', mark
c
	if (gds(1) .eq. 3) gproj='LC'
	if (gds(1) .eq. 5) gproj='PS'
	if (gds(1) .eq. 0) gproj='LL'

	write(6,*) 'calling with gproj= ', gproj

      call gtll(coh,inh,jnh,cov,inv,jnv,ald,apd,nxsec,nysec,gproj,gds)
c
c *** Horizontally interpolate input data (ht, mr, u, and v) to ETA grid 
c        using bilinear interpolation.
c

	DO L=1,nzmax

	ALLOCATE (TMP(NXSEC,NYSEC))

	do j=1,nysec
	do I=1,nxsec
	tmp(i,J)=fieldin(i,j,l)
	enddo
	enddo

	ALLOCATE (TMPOUT(IM,JM))
	if (mark .ne. 4 .and. mark .ne. 5) then
        	call bilinb(coh,inh,jnh,im,jm,nxsec,nysec,tmp,tmpout) 
	else
C		write(6,*) 'interpolating winds '
		call bilinb(cov,inv,jnv,im,jm,nxsec,nysec,tmp,tmpout)
	endif

	DEALLOCATE(TMP)

	do j=1,jm
        do I=1,im
        fieldint(i,j,l)=tmpout(i,j)
        enddo
        enddo
	
	DEALLOCATE(TMPOUT)

	ENDDO
c
c *** Check that mixing ratio is not less than zero.
c
	if (mark .eq. 2) then
	write(6,*) 'checking mixing ratio for neg values'
        do k=1,nzsec
	do j=1,jm
        do i=1,im
         fieldint(i,j,k)=max(0.,fieldint(i,j,k))
        enddo
        enddo
	enddo
	endif
c 
      return
      end
c
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
	subroutine hinterp_wind(uin,vin,gproj,uint,vint,nzmax,mark,gds)
c
      implicit none
c
      include 'ecommons.h'
c
c *** Input data on native grid.
c
      integer*4 nxsec,nysec,nzsec,mark,L,nzmax,n
c
      real*4 uin(nxsec,nysec,nzsec),vin(nxsec,nysec,nzsec)
c
c *** Input data on horizontal eta grid, native vertical grid.
c
      real*4 uint(im,jm,nzsec),vint(im,jm,nzsec)

	REAL,ALLOCATABLE:: utmpout(:,:),utmp(:,:),utmpout1(:,:)
	REAL,ALLOCATABLE:: vtmpout(:,:),vtmp(:,:),vtmpout1(:,:)
c
      real*4 coh(3,im,jm),inh(4,im,jm),jnh(4,im,jm)     
     .      ,cov(3,im,jm),inv(4,im,jm),jnv(4,im,jm)
     .      ,ald(im,jm),apd(im,jm),dtr

	parameter(dtr=.017453293)

      integer i,j,k
	integer GDS(200)
      character*2 gproj
c
      common /sectorsize/nxsec,nysec,nzsec
c
      print *,'Horizontally interpolate wind data to ETA grid.... '
c
	if (gds(1) .eq. 3) gproj='LC'
	if (gds(1) .eq. 5) gproj='PS'
	if (gds(1) .eq. 0) gproj='LL'

	write(6,*) 'calling with gproj= ', gproj

      call gtll(coh,inh,jnh,cov,inv,jnv,ald,apd,nxsec,nysec,gproj,gds)
c
c *** Horizontally interpolate input data (ht, mr, u, and v) to ETA grid 
c        using bilinear interpolation.
c

	DO L=1,nzmax

	ALLOCATE (UTMP(NXSEC,NYSEC))
	ALLOCATE (VTMP(NXSEC,NYSEC))

Cold	DO N=1,2

	do j=1,nysec
	do I=1,nxsec
	utmp(i,j)=uin(i,j,l)
	vtmp(i,j)=vin(i,j,l)
	enddo
	enddo

	ALLOCATE (UTMPOUT(IM,JM))
	ALLOCATE (VTMPOUT(IM,JM))
	ALLOCATE (UTMPOUT1(IM,JM))
	ALLOCATE (VTMPOUT1(IM,JM))
        
		call bilinb(cov,inv,jnv,im,jm,nxsec,nysec,utmp,utmpout)
		call bilinb(cov,inv,jnv,im,jm,nxsec,nysec,vtmp,vtmpout)

	DEALLOCATE(UTMP)
	DEALLOCATE(VTMP)

	 call ltlwin(ald,apd,utmpout,vtmpout,dtr,utmpout1,vtmpout1)

	do j=1,jm
        do I=1,im
	  uint(i,j,l)=utmpout1(i,j)
	  vint(i,j,l)=vtmpout1(i,j)
        enddo
        enddo

Cold	ENDDO

	DEALLOCATE(UTMPOUT)
	DEALLOCATE(VTMPOUT)
	DEALLOCATE(UTMPOUT1)
	DEALLOCATE(VTMPOUT1)

	ENDDO
c
        return
	end

c==========================================================================
C
      subroutine vinterp(spl,h,q,u,v,sfcgrid,ldm,idat)
c
c *** Code to vertically interpolate gridded init data from
c        native vertical grid to ETA vertical grid.
c
c *** Original code received from the U. of Athens and modfied at FSL.
c
c *** Setting up of the vertical grid variables, and              
c     vertical interpolation, pressure to eta surfaces           
c     Fedor Mesinger                                            
c
      implicit none
c
      include 'ecommons.h'
      include 'econstants.h'
c
C	integer imxjm
      real*4 a2,a3,a4,pq0
      parameter (a2=17.2693882E0,a3=273.16E0,a4=35.86E0
     .          ,pq0=379.90516)
C
C	parameter(imxjm=im*jm)

      integer*4 ldm,negsum,ll,NN
c

C	ldm
	REAL H(IM,JM,LDM),U(IM,JM,LDM),V(IM,JM,LDM),Q(IM,JM,LDM)

C	lm
	REAL, ALLOCATABLE:: HETA(:,:,:),QETA(:,:,:),UETA(:,:,:)
	REAL, ALLOCATABLE:: VETA(:,:,:),TETA(:,:,:),PDVP(:,:),PHIS(:,:)

	REAL, ALLOCATABLE:: HGT(:,:),SM(:,:),PD(:,:)

      real*4 
     .      ext(lm,2)
     .      ,hetaij
     .      ,sfcgrid(im,jm,12)

	
      real   uetaij(lm),vetaij(lm)
     .      ,href(ldm),eta(lmp1),peta(lmp1)
     .      ,pdb(kb,2),tb(kb,lm,2),ub(kb,lm,2),vb(kb,lm,2)
     .      ,qb(kb,lm,2)
     .      ,etal(lm),zeta(lmp1),ref(im,jm)
     .      ,hfp(2,2),hfpa(im,jm),hrsd(im,jm),dz(im,jm)
     .      ,etas(im,jm),wm(im,jm)
     .      ,seta(4),deta(lm),dum(lm)
     .      ,alpq,bq
     .      ,q3,q3m1,q3m2,hldm,cq,rheta,tresh
     .      ,tetam,cf,uld,vld,qseta,tetamax
     .      ,phub,phlb,q1,q2b,prfs,tmj2,gorg,rgog
     .      ,pt,dpd,dpu,x,h1b,h2,h3,rspl,splm,gfac,alpt
     .	    ,t1,t2,t3,t3m1,t3m2,bt,ct,zdif,adjfac,tsavetmp,
     .		ukb,vkb

Cmp
	real(8) alpeta,alpetai(im,jm), alp(ldm), alpr(ldm+1),alpsq(ldm)
	real(8) dlt(lm),alpub,alplb,b,c,alpgt,h3m1,h3m2,alpetk
c
      integer*4 lhgt(im,jm),lnew(im,jm),ldt1(lm),ldum(lm)
     .         ,idat(5),lmin(im,jm)
     .         ,mi2,ip1,jp1,jm1b,ldm1,ivi
     .         ,is,js,if,jf,l1,l2,l3,ldmm1,nk
     .         ,kt
     .         ,lnbmx,lmnn,lmne,lmns,lmnw,ld,lij,lrais
     .         ,mmx,ntsd,i,j,l,m,n,ihw(jm),ihe(jm),ivw(jm),ive(jm)
     .	       ,ivl,ivh,ihl,ihh,mnknt,idxx(im*jm),jdxx(im*jm),numk
     .	       ,kntx,idx(im*jm),jdx(im*jm),kntin,kp1
c
      character*3 fname
c
      logical wndls,hmask(im,jm),vmask(im,jm),run
c
      real*4 pdmin,pdmax, spl(ldm)

c_______________________________________________________________________________
c
      print *,'Vertically interpolate data to ETA grid.'
	write(6,*) 'input levels, output levels', LDM,LM
	negsum=0
      ldmm1=ldm-1
      tresh=0.95
c
      kt=idat(5)

Cmp
	pt=ptinp
Cmp
	write(6,*) 'in interp....pt= ', pt
	write(6,*) 'in interp....ptinp= ', ptinp
Czj
!-------------indirect indices for tom's set-up-------------------------
          do j=1,jm
      ihw(j)=-1+mod(j+1,2)
      ihe(j)=ihw(j)+1
      ivw(j)=-1+mod(j,2)
      ive(j)=ivw(j)+1
          enddo
!----------------------------------------------------------------------
Czj
c
c-----------------------------------------------------------------------
c     print=.true.
c        mountains to be four-point ('regular' or 'silhouette')
c        averaged, so as to have the same ground topography at groups
c        of four neighboring height points, or not four-point averaged
      fpmnts=.false.
c     siluet=.true.
c        hour00 fields to be created for a sigma mode/not a sigma mode
c        experiment
c     sigma=.false.
c        if a sigma mode experiment, mountains to be removed 6 grids
c        lines along the boundary/not to be removed
c     mrmsxl=.false.
cda      mrmsxl=.not.sigma
c        no mountains experiment/not a no mountains experiment
c     nomnts=.false.
c
c *** Define some constants needed for vertical interpolation.
c
      gorg=g/(r*gamma)
      rgog=r*gamma/g
      alpt=alog(pt)

c------- eta at the interfaces of the model layers ------------------

C	read in Eta levels from file

	open(unit=16,file='deta',form='unformatted',access=
     +				'sequential')

	REWIND 16
	READ(16)DETA,LDUM
        eta(1)=0.0

Cmp	DO N=1,LM-1
	DO N=1,LM
	ETA(N+1)=ETA(N)+DETA(N)
C       write(6,*) 'DETA,ETA ', DETA(N),ETA(N+1)
	ENDDO

      eta(lmp1)=1.0
c
c *** Compute ldt1.
c
      do l=1,lm
         i=1
         peta(l)=(prf0-pt)*eta(l)+pt
Cnew
C	write(6,*) 'peta(l), spl(i), i ', peta(l),spl(i),i
         do while (peta(l) .ge. spl(i) .and. i .lt. ldm)
            peta(l)=(prf0-pt)*eta(l)+pt
            i=i+1
         enddo
c
         if (i .le. 2) then
            ldt1(l)=1
         elseif (i .eq. ldm) then
            ldt1(l)=ldm-2
         else
            dpu=abs(spl(i-2)-peta(l))
            dpd=abs(spl(i+1)-peta(l))
            if (dpu .gt. dpd) then
               ldt1(l)=i-1
            else
               ldt1(l)=i-2
            endif
         endif
      enddo
c
c *** Compute half eta values.
c
      do l=1,lm
         etal(l)=0.5*(eta(l)+eta(l+1))
      enddo
c
c *** Compute eta level heights.
c
	write(6,*) 'lowest zeta values'
      do l=1,lmp1
         zeta(l)=t0*(1.-((pt+eta(l)*(prf0-pt))/prf0)**rgog)/gamma
	if (l .ge. lmp1-10) then
	write(6,*) 'zeta(l)... ', l, zeta(l)
	endif
      enddo
c
c *** Read topo heights and sea masks.
C
C     This version expects hgt, sm to be (im,jm) and NOT (imt,jmt)
C	make sure etatopo.f handles this properly!!!!
C
	ALLOCATE(HGT(IM,JM))
	ALLOCATE(SM(IM,JM))
      open(1,file=topo_out,status='old',form='unformatted')
      rewind(1)
      read(1) hgt,sm
      close(1)


c *** Zero out heights, if no mountains option has been selected.
c
C      if (nomnts) then
C         do j=1,jm
C         do i=1,im
C            if (hgt(i,j).gt.0.) hgt(i,j)=0.004
C            ref(i,j)=1.
C         enddo
C         enddo
C         goto 922
C      endif

 702  if (sigma .and. .not. fpmnts) goto 922
c
      do 902 j=1,jm
      do 902 i=1,im
         prfs=prf0*((t0-gamma*hgt(i,j))/t0)**gorg
         etas(i,j)=(prfs-pt)/(prf0-pt)
C
C
Cmp	through this point hgt represents the unchanged raw hgt value
C
         do 903 ivi=1,lm
            l=lmp1-ivi
            if (etas(i,j).lt.eta(l)) goto 903
cvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
            if (etas(i,j).lt.etal(l)) then
c           if (etas(i,j).lt.0.10*(9.*etal(l)+eta(l-1))) then
caaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa
               ref (i,j)= eta(l)
               hgt (i,j)=zeta(l)
               lhgt(i,j)=     l
            else
               ref (i,j)=eta(l+1)
               if (l+1 .eq. lmp1 .and. hgt(i,j) .gt. 0.) then
                  hgt(i,j)=0.004
               else
                  hgt(i,j)=zeta(l+1)
               endif
               lhgt(i,j)=    l+1
            endif
C            print*,"JLG1",ref(i,j), eta(l),hgt(i,j),i,j,l
c
            goto 902
 903     continue
 902  continue
c
c
 922  continue
c
c     if(.not.fpmnts):
c     find points having no neighboring wind point because of mountains
c     on all four sides (sunken points), and
c     *  if land, just raise to reach the lowest wind;
c     *  if an isolated water point, or a water point with only one
c          neighboring water point and at sea level: raise, and declare
c          land (in order not to trigger convection over artificially
c          elevated warm water);
c     *  otherwise:
c          remove (level off) land at one of the four neighboring wind
c          points -- the one having the smallest three-point averaged
c          elevation -- so as to restore one of the wind points
c
c     n.b.: i am in the "old" i,j indexing, with i being incremented
c     in each column
c
      if (.not. fpmnts) then
c
c     Save first the sea mask, sm, into a back-up mask ("water mask",
c     wm) to use in testing the neighbors, since sm will be changed
c     along the way; and initialize lmin, level beyond which points
c     should not be raised because they have participated in leveling
c     off at that level, and lnew
c
         do j=1,jm
         do i=1,im
            wm  (i,j)=sm  (i,j)
            lmin(i,j)=2
            lnew(i,j)=lhgt(i,j)
         enddo
         enddo
c
Cold         do i=4,imm3
	do j=4,jm-3
	ihl=2+mod(j,2)
        ihh=im-2

          do i=ihl,ihh

c
c ************ Find the maximum elevation (minimum l) of four neighboring wind
c              points -- to the west, east, south and north
c
      lmnw=min(lhgt(i+ihw(j),j-1),lhgt(i-1,j),lhgt(i+ihw(j),j+1))
      lmne=min(lhgt(i+ihe(j),j-1),lhgt(i+1,j),lhgt(i+ihe(j),j+1))
      lmns=min(lhgt(i,j-2),lhgt(i+ihw(j),j-1),lhgt(i+ihe(j),j-1))
      lmnn=min(lhgt(i+ihw(j),j+1),lhgt(i+ihe(j),j+1),lhgt(i,j+2))
c
c ************ Which one is the lowest of the four maximum elevations?
c
               lnbmx=max(lmnw,lmne,lmns,lmnn)
c
c ************ Is the point's original elevation below that of the lowest
c              available original wind, and, at the same time, in case it
c              participated in leveling off is it still below the level of the
c              lowest wind created by leveling off?
c
               if (lhgt(i,j) .gt. lnbmx .and. 
     .             ref(i,j) .gt. eta(lmin(i,j))) then
                  lrais=max0(lnbmx,lmin(i,j))
                  if (sm(i,j) .eq. 0.) then
                     ref (i,j)= eta(lrais)
                     hgt (i,j)=zeta(lrais)
                     lnew(i,j)=     lrais
c
             else if(wm(i+ihw(j),j-1)+wm(i+ihe(j),j-1)
     &               +wm(i+ihw(j),j+1)+wm(i+ihe(j),j+1).eq.0..or.
     &                wm(i+ihw(j),j-1)+wm(i+ihe(j),j-1)
     &               +wm(i+ihw(j),j+1)+wm(i+ihe(j),j+1).eq.1..and.
     &                  lhgt(i,j).eq.lm+1) then

                     ref (i,j)= eta(lrais)
                     hgt (i,j)=zeta(lrais)
                     lnew(i,j)=     lrais
c
                  else
c
c *************** There is a neighboring water point, and if it is only a
c                 single neighboring water point the water points are above sea
c                 level.  denote wind points to the east, north, west
c                 and south by 1, 2, 3, and 4, respectively, and check the
c                 three-point volume at each of them.
c
      seta(1)=etas(i+ihe(j),j-1)+etas(i+1,j)+etas(i+ihe(j),j+1)
      seta(2)=etas(i+ihw(j),j+1)+etas(i+ihe(j),j+1)+etas(i,j+2)
      seta(3)=etas(i+ihw(j),j-1)+etas(i-1,j)+etas(i+ihw(j),j+1)
      seta(4)=etas(i,j-2)+etas(i+ihw(j),j-1)+etas(i+ihe(j),j-1)
c
                     mmx=1
                     do m=2,4
                        if(seta(m) .gt. seta(mmx)) mmx=m
                     enddo
c
c ****************** n.b.: When removing now the obstructing land around the 
c                    wind point vm, lhgt is not changed.  Thus, hopefully (?) 
c                    resulting topography does not depend on the direction of 
c                    the sweep within the current loop.
c
                     lij=lhgt(i,j)
                     if (mmx .eq. 1 .or. mmx .eq. 4) then
             		if(ref(i+ihe(j),j-1).lt.eta(lij)) then
             			ref(i+ihe(j),j-1)=eta(lij)
             			hgt(i+ihe(j),j-1)=zeta(lij)
             			lnew(i+ihe(j),j-1)=lij
		     	endif
         		lmin(i+ihe(j),j-1)=max(lmin(i+ihe(j),j-1),lij)
                     endif
c
                     if (mmx .eq. 1) then
                        if (ref(i+1,j) .lt. eta(lij)) then
                           ref(i+1,j    )=   eta(lij)
                           hgt(i+1,j    )=  zeta(lij)
                           lnew(i+1,j    )=       lij
                        endif
                        lmin(i+1,j)=max(lmin(i+1,j),lij)
                     endif
c
                      if (mmx .eq. 1 .or. mmx .eq. 2) then
       	              if(ref(i+ihe(j),j+1).lt.eta(lij)) then
       			       ref(i+ihe(j),j+1)=eta(lij)
              		       hgt(i+ihe(j),j+1)=zeta(lij)
              	               lnew(i+ihe(j),j+1)=lij
                      endif
          	      lmin(i+ihe(j),j+1)=max(lmin(i+ihe(j),j+1),lij)
                      endif
c
                     if (mmx .eq. 2) then
                        if (ref(i,j+1) .lt. eta(lij)) then
                           ref(i  ,j+2  )=   eta(lij)
                           hgt(i  ,j+2  )=  zeta(lij)
                          lnew(i  ,j+2  )=       lij
                        endif
                        lmin(i,j+2)=max(lmin(i,j+2),lij)
                     endif
c
                     if (mmx .eq. 2 .or. mmx .eq. 3) then
                 	if(ref(i+ihw(j),j+1).lt.eta(lij)) then
             		  ref(i+ihw(j),j+1)=eta(lij)
              		  hgt(i+ihw(j),j+1)=zeta(lij)
              		  lnew(i+ihw(j),j+1)=lij
                  	endif
          		lmin(i+ihw(j),j+1)=max(lmin(i+ihw(j),j+1),lij)
                     endif
c
                     if (mmx .eq. 3) then
                        if (ref(i-1,j) .lt. eta(lij)) then
                           ref(i-1,j)=   eta(lij)
                           hgt(i-1,j)=  zeta(lij)
                           lnew(i-1,j)=       lij
                        endif
                        lmin(i-1,j)=max(lmin(i-1,j),lij)
                     endif
c
                     if (mmx .eq. 3 .or. mmx .eq. 4) then
                 if(ref(i+ihw(j),j-1).lt.eta(lij)) then
              ref(i+ihw(j),j-1)=eta(lij)
              hgt(i+ihw(j),j-1)=zeta(lij)
              lnew(i+ihw(j),j-1)=lij
                        endif
          lmin(i+ihw(j),j-1)=max(lmin(i+ihw(j),j-1),lij)
                     endif
c
                     if (mmx .eq. 4) then
                  if(ref(i,j-2).lt.eta(lij)) then
              ref(i,j-2)=eta(lij)
              hgt(i,j-2)=zeta(lij)
              lnew(i,j-2)=lij
                  endif
          lmin(i,j-2)=max(lmin(i,j-2),lij)
                     endif
c
                  endif
               endif
            enddo
         enddo
c
c ****** Any windless points left or inadvertently created?
c
         wndls=.false.
	do j=4,jm-3
          ihl=2+mod(j,2)
          ihh=im-2
!
          do i=ihl,ihh
!

c ************ Find the maximum elevation (minimum l) of four neighboring wind
c              points -- to the west, east, south and north
c
      lmnw=min(lnew(i+ihw(j),j-1),lnew(i-1,j),lnew(i+ihw(j),j+1))
      lmne=min(lnew(i+ihe(j),j-1),lnew(i+1,j),lnew(i+ihe(j),j+1))
      lmns=min(lnew(i,j-2),lnew(i+ihw(j),j-1),lnew(i+ihe(j),j-1))
      lmnn=min(lnew(i+ihw(j),j+1),lnew(i+ihe(j),j+1),lnew(i,j+2))
c
c ************ Which one is the lowest of the four maximum elevations?
c
               lnbmx=max(lmnw,lmne,lmns,lmnn)
c
c ************ Is the point's new elevation below that of the lowest available
c              new wind?
c
               if (lnew(i,j) .gt. lnbmx) wndls=.true.
            enddo
         enddo
c
      endif
c
      if (sigma) then
         do j=1,jm
         do i=1,im
            ref(i,j)=1.
         enddo
         enddo
      endif
c
c *** Masks.
      do j=1,jm
      do i=1,im
         hmask(i,j)=.false.
         vmask(i,j)=.false.
      enddo
      enddo
!-----------------------------------------------------------------------
      do i=1,im
         hmask(i,1)=.true.
         hmask(i,jm)=.true.
      enddo
      do j=1,jm,2
         hmask(1,j)=.true.
         hmask(im,j)=.true.
      enddo
!-----------------------------------------------------------------------
      do i=1,im
         vmask(i,1)=.true.
         vmask(i,jm)=.true.
      enddo
      do j=2,jm-1,2
         vmask(1,j)=.true.
         vmask(im,j)=.true.
      enddo
!-----------------------------------------------------------------------
c
c *** Vertical interpolation: quadratic interpolation of
c        heights (equivalent to temperature being linear in ln p)
c        and linear interpolation of winds.
c
c *** Computation of the 'sea level' pressure difference.
c
      splm=spl(ldm)
      rspl=splm/spl(ldmm1)
      do ld=1,ldmm1
         alpr(ld)=alog(spl(ld+1)/spl(ld))
      enddo

      do ld=1,ldm
Cmp	ln of preset pressure levels
         alp(ld)=alog(spl(ld))
         alpsq(ld)=alp(ld)**2
      enddo

      do l=1,lm
         l1=ldt1(l)
Cmakesworse    dlt(l)=alpr(l1+1)*alog(spl(l1+2)/spl(l1))*(-alpr(l1))
         dlt(l)=alpr(l1+1)*(alp(l1+2)-alp(l1))*(-alpr(l1))
      enddo
c

Cmp *************** START FIRST SET OF LOOPS ********************

	ALLOCATE(PD(IM,JM))

	do j=1,jm
      do i=1,im

Cmp	approach started 2/5/99....use lhgt to only use the closest
Cmp	to ground surface data...not subground data

C            l=lm   
	    l=min(lm,lhgt(i,j))

            l1=ldt1(l)
            l2=l1+1
            l3=l1+2
            h1b=h(i,j,l1)
            h2 =h(i,j,l2)
            h3 =h(i,j,l3)

            h3m2=h3-h2
            h3m1=h3-h1b
csd
Cmp reinstate
Cremove            if (kt .eq. 0 .or. hmask(i,j)) then
csd
               b=(h3m2*(alpsq(l3)-alpsq(l1))
     .           -h3m1*(alpsq(l3)-alpsq(l2)))/dlt(l)
               c=(h3m1*(alp(l3)-alp(l2))
     .           -h3m2*(alp(l3)-alp(l1)))/dlt(l)


cdule          if (abs(c) .lt .0.00001) goto 532
               if (abs(c) .lt. 0.1) then
		write(6,*) 'small abs(c).... ', i,j,c
		 goto 532
		endif
Cmp
        if (b**2-4.*c*(-c*alpsq(l3)-b*alp(l3)+h3-hgt(i,j)).lt.0) then
	negsum=negsum+1
	goto 532
	endif

               alpgt=(-b-sqrt(b**2-4.*c
     .              *(-c*alpsq(l3)-b*alp(l3)+h3-hgt(i,j))))/(2.*c)
		
C	pd for "normal" points

Cmp	want to save the pd value to an array so have when do rest
Cmp	of calculations below

	pd(i,j)=(exp(alpgt)-pt)/ref(i,j)
C        Print*,"JLG0",pd(i,j),pt,ref(i,j),alpgt

               goto 533
  532          hldm=h(i,j,ldm)

Cmp vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
               pd(i,j)=(splm*rspl**((hldm-hgt(i,j))
     .              /(h(i,j,ldmm1)-hldm))-pt)
     .              /ref(i,j)

Cmp ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

	write(6,*) 'special case.... ', i,j,pd(i,j)
	write(6,969) hldm,hgt(i,j),h(i,j,ldmm1),ref(i,j)
  969	format(' hldm,hgt,h,ref ',3(f8.2,x),f7.5)
	write(6,*) '.........................................'

Cmp *** when pd(i,j) is large, alpeta is larger than normal
Cmp ***	then when take differences with alp() and alpsq() which are functions
Cmp *** of the input data set pressure levels get values of hetaij which do
Cmp *** not match well with surrounding regions

  533          continue 
Cmp	if (i .ge. IM-1) write(6,*) 'i,j,pd,ref ', i,j,pd(i,j),ref(i,j)
Cmp	reinstate
Cremove	endif
         enddo
      enddo

C*************************************************************
C	NEW STUFF                 ****************************
C*************************************************************

	ALLOCATE(HETA(IM,JM,LM))
	ALLOCATE(QETA(IM,JM,LM))

	do l=lm,1,-1
         do j=1,jm
      do i=1,im

            l1=ldt1(l)
Cmp
C	if (l1 .eq. ldm-2)  then
C	write(6,*) 'changing L1!!!!!!'
C	l1=l1-1
C	endif
Cmp
            l2=l1+1
            l3=l1+2
            h1b=h(i,j,l1)
            h2 =h(i,j,l2)
            h3 =h(i,j,l3)

Cmp
	if (I .eq. 51 .and. J .eq. 15) then
C	do LL=1,ldm
C	write(6,*) 'L1, input Z ',L1,h1b,h2,h3
C	enddo
	endif
Cmp

            h3m2=h3-h2
            h3m1=h3-h1b

Cremove       if (kt .eq. 0 .or. hmask(i,j)) then

               b=(h3m2*(alpsq(l3)-alpsq(l1))
     .           -h3m1*(alpsq(l3)-alpsq(l2)))/dlt(l)
               c=(h3m1*(alp(l3)-alp(l2))
     .           -h3m2*(alp(l3)-alp(l1)))/dlt(l)

c ************ Computation of heights at upper boundaries of eta layers.
c
               q1 =q(i,j,l1)
               q2b=q(i,j,l2)
               q3 =q(i,j,l3)
               q3m2=q3-q2b
               q3m1=q3-q1

               bq=(q3m2*(alpsq(l3)-alpsq(l1))
     .            -q3m1*(alpsq(l3)-alpsq(l2)))/dlt(l)
               cq=(q3m1*(alp(l3)-alp(l2))
     .            -q3m2*(alp(l3)-alp(l1)))/dlt(l)


C              alpeta=alog(pt+pd(i,j)*eta(l))
              alpeta=alog(pt+pd(i,j)*eta(l))
             alpq=alog(pt+pd(i,j)*(eta(l)+0.5*deta(l)))
         hetaij=h2+b*(alpeta-alp(l2))+c*(alpeta**2-alpsq(l2))

Ctest	heta(i,j,l)=amax1(hetaij,0.01)
	heta(i,j,l)=hetaij
         qeta(i,j,l) = q2b+bq*(alpq-alp(l2)) +cq*(alpq**2-alpsq(l2))

        if (heta(i,j,l) .lt. -120)  then
C      write(6,*) 'NEG heta:', i,j,l,heta(i,j,l),h1b,h2,h3,pt+pd(i,j)
C      write(6,611) alpeta, alp(l2), b, c
C      write(6,*) '---------------------------------------------'
	endif

Cremove        endif

	enddo
	enddo
	enddo
Cmp
C       write(6,*) 'Q values after vinterp: '
 
       do J=1,LM
C       write(6,*) 'J,Q(16,53,J): ', J,QETA(16,53,J)
       enddo
Cmp

  611	format('alpeta, alp(l2), b, c ',4(f14.6,1x))

C	STOP

C ****************************************************************
C****************** end of new stuff *****************************
C*****************************************************************

	pdmax=0.
	pdmin=99999.

	do J=1,JM
	do I=1,IM
	if (pd(I,J)*ref(I,J).lt.pdmin .and. pd(I,J).gt.1000.)
     +	 pdmin=pd(I,J)*ref(I,J)
	if (pd(I,J)*ref(I,j).gt.pdmax) then
	pdmax=pd(I,J)*ref(I,J)
C	write(6,*) 'I,J,pd,ref ',i,j,pd(i,j),ref(i,j),pdmax
	endif
	enddo
	enddo

	write(6,*) 'in interp, pdmin (surface based)= ', pdmin
	write(6,*) 'in interp, pdmax (surface based)= ', pdmax
c
c *** Computation of winds within eta layers.
c
C      do 519 j=1,jm
C	    ivl=1
C            ivh=im-mod(j,2)
Cmytest            ivh=im
C      do 519 i=ivl,ivh
C            if (j .eq. 1  .or. j .eq. jm) goto 520
Corig            if ( (i .eq.1 .and. mod(j+1,2).eq.0) .or. i.eq.im) goto 521
C        if ( (i .eq.1 .and. mod(j,2).eq.0) .or. i.eq.im) goto 521
C	    pdvp=0.25*(pd(i,j-1)+pd(i+ivw(j),j)+pd(i+ive(j),j)+pd(i,j+1))
C            goto 522
C  520       pdvp = 0.50*(pd(i+ivw(j),j)+pd(i+ive(j),j))
C            goto 522
C  521       pdvp = 0.50*(pd(i,j-1)+pd(i,j+1))
c

	ALLOCATE(PDVP(IM,JM))

      DO J=2,JM-1
       DO I=2,IM-1
          PDVP(I,J)=0.25*(PD(I+IVE(J),J)+PD(I+IVW(J),J)
     1                 +PD(I,J+1)+PD(I,J-1))
       ENDDO
      ENDDO
C***
C***  COMPUTE NORTH AND SOUTH EDGES AND RECOMPUTE EAST AND WEST SIDES
C***
      DO I=1,IM-1
        PDVP(I,1) =0.5*(PD(I+IVE(1),1)+PD(I+IVW(1),1))
        PDVP(I,JM)=0.5*(PD(I+IVE(JM),JM)+PD(I+IVW(JM),JM))
      ENDDO
      DO J=2,JM-1,2
        PDVP(1,J) =0.5*(PD(1,J+1)+PD(1,J-1))
        PDVP(IM,J)=0.5*(PD(IM,J+1)+PD(IM,J-1))
      ENDDO
      DO J=1,JM,2
        PDVP(IM,J)=PDVP(IM-1,J)
      ENDDO
      DO J=3,JM-2,2
        PDVP(1,J)=0.25*(PD(1+IVE(J),J)+PD(1+IVW(J),J)
     1                 +PD(1,J+1)+PD(1,J-1))
      ENDDO
C***
C***  COMPUTE WINDS (SINCE FIX IS HARDWIRED TO 0. FOR ALL K,
C***                 SKIP CHECKING THE VALUE OF FIX AND PROCEED)
C***

	ALLOCATE(UETA(IM,JM,LM))
	ALLOCATE(VETA(IM,JM,LM))

	write(6,*) 'past wind allocates'

      DO J=1,JM
      DO I=1,IM
        NN=(J-1)*IM+I
        IDXX(NN)=I
        JDXX(NN)=J
      ENDDO
      ENDDO

      NUMK=IM*JM
C      DO NN=1,NK
C        IDX(NN)=IDXX(NN)
C        JDX(NN)=JDXX(NN)
C      ENDDO

      MNKNT=1

      DO 400 L=1,LM
C      KNTX=MNKNT
C      KNTIN=KNTX
C      KP1=MIN(LM,KNTIN+1)
C      NUMK=0
C        ALPETAI(I,J)=ALOG(PT+PDVP(I,J)*ETAL(L))
C
cdir$ ivdep
      DO N=1,NUMK
        I=IDXX(N)
        J=JDXX(N)
        ALPETAI(I,J)=ALOG(PT+PDVP(I,J)*ETAL(L))
        ALPETK=ALPETAI(I,J)


	do 524 ld=2,ldm
	if (ALPETK .GT. ALP(LD) .AND. LD .LT. LDM) GOTO 524
          ULD=U(I,J,LD)
          VLD=V(I,J,LD)
          CF=(ALP(LD)-ALPETK)/ALPR(LD-1)
          UKB=ULD+(U(I,J,LD-1)-ULD)*CF
          VKB=VLD+(V(I,J,LD-1)-VLD)*CF
          UETA(I,J,L)=UKB
          VETA(I,J,L)=VKB
	GOTO 523
 524  continue
 523  continue
	ENDDO
  400 CONTINUE

	DEALLOCATE(PDVP)

	write(6,*) 'past PDVP deallocate'


C	do j=1,jm
C	ivh=im-mod(j,2)
C	do i=1,ivh
C        do l=1,lm
C               if (l .eq. 1) alplb=alpt
C               alpub=alplb
C               alplb=alog(pt+pdvp(i,j)*eta(l+1))
C               alpeta=sqrt(0.5*(alpub**2+alplb**2))
C               do 524 ld=2,ldm
C                  if (alpeta .gt. alp(ld) .and. ld .lt. ldm) goto 524
C                  uld=u(i,j,ld)
C                  vld=v(i,j,ld)
C                  ldm1=ld-1
C                  cf=(alp(ld)-alpeta)/alpr(ldm1)
C                  uetaij(l)=uld+(u(i,j,ldm1)-uld)*cf
C                  vetaij(l)=vld+(v(i,j,ldm1)-vld)*cf
C	if (abs(uetaij(l)) .gt. 100.) then
C	write(6,*) uld, u(i,j,ldm1), cf
C	endif
C                  goto 523
C  524          continue
C  523       continue

C	do l=1,lm
C	ueta(i,j,l)=uetaij(l)
C	veta(i,j,l)=vetaij(l)
C	enddo

C	enddo
C	enddo
c
c
c *** Ground surface heights converted to geopotentials, and 
c        geopotential to temperature inversion.
c
	ALLOCATE(PHIS(IM,JM))
	ALLOCATE(TETA(IM,JM,LM))
      do j=1,jm
C	write(6,*) 'looping for J=  ', J
      do i=1,im
csd
Cremove            if (kt .eq. 0 .or. hmask(i,j)) then
csd
               phis(i,j)=g*hgt(i,j)
c           
               phub=0.
               if (sigma) phub=phis(i,j)
              do ivi=1,lm
                  l=lmp1-ivi
                  phlb=phub
                  phub=g*heta(i,j,l)
                  teta(i,j,l)=-(phlb-phub)*(pt+etal(l)*pd(i,j))
     +                        /(r*deta(l)*pd(i,j))

cmp
C              if (teta(i,j,l).gt.2000) Print*,'JLG',teta(i,j,l),pd(i,j)
Cmp	if (phub .lt. phlb) write(6,*) '<heta HOSED>: ', phub,phlb
	if (teta(i,j,l) .lt. 250 .and.L.ge.33.and.hgt(i,j).lt.90.) then
Cmp       write(6,264)I,J, L,phlb,phub,hgt(i,j),pd(i,j),teta(i,j,l)
	endif
  264	format('L,phlb,phub,hgt,pd,teta ',3(I2,1x),f5.1,1x,
     +	f7.1,1x,f6.1,1x,
     +	f8.1,1x,f7.1)


Cmp	diagnostic trying to find why lowest level temps suck
Cmp	basically everything is okay except for first level....too much
Cmp	of a jump from phi=0 to g*heta(i,j,lm)

	if (I .eq. 51 .and. J .eq. 15) then
C	write(6,*) ' '
C	write(6,*) 'L, teta, hgtlb,hgtub= > ', l,teta(i,j,l),
C     +	phlb/9.81,phub/9.81
C	write(6,*) 'phlb,phub ', phlb,phub
C	write(6,*) ' '
C	write(6,*) '................................'
	ENDIF

C**************************************************************
Cmp	substitute the TETA values at lowest level?
	if (ivi .eq. lm) then
	tsavetmp=teta(i,j,lm)	
CTEST	teta(i,j,lm)=teta(i,j,lm-1)
	endif
Cmp

	if (teta(i,j,l) .gt. 2000) then
        write(6,*) 'BIG TETA,phub,pd ',teta(i,j,l),i,j,l,phub/g,pd(i,J)
	endif

	if (TETA(I,J,L).lt.100.and.L.le.LM-1.and.L.ge.20) then
C	write(6,*) 'SMALL TETA:lev,lowZ,upZ,pd,etal ', teta(i,j,l),l,phlb/g,
C     +	phub/g,pd(i,J),etal(l)
C	write(6,*) 'TETA (below), deta(l) ', teta(I,J,L+1),deta(l)
	endif

      if (teta(i,j,l).gt.tetamax) tetamax=teta(i,j,l)


Cmp
	teta(i,j,l)=amin1(teta(i,j,l),325.)
	teta(i,j,l)=amax1(teta(i,j,l),150.)
Cmp
C
csn************
                  if (eta(l+1) .le. ref(i,j)) then
                     qseta=pq0/(pd(i,j)*etal(l)+pt)
     .                    *exp(a2*(teta(i,j,l)-a3)/(teta(i,j,l)-a4))
                     rheta=qeta(i,j,l)/qseta
                  endif
                  rheta=min(rheta,tresh)
                  qeta(i,j,l)=rheta*qseta
                  qeta(i,j,l)=max(0.,qeta(i,j,l))
                  teta(i,j,l)=teta(i,j,l)/(qeta(i,j,l)*0.61+1)
               enddo             
c
C************************
c ************ Now redefine pd to have it equal to ps-pt.
C**************************
c
               pd(i,j)=ref(i,j)*pd(i,j)
C
Cmp	write(6,301) pd(i,j)
  301	format('redefined pd',f9.2)
C****************************
C**************************
csd
Cmp	reinstate
Cremove            endif
csd
	do L=1,LM
C	if (I .eq. 93 .and. J .eq. 17) then
C	write(6,*) 'WHY: I,J,L, teta(i,j,l)= > ', i,j,l,
C     +     	teta(i,j,l)
C	ENDIF
	enddo
         enddo
      enddo

	DEALLOCATE(HETA)
	DEALLOCATE(HGT)

	write(6,*) 'heta deallocated'

c
c *** Set u, v and t equal to zero at points below the ground.
c
                  do j=2,jm-1
              ihl=1+mod(j,2)
              ihh=im-1
!
Cmp	i indices changed from zj code
              do i=ihl,ihh
            do l=1,lm
Cmp
Cmp---change this part????????????????????????????
               if (eta(l+1) .gt. ref(i,j)) then
csd               teta(i,j,l)=0.
csd               qeta(i,j,l)=0.
C               teta(i,j,l)=0.
C               qeta(i,j,l)=0.
                  ueta(i+ihw(j),j,l)=0.
                  veta(i+ihw(j),j,l)=0.
                  ueta(i+ihe(j),j,l)=0.
                  veta(i+ihe(J),j,l)=0.
                  ueta(i,j-1,l)=0.
                  veta(i,j-1,l)=0.
                  ueta(i,j+1,l)=0.
                  veta(i,j+1,l)=0.
               endif
C      if(abs(ueta(i,j,l)).gt.100.) write(6,*) 'ueta ',i,j,l,ueta(i,j,l)
C      if(abs(veta(i,j,l)).gt.100.) write(6,*) 'veta ',i,j,l,veta(i,j,l)

            enddo
         enddo
      enddo
c
c *** The separation of the boundary values.
c
C
C
C	write(6,*) 'sample wind values, lev=20 '
C	write(6,*) 'U,V,spd(1,1) ', ueta(1,1,20),veta(1,1,20),
C     +		(ueta(1,1,20)**2.+veta(1,1,20)**2.)**0.5
C	write(6,*) 'U,V,spd(35,35) ', ueta(35,35,20),veta(35,35,20),
C     +		(ueta(35,35,20)**2.+veta(35,35,20)**2.)**0.5
C	write(6,*) 'U,V,spd(im,4) ', ueta(im,4,20),veta(im,4,20),
C     +		(ueta(im,4,20)**2.+veta(im,4,20)**2.)**0.5
      n = 1 
      do i=1,im
         pdb(n,1)=pd(i, 1)
         pdb(n,2)=0.
         do l=1,lm
            tb(n,l,1)=teta(i, 1,l)
            tb(n,l,2)=0.
            qb(n,l,1)=qeta(i, 1,l)
            qb(n,l,2)=0.
         enddo
         n=n+1
      enddo
      do i=1,im
         pdb(n,1)=pd(i,jm)
         pdb(n,2)=0.
         do l=1,lm
            tb(n,l,1)=teta(i,jm,l)
            tb(n,l,2)=0.
            qb(n,l,1)=qeta(i,jm,l)
            qb(n,l,2)=0.
         enddo
         n=n+1
      enddo
      do j=3,jm-2,2
         pdb(n,1)=pd( 1,j)
         pdb(n,2)=0.
         do l=1,lm
            tb(n,l,1)=teta( 1,j,l)
            tb(n,l,2)=0.
            qb(n,l,1)=qeta( 1,j,l)
            qb(n,l,2)=0.
         enddo
         n=n+1
      enddo
      do j=3,jm-2,2
         pdb(n,1)=pd(im,j)
         pdb(n,2)=0.
         do l=1,lm
            tb(n,l,1)=teta(im,j,l)
            tb(n,l,2)=0.
            qb(n,l,1)=qeta(im,j,l)
            qb(n,l,2)=0.
         enddo
         n=n+1
      enddo
c
C       SOUTH BOUNDARY - V POINTS
c
      n=1 
         do i=1,im-1
         do l=1,lm
            ub(n,l,1)=ueta(i, 1,l)
            ub(n,l,2)=0.
            vb(n,l,1)=veta(i, 1,l)
            vb(n,l,2)=0.
         enddo
         n=n+1
      enddo
C
C       NORTH BOUNDARY - V POINTS
C
      do i=1,im-1
         do l=1,lm
            ub(n,l,1)=ueta(i,jm,l)
            ub(n,l,2)=0.
            vb(n,l,1)=veta(i,jm,l)
            vb(n,l,2)=0.
         enddo
         n=n+1
      enddo
C
C       WEST BOUNDARY - V POINTS
C
      do j=2,jm-1,2
         do l=1,lm
            ub(n,l,1)=ueta( 1,j,l)
            ub(n,l,2)=0.
            vb(n,l,1)=veta( 1,j,l)
            vb(n,l,2)=0.
         enddo
         n=n+1
      enddo
C
C       EAST BOUNDARY - V POINTS
C
      do j=2,jm-1,2
         do l=1,lm
            ub(n,l,1)=ueta(im,j,l)
            ub(n,l,2)=0.
            vb(n,l,1)=veta(im,j,l)
            vb(n,l,2)=0.
         enddo
         n=n+1
      enddo
c
      if (kt .eq. 0) then
c
	write(6,*) 'THE LARGEST TETA VALUE IS ', TETAMAX
Cmp
         l=index(init_out//' ',' ')-1
         if (init_out(l:l) .ne. '/') then
            l=l+1
            init_out(l:l)='/'
         endif
c
         open(1,file=init_out(1:l)//'preproc.init'
     .       ,status='unknown',form='unformatted')
         rewind(1) 
         run=.true.
         ntsd=0
         print *,'Writing to file: ',init_out(1:l)//'preproc.init'

C	write(6,*) 'temps'
C	call levext(teta,im,jm,lm)
C	write(6,*) 'uwnd'
C	call levext(ueta,im,jm,lm)
C	write(6,*) 'vwnd'
C	call levext(veta,im,jm,lm)
C	write(6,*) 'Z'
C	call levext(heta,im,jm,lm)
C	write(6,*) 'pd'
C	call levext(pd,im,jm,1)

C	write(6,*) 'pd'
	do J=jm,jm/2,-1
C	write(6,666) (pd(i,j)/100.,i=im-10,im)
	enddo
C	write(6,*) 'ueta at lm=19'
	do J=jm,jm/2,-1
C        write(6,666) (ueta(i,j,19),i=im-10,im)
        enddo
C	write(6,*) 'veta at lm=19'
	do J=jm,jm/2,-1
C        write(6,666) (veta(i,j,19),i=im-10,im)
        enddo
C	write(6,*) 'HMASK (NE corner) '
	do J=jm,jm/2,-1
C        write(6,667) (hmask(i,j),i=im-10,im)
        enddo
C	write(6,*) 'VMASK (NE corner) '
	do J=jm,jm/2,-1
C        write(6,667) (vmask(i,j),i=im-10,im)
        enddo

  666	format(20(f5.0,1x))	
  667	format(20(L2,1x))	
         write(1) run,idat(1),idat(2),idat(3),idat(4),ntsd,ueta,veta
         write(1) teta,qeta,pd,phis,sm,ref,eta,pt,deta,etal,zeta
Ctst
C        open(unit=4,file=init_out(1:l)//'eta_temps.fil',
C     + status='unknown',form='unformatted')
C        write(4) teta
Ctst


	write(6,*) 'ueta, veta, level 20'
         print *,ueta(1,1,20),ueta(11,11,20),ueta(21,21,20)
         print *,veta(1,1,20),veta(11,11,20),veta(21,21,20)
	
Cmp ***** write out the surface fields

	write(1) sfcgrid

         close(1)
c
      endif

	DEALLOCATE(PD)
	DEALLOCATE(PHIS)
	DEALLOCATE(SM)
	DEALLOCATE(TETA)
	DEALLOCATE(QETA)
	DEALLOCATE(UETA)
	DEALLOCATE(VETA)
c
      l=index(init_out//' ',' ')-1
      if (init_out(l:l) .ne. '/') then
         l=l+1
         init_out(l:l)='/'
      endif
      write(fname,'(i3.3)') idat(5)
      open (1,file=init_out(1:l)//'preproc.bc.'//fname
     .     ,status='unknown',form='unformatted')
	if (idat(5) .eq. 0) then
      open (11,file=init_out(1:l)//'bndy.newstyle'
     .     ,status='unknown',form='unformatted')
	endif
      write(1) run,idat(1),idat(2),idat(3),idat(4),pdb,tb,qb,ub,vb
Cmp	write(11) run,idat(1),idat(2),idat(3),idat(4)
	write(11) pdb,tb,qb,ub,vb
	write(6,*) 'in interp, pdb(1,1),pdb(1,2): ', pdb(1,1),
     +                           pdb(1,2)
      close(1)
  671   format('L,U,V(LEV=20) ',I3,1x,f6.2,1x,f6.2,1x,f6.2)

      write(6,*) 'took square of neg number at ', negsum,' points'
c
      return
      end

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

	subroutine levext(array,idim,jdim,kdim)

	real array(idim,jdim,kdim)

	do K=1,KDIM
	armax=-9999999.
	armin=9999999.
	imax=-9999.
	jmax=-9999.
C	do J=1,jdim
C	do I=1,idim
	do J=2,jdim-1
	do I=2,idim-1
	if (array(I,J,K).gt.armax) then
	armax=array(I,J,K)
	imax=i
	jmax=j
	endif
	if (array(I,J,K).lt.armin) armin=array(I,J,K)
	enddo
	enddo
	write(6,*) 'extremes for LEV: ', K, 'are  ', armin,armax, 
     +	'imax,jmax ',
     +	 imax,jmax
	enddo	
	return
	end

C
      SUBROUTINE PRINTETA (SI,SM)
C
      IMPLICIT REAL (A-H, O-Z)
C
      INCLUDE "parmeta"
C
      REAL           SI(IM,JM),   SM(IM,JM)
      INTEGER        SI2D(IM,JM), SM2D(IM,JM)
      INTEGER        SR
C
      DO J=1,JM
      DO I=1,IM
C                          CONVERT MTRS TO INCHES, CAP AT 9 FOR PRINT
      SINCH=SI(I,J)*100./2.54
      SR= NINT(SINCH)
      SR = MIN (9,SR) 
      SI2D(I,J) = SR 
      SM2D(I,J) = NINT(SM(I,J))
      IF (SM2D(I,J).EQ.0) SI2D(I,J)=MAX(1,MIN(8,SI2D(I,J)))
C   
      ENDDO
      ENDDO
C
      PRINT 50
   50 FORMAT(////' LAND-SEA MASK OF ETA GRID ( SEA/LAKE=1, LAND=0 )'/)
C
      DO 100, JJ=1,JM,JM/30
      J = JM + 1 - JJ
      PRINT 70, J, (SM2D(I,J), I=1,IM,IM/30)
   70 FORMAT(' ', ' J=', I3, 1X, 72I1)
  100 CONTINUE
C
      PRINT 75
   75 FORMAT(/' SNOW/ICE ON ETA GRID '/
     1' ',9X,'(ICE-FREE SEA=0, SNOW-FREE LAND=1, SNOW=2-8 IN., ICE=9)'/
     2' ','*** SNOWDEPTH CAPPED HERE AT 8 INCHES FOR DISPLAY ONLY ***'/)
C
      DO 200, JJ=1,JM,JM/30
      J = JM + 1 - JJ
      PRINT 70, J, (SI2D(I,J), I=1,IM,IM/30)
  200 CONTINUE
C
      RETURN
      END

      program data_prep
c
c *** Program to prepare ETA initialization fields from any gridded
c        data set.
c
c *** Original code obtained from U. of Athens and modified at FSL.
c
      implicit none
c
      include 'ecommons.h'
c
      integer*4 n
c_______________________________________________________________________________
c 
c *** Fill eta model common blocks.
c
      call eta_commons
c
c *** Interpolate data to eta grid from each input init gridded dataset.
c
      do n=1,ninit
c
c ****** Get the native grid dimensions of the input data.
c           (Dims are filled into named common block - sectorsize).
c
!         call get_sector_size(init_in(n))
	write(6,*) 'call get_sector_size'
	write(6,*) 'file= ', init_gdsdir
	call get_sector_size(init_in(n),init_gdsdir)
c
         Write(6,*)'Passei ',n,' vezes'
         call eta_interp(n)
c
      enddo
c
c *** Create model init and constants files.
c
	write(6,*) 'calling eta_const'
      call eta_const
c
c *** Create model boundary condition files.
c
      call eta_boco
c
      end

C$$$  sub  PROGRAM DOCUMENTATION BLOCK
C                .      .    .                                       .
C sub  PROGRAM:  gridst   READ GLOBAL Grib SST
C                            
C
C ABSTRACT: SUBSTITUTE THE GRIBST SUB PROGRAM
C           READ THE SST FIELD IN A BINARY FORMAT 
C           INSTED A GRIB FORMAT
C           IN THIS CASE THE BINARY FILE IS GENERATE
C           FROM SST GRIB2 FILE WITH WGRIB2 PROGRAM: 
C           wgrib2 -d 1 sst2dvar_grb_0.5.grib2 -v \
C           -no_header big_endian -bin ssthiresgrd.bin
C
C PROGRAM HISTORY LOG:
C   08-11-03  JORGE LUIS GOMES
C
C
      subroutine gridst(insst,gsst)
c
      parameter(nx=4320,ny=2160,nxp1=nx+1)

      REAl out(nx,ny)
      dimension gsst(nxp1,ny)
c
C
c
C            OPEN UNIT FOR READING GRID FILE
       OPEN (INSST,form='unformatted',convert='big_endian')
       READ(INSST)((out(I,2161-J),I=1,4320),J=1,2160)
C
              do  jj= 1,ny
                do  kk= 1,nx
                 gsst(kk,jj) = out(kk,jj)
                end do
              end do
c
c...   add greenich to right side of grid
c
             do jj = 1,ny
               gsst(nxp1,jj) = gsst(1,jj)
             end do
         write(95)gsst
c
C
   30        CONTINUE
C
  999           CONTINUE
	write(6,*) 'leaving GRIDST'
             return
             END

      SUBROUTINE GAULAT(GAUL,K)
C
      DIMENSION A(500)
C      DIMENSION GAUL(1)
      DIMENSION GAUL(K)

	real(8) XZ,AVSP,SP,PK,PKMRK,PKM1,PKM2
C
C      ESP=1.E-14
      ESP=1.E-12
      C=(1.E0-(2.E0/3.14159265358979E0)**2)*0.25E0
      FK=K
      KK=K/2
      CALL BSSLZ1(A,KK)
      do30: DO IS=1,KK
      XZ=COS(A(IS)/SQRT((FK+0.5E0)**2+C))
      ITER=0
   10 PKM2=1.E0
      PKM1=XZ
      ITER=ITER+1
      IF(ITER.GT.10) GO TO 70
      do20: DO N=2,K
      FN=N
      PK=((2.E0*FN-1.E0)*XZ*PKM1-(FN-1.E0)*PKM2)/FN
      PKM2=PKM1
      PKM1=PK
      END DO do20
      PKM1=PKM2
      PKMRK=(FK*(PKM1-XZ*PK))/(1.E0-XZ**2)
      SP=PK/PKMRK
      XZ=XZ-SP
      AVSP=ABS(SP)
      IF(AVSP.GT.ESP) GO TO 10
      A(IS)=XZ
      END DO do30
      IF(K.EQ.KK*2) GO TO 50
      A(KK+1)=0.E0
      PK=2.E0/FK**2
      do40: DO N=2,K,2
      FN=N
      PK=PK*FN**2/(FN-1.E0)**2
      END DO do40
   50 CONTINUE
      DO 60 N=1,KK
      L=K+1-N
      A(L)=-A(N)
   60 CONTINUE
C
      RADI=180./(4.*ATAN(1.))
      DO 211 N=1,K
      GAUL(N)=90.-ACOS(A(N))*RADI
C	if (mod(N,3) .eq. 0) write(6,*) 'N, GAULAT: ', N, GAUL(N)
  211 CONTINUE
C
C     PRINT *,'GAUSSIAN LAT (DEG) FOR JMAX=',K
C     PRINT *,(GAUL(N),N=1,K)
C
      RETURN
   70 WRITE(6,6000)
 6000 FORMAT(//5X,14HERROR IN GAUAW//)
      STOP
      END

      SUBROUTINE gauss_ijonce(KGDS,IOPT,NPTS,FILL,XPTS,YPTS,
     +						RLON,RLAT,NRET)
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM:  GDSWIZ04   GDS WIZARD FOR GAUSSIAN CYLINDRICAL
C   PRGMMR: IREDELL       ORG: W/NMC23       DATE: 96-04-10
C
C ABSTRACT: THIS SUBPROGRAM DECODES THE GRIB GRID DESCRIPTION SECTION
C           (PASSED IN INTEGER FORM AS DECODED BY SUBPROGRAM W3FI63)
C           AND RETURNS ONE OF THE FOLLOWING:
C             (IOPT=+1) EARTH COORDINATES OF SELECTED GRID COORDINATES
C             (IOPT=-1) GRID COORDINATES OF SELECTED EARTH COORDINATES
C           FOR GAUSSIAN CYLINDRICAL PROJECTIONS.
C           IF THE SELECTED COORDINATES ARE MORE THAN ONE GRIDPOINT
C           BEYOND THE THE EDGES OF THE GRID DOMAIN, THEN THE RELEVANT
C           OUTPUT ELEMENTS ARE SET TO FILL VALUES.
C           THE ACTUAL NUMBER OF VALID POINTS COMPUTED IS RETURNED TOO.
C
C PROGRAM HISTORY LOG:
C   96-04-10  IREDELL
C
C USAGE:    CALL GDSWIZ04(KGDS,IOPT,NPTS,FILL,XPTS,YPTS,RLON,RLAT,NRET,
C    &                    LROT,CROT,SROT)
C
C   INPUT ARGUMENT LIST:
C     KGDS     - INTEGER (200) GDS PARAMETERS AS DECODED BY W3FI63
C     IOPT     - INTEGER OPTION FLAG
C                (+1 TO COMPUTE EARTH COORDS OF SELECTED GRID COORDS)
C                (-1 TO COMPUTE GRID COORDS OF SELECTED EARTH COORDS)
C     NPTS     - INTEGER MAXIMUM NUMBER OF COORDINATES
C     FILL     - REAL FILL VALUE TO SET INVALID OUTPUT DATA
C                (MUST BE IMPOSSIBLE VALUE; SUGGESTED VALUE: -9999.)
C     XPTS     - REAL (NPTS) GRID X POINT COORDINATES IF IOPT>0
C     YPTS     - REAL (NPTS) GRID Y POINT COORDINATES IF IOPT>0
C     RLON     - REAL (NPTS) EARTH LONGITUDES IN DEGREES E IF IOPT<0
C                (ACCEPTABLE RANGE: -360. TO 360.)
C     RLAT     - REAL (NPTS) EARTH LATITUDES IN DEGREES N IF IOPT<0
C                (ACCEPTABLE RANGE: -90. TO 90.)
C     LROT     - INTEGER FLAG TO RETURN VECTOR ROTATIONS IF 1
C
C   OUTPUT ARGUMENT LIST:
C     XPTS     - REAL (NPTS) GRID X POINT COORDINATES IF IOPT<0
C     YPTS     - REAL (NPTS) GRID Y POINT COORDINATES IF IOPT<0
C     RLON     - REAL (NPTS) EARTH LONGITUDES IN DEGREES E IF IOPT>0
C     RLAT     - REAL (NPTS) EARTH LATITUDES IN DEGREES N IF IOPT>0
C     NRET     - INTEGER NUMBER OF VALID POINTS COMPUTED
C     CROT     - REAL (NPTS) CLOCKWISE VECTOR ROTATION COSINES IF LROT=1
C     SROT     - REAL (NPTS) CLOCKWISE VECTOR ROTATION SINES IF LROT=1
C                (UGRID=CROT*UEARTH-SROT*VEARTH;
C                 VGRID=SROT*UEARTH+CROT*VEARTH)
C
C SUBPROGRAMS CALLED:
C   GAUSSLAT     COMPUTE GAUSSIAN LATITUDES
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 77
C
C$$$
      INTEGER KGDS(200)
      REAL XPTS(NPTS),YPTS(NPTS),RLON(NPTS),RLAT(NPTS)
      PARAMETER(PI=3.14159265358979,DPR=180./PI)
      PARAMETER(JGMAX=2000)
      REAL ALAT(0:JGMAX+1),BLAT(JGMAX)
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      IF(KGDS(1).EQ.004.AND.KGDS(10)*2.LE.JGMAX) THEN
        IM=KGDS(2)
        JM=KGDS(3)
        RLAT1=KGDS(4)*1.E-5
        RLON1=KGDS(5)*1.E-5
        RLAT2=KGDS(7)*1.E-5
        RLON2=KGDS(8)*1.E-5
        JG=KGDS(10)*2
        ISCAN=MOD(KGDS(11)/128,2)
        JSCAN=MOD(KGDS(11)/64,2)
        NSCAN=MOD(KGDS(11)/32,2)
        HI=(-1.)**ISCAN
        JH=(-1)**JSCAN
        DLON=HI*(MOD(HI*(RLON2-RLON1)-1+3600,360.)+1)/(IM-1)
        CALL GAUSSLAT(JG,ALAT(1),BLAT)
        DO JA=1,JG
          ALAT(JA)=DPR*ASIN(ALAT(JA))
        ENDDO
        ALAT(0)=180.-ALAT(1)
        ALAT(JG+1)=-ALAT(0)
        J1=1
        DOWHILE(J1.LT.JG.AND.RLAT1.LT.(ALAT(J1)+ALAT(J1+1))/2)
          J1=J1+1
        ENDDO
        J2=J1+JH*(JM-1)
        XMIN=0
        XMAX=IM+1
        IF(IM.EQ.NINT(360/ABS(DLON))) XMAX=IM+2
        YMIN=0.5
        YMAX=JM+0.5
        NRET=0
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C  TRANSLATE GRID COORDINATES TO EARTH COORDINATES
        IF(IOPT.EQ.0.OR.IOPT.EQ.1) THEN
          DO N=1,NPTS
            IF(XPTS(N).GE.XMIN.AND.XPTS(N).LE.XMAX.AND.
     &         YPTS(N).GE.YMIN.AND.YPTS(N).LE.YMAX) THEN
              RLON(N)=MOD(RLON1+DLON*(XPTS(N)-1)+3600,360.)
              J=MIN(INT(YPTS(N)),JM)
              RLATA=ALAT(J1+JH*(J-1))
              RLATB=ALAT(J1+JH*J)
              WB=YPTS(N)-J
              RLAT(N)=RLATA+WB*(RLATB-RLATA)
              NRET=NRET+1
            ELSE
              RLON(N)=FILL
              RLAT(N)=FILL
            ENDIF
          ENDDO
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C  TRANSLATE EARTH COORDINATES TO GRID COORDINATES
        ELSEIF(IOPT.EQ.-1) THEN
          DO N=1,NPTS
            XPTS(N)=FILL
            YPTS(N)=FILL
            IF(ABS(RLON(N)).LE.360.AND.ABS(RLAT(N)).LE.90) THEN
              XPTS(N)=1+HI*MOD(HI*(RLON(N)-RLON1)+3600,360.)/DLON
              JA=MIN(INT((JG+1)/180.*(90-RLAT(N))),JG)
              IF(RLAT(N).GT.ALAT(JA)) JA=MAX(JA-2,0)
              IF(RLAT(N).LT.ALAT(JA+1)) JA=MIN(JA+2,JG)
              IF(RLAT(N).GT.ALAT(JA)) JA=JA-1
              IF(RLAT(N).LT.ALAT(JA+1)) JA=JA+1
              YPTSA=1+JH*(JA-J1)
              YPTSB=1+JH*(JA+1-J1)
              WB=(ALAT(JA)-RLAT(N))/(ALAT(JA)-ALAT(JA+1))
              YPTS(N)=YPTSA+WB*(YPTSB-YPTSA)
              IF(XPTS(N).GE.XMIN.AND.XPTS(N).LE.XMAX.AND.
     &           YPTS(N).GE.YMIN.AND.YPTS(N).LE.YMAX) THEN
                NRET=NRET+1
              ELSE
                XPTS(N)=FILL
                YPTS(N)=FILL
              ENDIF
            ENDIF
          ENDDO
        ENDIF
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C  PROJECTION UNRECOGNIZED
      ELSE
        IRET=-1
        IF(IOPT.GE.0) THEN
          DO N=1,NPTS
            RLON(N)=FILL
            RLAT(N)=FILL
          ENDDO
        ENDIF
        IF(IOPT.LE.0) THEN
          DO N=1,NPTS
            XPTS(N)=FILL
            YPTS(N)=FILL
          ENDDO
        ENDIF
      ENDIF
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      END

      SUBROUTINE PRINTAF ( SNODEP, MSKAF ) 
C
      IMPLICIT REAL (A-H, O-Z)                      
C                                                     
      REAL          SNODEP(512,512) 
      INTEGER       MSKAF (512,512), IPSNO(512)
C                                                                       
      DATA   IAF/512/, JAF/512/
C
      JAFP1 = JAF + 1
C
      PRINT 50
   50 FORMAT(/' LAND-SEA MASK OF USAF GRID '/
     1    ' ',' ( SEA/LAKE=1, LAND=2, COASTAL-LAND=4, OFFWORLD=9 )'/)
C
      DO 100, JJ=1,JAF,8
      J = JAF + 1 - JJ
      PRINT 70, J, (MSKAF(I,J), I=69,IAF,6)
   70 FORMAT(' ', ' J=', I3, 1X, 74I1)
  100 CONTINUE
C
      PRINT 120
  120 FORMAT(/' SNOW/ICE ON USAF GRID'/
     1' (ICE-FREE SEA=0, SNOW-FREE LAND=1, SNOWDEPTH=2-8 IN., ICE=9 )'/
     2' ','*** SNOWDEPTH CAPPED HERE AT 8 INCHES FOR DISPLAY ONLY ***'/)
C
      DO 200, JJ=1,JAF,8
      J = JAF + 1 - JJ
      DO 150, I=1,IAF
      SR=SNODEP(I,J)*100./2.54
C CAP SEA-ICE AT 9 FOR PRINT PURPOSES
      IPSNO(I)=MIN(9,NINT(SR))
C CAP SNOWDEPTH AT 8 INCHES FOR PRINT PURPOSES
      IF (MSKAF(I,J) .GE. 2) IPSNO(I)=MAX(1,MIN(8,NINT(SR)))
C FORCE PRINT OF ASTERISK FOR OFF-WORLD
      IF (MSKAF(I,J) .EQ. 9) IPSNO(I)=10
  150 CONTINUE    
      PRINT 70, J, (IPSNO(I), I=69,IAF,6)
  200 CONTINUE
C
      RETURN
      END

	SUBROUTINE SNOWSOILSST(im,jm,tlm0d,tph0d,dlmd,dphd,sfc_file,
     +	GGSTC1,GGSTC2,GGSMC1,GGSMC2,SSTRAW,SNOWRAW,GGLAND,GGICE,kgds)


	parameter (nx=192,ny=94)
	parameter(dtr=3.14159/180.,r2d=1./dtr)

CC	read and fill these 8 arrays...process rest in another sub

C	real,allocatable:: GGSTC1(:,:),GGSTC2(:,:)
C	real,allocatable:: GGSMC1(:,:),GGSMC2(:,:)
C	real,allocatable:: SSTRAW(:,:),SNOWRAW(:,:)
C	real,allocatable:: GGLAND(:,:),GGICE(:,:)

	REAL GGSTC1(nx,ny),GGSTC2(nx,ny),GGSMC1(nx,ny)
	REAL GGSMC2(nx,ny),SSTRAW(nx,ny),SNOWRAW(nx,ny)
	REAL GGLAND(nx,ny),GGICE(nx,ny)
	real,allocatable:: tmp(:)

	character*256 sfc_file

        integer ICOUNT,I,ixp,jyp

	      integer kgds(200),kpds(200),len
     .         ,nwords,IRETO,IRET1,JPDS(200),JGDS(200),KNUM

        logical BITMAP(nx*ny)

Cmp	eventually need a proper file name here
C
	len=index(sfc_file,' ')-1
C	write(6,*) 'trying to open ', sfc_file(1:len)

	call baopen(11,sfc_file(1:len),IRETO)
	if (IRETO .ne. 0) write(6,*) 'baopen error!'

        jpds=-1
        jgds=-1

        jpds(7)=10
        jpds(5)=11
        jpds(6)=112


CC	first call to get GDS of Gaussian grid
CC
	allocate(tmp(nx*ny))
        call getgb(11,0,nx*ny,0,JPDS,JGDS,nwords,KNUM,KPDS,KGDS,
     &     BITMAP,tmp,IRET1)

	if (IRET1 .ne. 0) write(6,*) 'TROUBLE AHEAD!!!'
!	write(6,*) 'first getgb, nwords: ' , nwords

!	write(6,*) 'raw vals for STC'
	do J=1,NX*NY,500
!	write(6,*) 'J, tmp(J): ', J, tmp(J)
	enddo

        jpds=-1
        jgds=-1

        jpds(7)=10
        jpds(5)=11
        jpds(6)=112

!	write(6,*) 'nx*ny= ', nx*ny

CC	0-10 STC
CC
!	write(6,*) 'calling getgb'

        call getgb(11,0,nx*ny,0,JPDS,JGDS,nwords,KNUM,KPDS,KGDS,
     &     BITMAP,tmp,IRET1)

C	allocate(GGSTC1(nx,ny))

	if (IRET1 .eq. 0) then
	call reord(nx,ny,tmp,GGSTC1)
	else
	write(6,*) 'IRET1= ', IRET1
	write(6,*) 'no GGSTC1'
	STOP 666
	endif

CC	0-10 SMC
CC
	jpds(5)=144

!	write(6,*) 'getgb for 0-10 SMC'
        call getgb(11,0,nx*ny,0,JPDS,JGDS,nwords,KNUM,KPDS,KGDS,
     &     BITMAP,tmp,IRET1)

	if (IRET1 .eq. 0) then
C	allocate (GGSMC1(nx,ny))
	call reord(nx,ny,tmp,GGSMC1)
!	write(6,*) 'past reord 0-10 SMC'
	else
	write(6,*) 'no GGSMC1'
	write(6,*) 'IRET1= ', IRET1
	STOP 666
	endif

CC	10-200 STC
CC
	jpds(5)=11
	jpds(7)=2760
!	write(6,*) 'calling getgb for 10-200 STC'
        call getgb(11,0,nx*ny,0,JPDS,JGDS,nwords,KNUM,KPDS,KGDS,
     &     BITMAP,tmp,IRET1)

	if (IRET1 .eq. 0) then
C	allocate (GGSTC2(nx,ny))
	call reord(nx,ny,tmp,GGSTC2)
	else
	write(6,*) 'no GGSTC2'
	endif

CC	10-200 SMC
CC

	jpds(5)=144
!	write(6,*) 'getgb for 10-200 SMC'
        call getgb(11,0,nx*ny,0,JPDS,JGDS,nwords,KNUM,KPDS,KGDS,
     &     BITMAP,tmp,IRET1)
	
	if (IRET1 .eq. 0) then
C	allocate (GGSMC2(nx,ny))
	call reord(nx,ny,tmp,GGSMC2)
	else
	write(6,*) 'no GGSMC2'
	endif

CC
CC 	SFC TEMP (for SST?)
CC	

	jpds=-1
	jpds(5)=11
	jpds(6)=1
	jpds(7)=0
!	write(6,*) 'getgb for  SFC TMP'
        call getgb(11,0,nx*ny,0,JPDS,JGDS,nwords,KNUM,KPDS,KGDS,
     &     BITMAP,tmp,IRET1)

	if (IRET1 .eq. 0) then
C	allocate (SSTRAW(nx,ny))
	call reord(nx,ny,tmp,SSTRAW)
	else
	write(6,*) 'no SSTRAW'
	endif
	

CC
CC	snow depth?
CC

	jpds(5)=65
	jpds(6)=1
	jpds(7)=0
!	write(6,*) 'getgb for SNOW DEPTH'
        call getgb(11,0,nx*ny,0,JPDS,JGDS,nwords,KNUM,KPDS,KGDS,
     &     BITMAP,tmp,IRET1)

	if (IRET1 .eq. 0) then
C	allocate (SNOWRAW(nx,ny))
	call reord(nx,ny,tmp,SNOWRAW)
	else
	write(6,*) 'no snowraw'
	endif

	write(6,*) 'snowraw after reordered'
	write(6,*) 'I=140-->165, J=80-->60'
!	do J=1,ny/2
	do J=13,35
	write(6,632) (snowraw(I,J),I=142,160)
	enddo
  632	format(50(f4.0))

	jpds(5)=81
!	write(6,*) 'getgb for land mask'
        call getgb(11,0,nx*ny,0,JPDS,JGDS,nwords,KNUM,KPDS,KGDS,
     &     BITMAP,tmp,IRET1)

!	write(6,*) 'NWORDS from ggland getgb: ', nwords

!	write(6,*) 'raw vals for GGLANd'
	do J=1,NX*NY,500
!	write(6,*) 'J, tmp(J): ', J, tmp(J)
	enddo
	
	if (IRET1 .eq. 0) then
C	allocate (GGLAND(nx,ny))
	call reord(nx,ny,tmp,GGLAND)
	else
	write(6,*) 'ggland problems ', IRET1
	endif

        jpds(5)=91
	write(6,*) 'getgb for ice mask'
        call getgb(11,0,nx*ny,0,JPDS,JGDS,nwords,KNUM,KPDS,KGDS,
     &     BITMAP,tmp,IRET1)

	if (IRET1 .eq. 0) then
C	allocate (GGICE(nx,ny))
	call reord(nx,ny,tmp,GGICE)
	write(6,*) 'GGICE after reordered'
	do J=13,35
	write(6,632) (ggice(I,J),I=142,160)
	enddo
!	write(6,*) 'end GGICE'
	endif
CC
	return
	end

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC


	subroutine reord(nx,ny,input,output)

	real input(nx*ny),output(nx,ny)
C	write(6,*) 'inside reord ', nx,ny

	output=-9999.

	ICOUNT=0
	do J=1,ny
	do I=1,nx
	ICOUNT=ICOUNT+1
	output(I,J)=input(ICOUNT)
	enddo
	enddo

C	write(6,*) 'leaving reord'

	return
	end

      subroutine gautoeta(glats,nglats,nglons,hlat,hlon,sm,sice,
     &                            ggsli,ggrid,egrid)
C
      INCLUDE "parmeta"
C

      dimension glats(nglats),sm(im,jm),ggrid(nglons,nglats),
     &          egrid(im,jm)
      dimension hlat(im,jm),hlon(im,jm),sice(im,jm),ggsli(nglons,nglats)
C	write(6,*) 'inside GAUTOETA'
C	write(6,*) 'range of hlon values ', (hlon(I,jm/2),i=1,im,5)
      do j = 1,jm
      do i = 1,im
        if((sm(i,j).gt.0.5).or.(sice(i,j).eq.1.0)) then
c                           set non land-mass values
          egrid(i,j) = 0.0
        else
c                           set land-mass values
          y = (nglats-1) / (glats(nglats) - glats(1))
     &        * (hlat(i,j)-glats(1)) + 1
          x =float(nglons) / 360.0 * hlon(i,j) + 1
          iy = y
          ix = x
          iyp1 = iy + 1
          ixp1 = ix + 1
c  First calculate the bilinear weights assuming a constant dx and dy
          wxy =     (ixp1-x) * (iyp1 - y)
          wxp1y =   (x-ix)   * (iyp1 - y)
          wxp1yp1 = (x-ix)   * (y-iy)
          wxyp1 = (ixp1 - x) * (y-iy)
c  Take care of the wrap around the 0 meridan when necessary
          if(ix.eq.nglons) ixp1 = 1
c  Only use land mass points (ggsli=1) for the interpolation
          if(ggsli(ix,iy).ne.1.0) wxy = 0.0
          if(ggsli(ixp1,iy).ne.1.0) wxp1y = 0.0
          if(ggsli(ixp1,iyp1).ne.1.0) wxp1yp1 = 0.0
          if(ggsli(ix,iyp1).ne.1.0) wxyp1 = 0.0
          sum = wxy + wxp1y + wxp1yp1 + wxyp1
          if(sum.eq.0.0) then
c  The eta land point is surrounded by gaussian grid non land
c  Look for nearest gaussian grid land point and assign it to the
c  Eta grid point. Find nearest at this latitude
            do jfnd = iy,nglats
            do ifnd = ix,nglons
            if(ggsli(ifnd,jfnd).eq.1.0) then
                wxy = 1.0
                sum = 1.0
                ix = ifnd
                iy = jfnd
                go to 3356
            end if
            end do
            do ifnd = ix,1,-1
            if(ggsli(ifnd,jfnd).eq.1.0) then
                wxy = 1.0
                sum = 1.0
                ix = ifnd
                iy = jfnd
                go to 3356
            end if
            end do
            end do
       print *,"Oh Oh can't find a land point at:",hlat(i,j),hlon(i,j)
       print *,((ggsli(ii,jj),ii=ix,ix+3),jj=iy,iy+2)
3356        continue
          end if
          wxy = wxy / sum
          wxp1y = wxp1y / sum
          wxp1yp1 = wxp1yp1 / sum
          wxyp1 = wxyp1 / sum
          egrid(i,j) = wxy     * ggrid(ix,iy)     +
     &                 wxp1y   * ggrid(ixp1,iy)   +
     &                 wxp1yp1 * ggrid(ixp1,iyp1) +
     &                 wxyp1   * ggrid(ix,iyp1)
        end if
      end do
      end do
      return
      end

      SUBROUTINE PRINTIMS ( SCVH, MSKSCVH )
C
      REAL      SCVH    (1024,1024)
      INTEGER   MSKSCVH (1024,1024)
C
      DIMENSION ILABEL(64), ILABEL1(64)
C
      DO 10 I=1,64
        ILABEL(I) = I*16
   10 CONTINUE                                                                
C
      WRITE(6,20)                                                          
  20  FORMAT (/' LAND-SEA MASK FOR NESDIS-IMS SNOW-ICE ANAL'/
     &         ' ','   ( LAND=1, SEA/LAKE=0 )')               
C                                                                           
      WRITE(6,*) 
C                                                                 
C   NEXT 64 COLUMNS
      DO 30 J=1024,16,-16
        WRITE(6,40) J, (MSKSCVH(I,J), I=16,1024,16)
  30  CONTINUE
  40  FORMAT( ' ', ' J=', I4, 1X, 64I1)
C
      WRITE(6,50)
  50  FORMAT (//' NESDIS-IMS SNOW-ICE ANAL: '/
     &  ' ',' (ICE-FREE SEA=0, SNOW-FREE LAND=1, ICE=2, SNOW=3)'/) 
C       
C   NEXT 72 COLUMNS                     
      WRITE(6,*)
C
      DO 60 J=1024,16,-16
        WRITE(6,40) J, (MSKSCVH(I,J)+NINT(SCVH(I,J))*2, I=16,1024,16) 
  60  CONTINUE                                                            
C                                                                              
      RETURN
      END

	subroutine coastalfix(egridval,rawval,sm,im,jm,nxin,nyin,
     +				dphd,dlmd,
     +				wbd,sbd,tph0d,tlm0d,gds)
C
C============================================================================
C
C Subroutine written 6 June 2000 to hopefully fix once and for all the
C coastal "smearing" problem seen in soil fields that are bilinearly
C interpolated onto the Eta model's e-grid.  
C
C This routine will make an effort to avoid interpolating soil values
C that are corrupted by being overly close to the coast.  If any of
C the neighbor input points are water, new values of the soil fields
C are calculated as an average of the surrounding non-water points.  
C Not perfect, but better than it was.
C
C This subroutine takes its inspiration (and the nearest neighbor code)
C from the SFCEDAS routine of M. Ek and K. Mitchell.
C
C============================================================================

	real egridval(im,jm,12),rawval(nxin,nyin,12),sm(im,jm)
	real hlat(im,jm),hlon(im,jm),glatr(im,jm),glonr(im,jm)
	real redo(im,jm),rsum(8)
	integer gds(200),icount(8)
	parameter (r2d=57.2957795)
	parameter (dtr=3.141592654/180.)
	parameter (nsoil=8)

	KRADUL=1
      print*,'KRADUL',KRADUL


	write(6,*) 'rawval land/sea mask '
	do J=NYIN,1,-10
	write(6,643) (rawval(I,J,1),I=1,NXIN,13)
	enddo
  643	format(30(f2.0))

C COMPUTE OUTPUT GRID lats AND lons

      tph0=tph0d*dtr
      wb=wbd*dtr
      sb=sbd*dtr
      dlm=dlmd*dtr
      dph=dphd*dtr
      tdlm=dlm+dlm
      tdph=dph+dph
      tph=sb-dph
      ctph0=cos(tph0)
       stph0=sin(tph0)
	
      do j=1,jm
         tlm=wb-tdlm+mod(j+1,2)*dlm
         tph=tph+dph
         stph=sin(tph)
         ctph=cos(tph)
c
        do i=1,im
            tlm=tlm+tdlm
            sinphi=ctph0*stph+stph0*ctph*cos(tlm)
            glatr(i,j)=asin(sinphi)
            coslam=ctph*cos(tlm)/(cos(glatr(i,j))*ctph0)
     .            -tan(glatr(i,j))*tan(tph0)
            coslam=min(coslam,1.)
            fact=1.
            if (tlm .gt. 0.0) fact=-1.
            glonr(i,j)=-tlm0d*dtr+fact*acos(coslam)
	hlat(i,j)=glatr(i,j)*r2d	
	hlon(i,j)=glonr(i,j)*r2d	
C
	if (hlon(i,j).lt.0) hlon(i,j)=hlon(i,j)+360.
C
	if (mod(I,30).eq.0.and.mod(J,30).eq.0) then
C	write(6,*) 'hlat,hlon: ', hlat(i,j),hlon(i,j)
	endif
         enddo
      enddo

C
C  Begin looping through e-grid domain
C	
	redo=0.

	DO 200 J=1,JM
	DO 100 I=1,IM

C IF NON LAND-MASS POINT ON OUTPUT GRID, SKIP TO END OF LOOP (100)
C
          IF ((SM(I,J) .GT. 0.9)) GOTO 100

C DETERMINE LAT/LON OF TARGET (output) GRID POINT
C
        GLATD = HLAT(I,J)
        GLOND = 360. - HLON(I,J)
C
C DETERMINE NEAREST NEIGHBOR FROM INPUT GRID
C
        if (GDS(1).eq.5) then
          call str_ij(GLATD,glond,x,y,gds)
        elseif (GDS(1).eq.3) then
          call lcc_ij(GLATD,glond,x,y,gds)
        elseif(GDS(1).eq.0) then
          call ced_ij(GLATD,glond,x,y,gds)
	else
	write(6,*) 'BAD GDS(1) VALUE...NOT SUPPORTED...STOPPING!'
	write(6,*) 'GDS(1)= ', GDS(1)
	write(6,*) 'GDS(1)= ', GDS(1)
	STOP 666
        endif

	II=INT(X+0.5)
	JI=INT(Y+0.5)

C	rawval has land/sea mask opposite to that of sm (i.e., water=0.)
C
C SEARCH FOR ANY SURROUNDING WATER POINTS (TO A LIMIT OF KRAD=KRADUL)
C
	DO 50 KRAD=1,KRADUL 
	  DO 40 JY = JI-KRAD,JI+KRAD 
	    DO 30 IX = II-KRAD,II+KRAD
C
C-----------------------------------------------------------------------
C CHECK TO SEE IF THIS NEAREST NEIGHBOR (IX,JY) STILL WITHIN IMI,JMI
C DOMAIN
C
                  IF ( (IX .LT. 1) .OR. (IX .GT. NXIN) .OR.
     +                 (JY .LT. 1) .OR. (JY .GT. NYIN) )  THEN
			GOTO 30
		  ENDIF

C IS THIS NEIGHBOR POINT WATER?  IF SO THE VALUE HERE IS SUSPICIOUS
C
C	write(6,*) 'NN , rawval ', IX,JY,rawval(ix,jy,1)
C
                  IF ( rawval(IX,JY,1) .lt. 0.4) THEN
			redo(i,j)=1.
			goto 52
		  ENDIF

  30            CONTINUE
  40          CONTINUE
  50        CONTINUE
C
C-----------------------------------------------------------------------
C
  52	continue

			IF (redo(i,j) .eq. 1) THEN

C	write(6,*) 'redoing at ', i,j

	icount=0
	rsum=0.

	DO 55 KRAD=1,KRADUL
	  DO 45 JY=JI-KRAD,JI+KRAD
	    DO 35 IX=II-KRAD,II+KRAD
C
                  IF ( (IX .LT. 1) .OR. (IX .GT. NXIN) .OR.
     +                 (JY .LT. 1) .OR. (JY .GT. NYIN) )  THEN
                        GOTO 35
                  ENDIF
C
C MAKE SURE THIS POSSIBLE REPLACEMENT ISN'T WATER
C
                  IF ( rawval(IX,JY,1) .lt. 0.4) THEN
                        goto 35
		  ELSE

		do IR=1,8
		rsum(IR)=rsum(IR)+rawval(IX,JY,IR+4)
		icount(IR)=icount(IR)+1
		enddo
			
                  ENDIF

C	
  35            CONTINUE
  45          CONTINUE
  55        CONTINUE

          DO 70 K=1,NSOIL
	    tmphold=egridval(I,J,2*K+3)
Cmp
	if (icount(2*K-1) .gt. 0) then
            egridval(I,J,2*K+3)=rsum(2*K-1)/icount(2*K-1)
	endif

	if (icount(K) .eq. 0 .and. K .eq. 1) then
C	write(6,*) 'NO VALID POINTS....KEEP ORIGINAL VALUE!!!! '
	endif

	if (icount(2*K) .gt. 0) egridval(I,J,2*K+4)=rsum(2*K)/icount(2*K)
	    if (abs(tmphold-egridval(I,J,2*K+3)).gt. 5.) then
C	     write(6,*) 'soil temp: old,new ',tmphold,egridval(I,J,2*K+3)
	    endif
  70      CONTINUE

			ENDIF

 100	CONTINUE
 200	CONTINUE
	
	itot=0

	do J=1,jm
	do I=1,im
	itot=itot+redo(i,j)
	enddo
	enddo

	write(6,*) 'replaced soil values at : ', itot, ' points'

	RETURN
	END

C$$$  sub  PROGRAM DOCUMENTATION BLOCK
C                .      .    .                                       .
C sub  PROGRAM:  gribst      UNPACK GLOBAL Grib SST
C   PRGMMR: GERALD           ORG: W/NMC21     DATE: 95-08-01
C
C ABSTRACT: DECODES GLOBAL AVN, FNL, OR MRF GRIB GRIDDED FIELDS.
C
C PROGRAM HISTORY LOG:
C   95-08-01  GERALD
C   96-07-23  PETERS - UPDATED FOR USE WITH ETA MODEL, GETS 
C                      REYNOLDS 1X1 OISST 
Cmp
Cmp	Changed 99-02-22 by Pyle to use a normal version of GETGB
Cmp
C
C
C USAGE:
C   INPUT FILES:
C     DDNAME1  - GENERIC NAMES & USAGE
C     FTNNF001 - START IN COL 7
C              - BUT TAB CONTINUATIONS TO LINE UP LIKE THIS
C     FXN      - LINE UP DASHES WHEN DESCRIBING FILES
C     TAPENN   - CRAY TYPE DESIGNATION
C     UNITNN   - CRAY TYPE DESIGNATION
C     PARM     - IF PARM FIELD IS USED, DESCRIBE HERE
C
C   OUTPUT FILES:  (INCLUDING SCRATCH FILES)
C     FTMMF001 - NAMES & USAGE AS ABOVE IN THE INPUT SECTION
C     FT06F001 - INCLUDE IF ANY PRINTOUT
C
C   SUBPROGRAMS CALLED: (LIST ALL CALLED FROM ANYWHERE IN CODES)
C     UNIQUE:    - ROUTINES THAT ACCOMPANY SOURCE FOR COMPILE
C     LIBRARY:
C       COMMON   - LIST COMMON LIBRARY ROUTINES, E.G., CONSOL
C       W3LIB    -
C       W4LIB    - DELETE THE CORRESPONDING LINE OR LINES
C       GRAPHICS - IF LIBRARY IS UNNEEDED
C
C   EXIT STATES:
C     COND =   0 - SUCCESSFUL RUN
C          =NNNN - TROUBLE OR SPECIAL FLAG - SPECIFY NATURE
C
C REMARKS: LIST CAVEATS, OTHER HELPFUL HINTS OR INFORMATION
C
C ATTRIBUTES:
C   LANGUAGE: INDICATE EXTENSIONS, COMPILER OPTIONS
C   MACHINE:  CRAY
C
C$$$
C
      subroutine gribst(insst,indxst,gsst,ierr)
c
      Parameter(jf=360*180)
      INTEGER PDS,GDS,GRID
      INTEGER JPDS(200),JGDS(200),IGRD(5,3)
      INTEGER KPDS(200),KGDS(200)
      REAl FLD(jf),out(360,180)
      dimension gsst(361,180)
      logical lb(jf)
      equivalence(out(1,1),fld(1))
c
C
C                sst
      DATA IGRD/ 11, 34,  2, 52, 11,
     *            1,105,102,105,105,
     *            0, 10,  0,  2,  2/
c
C            INPUT UNITS FOR DECODING GRIB FILE
C
          LUGB=INSST
Cmp          LUGI=INDXST
	LUGI=0
          ierr = 0
          j = 0
C
C........    DECODE THE FIELDS
C
        DO 30 GRID = 1,1
C
          DO 10 PDS=1,200
          JPDS(PDS) = -1
   10      CONTINUE
C
             DO 20 GDS = 1,200
           JGDS(GDS) = -1
   20     CONTINUE
C
C........   GET SELECT FIELDS
C
           jPDS(5) = IGRD(GRID,1)
           jPDS(6) = IGRD(GRID,2)
           jPDS(7) = IGRD(GRID,3)
C
C             print *,'call getgb with unit #s ', LUGB,LUGI
	   CALL BAOPEN(LUGB,'sstgrb',IRETBA)
C	write(6,*) 'back from baopen, IRET= ', IRETBA
           CALL GETGB(LUGB,LUGI,JF,j,JPDS,JGDS,
     *                          KF,K,KPDS,KGDS,LB,Fld,IRET)
C
          IF(IRET.NE.0) THEN
            ierr = 1
            WRITE(6,60)IRET
            GO TO 999
          ENDIF
   60  FORMAT(1X,' IRET =',I5)
C
c..   flip grid to PT(1,1) =(0e,-90.0)
c
	write(6,*) 'flipping the data'
              do  jj= 1,180
                do  kk= 1,360
                 gsst(kk,180-jj+1) = out(kk,jj)
                end do
              end do
c
c...   add greenich to right side of grid
c
             do jj = 1,180
               gsst(361,jj) = gsst(1,jj)
             end do
c
Cmp            WRITE(6,61)KPDS,KF,KGDS
Cmp   61  FORMAT(2(/,2X,'PDS=',13I7),2(/,2X,' GDS=',11I7 ))
	write(6,*) 'KPDS= ', (KPDS(I),I=1,12)
	write(6,*) 'KGDS= ', (KGDS(I),I=1,25)
C
   30        CONTINUE
C
  999           CONTINUE
	write(6,*) 'leaving GRIBST'
             return
             END

C
       subroutine putem(hlat,hlon,i1d,sm,sice,ieta)
C
       INCLUDE "parmeta"
C
       real*4 hlat(im,jm),hlon(im,jm)
	integer*4 i1d(360,180), ieta(im,jm)
       real*4 sm(im,jm),sice(im,jm)
C
C   This subroutine moves the value stored in i1d (integer 1 by 1 deg global
C   grid) to the nearest eta land point in the ieta integer array.
C   Special effort is made to ensure that islands are taken care of when
C   not resolved on the 1 x 1 deg. grid.
c
        do j = 1,jm
        do i = 1,im

          if((sm(i,j).gt.0.5).or.(sice(i,j).eq.1.0)) then
            ieta(i,j) = 0
          else
            indx = nint(hlon(i,j) - 179.5)
            if(indx.lt.1) indx = nint(hlon(i,j) + 180.5)
            indy = nint(hlat(i,j) + 90.5)
            if(i1d(indx,indy).ne.0) then
Cmp	     write(6,*) 'assigned a value'
                ieta(i,j) = i1d(indx,indy)
            else
c We have an isolated point and need to look at surrounding
c 1 degree grid points, at this latitude.
                do krad=1,40
		do jj = indy-krad,indy+krad
                do ii=indx-krad,indx+krad
                  itt = min(ii,360)
                  itt = max(itt,1)
                  jtt = min(jj,180)
                  jtt = max(jtt,1)
                  if(i1d(itt,jtt).ne.0) then
                    ieta(i,j) = i1d(itt,jtt)
                    go to 33
                  end if
                end do
                end do
                end do
           print *,"oh oh ",hlat(i,j),hlon(i,j),indx,indy
33              continue
            end if
          end if
        end do
        end do
          return
          end

      SUBROUTINE SNO16GET(SCVH,IYR,IMN,IDY,   INSNOSAB, LIST) 
C                                             
C ABSTRACT: READS THE NESDIS IMS DAILY SNOW/ICE ANALYSIS ON THE
C           1/16TH MESH.
C           SCVH = 0 --- NO SNOW OR ICE
C                  1 --- WITH SNOW/ICE
C
C  INPUT ARGUMENTS:
C     INSNOSAB - UNIT NO. FOR NESDIS WEEKLY SNOW/ICE ANAL
C     LIST     - UNIT NO. FOR PRINT
C  OUTPUT ARGUMENTS:
C     SCVH - REAL SNOW/ICE ANAL FLAGS OF ZEROE'S AND ONE'S
C     IYR  - YEAR  OF ANAL
C     IMN  - MONTH OF ANAL
C     IDY  - DAY   OF ANAL
C  
      REAL SCVH(1024,1024), ICE(1024,1024)
      LOGICAL BITMAP(1024,1024)
Cmp      INTEGER KPDS(25), KGDS(22), JPDS(25), JGDS(22)
	 INTEGER KPDS(200), KGDS(200), JPDS(200), JGDS(200)
C
      JPDS = -1

Cmp  open up the imssnow.grb file

	write(6,*) 'inside  SNO16GET'
	CALL BAOPEN(INSNOSAB,'imssnow.grb',IRETBA)

Cmp      CALL GETGBOPL(INSNOSAB,0,1024*1024,0,JPDS,JGDS,KF,KNUM,KPDS,KGDS,
      CALL GETGB(INSNOSAB,0,1024*1024,0,JPDS,JGDS,KF,KNUM,KPDS,KGDS,
     &     BITMAP,ICE,IRET1)
      WRITE(6,*) 'AFTER GETGB FOR SAB ICE, IRET1=', IRET1
C
      JPDS = -1
Cmp      CALL GETGBOPL(INSNOSAB,0,1024*1024,1,JPDS,JGDS,KF,KNUM,KPDS,KGDS,
      CALL GETGB(INSNOSAB,0,1024*1024,1,JPDS,JGDS,KF,KNUM,KPDS,KGDS,
     &     BITMAP,SCVH,IRET2)
      WRITE(6,*) 'AFTER GETGB FOR SAB SNOW, IRET2=', IRET2
C
      IF (IRET1.NE.0 .OR. IRET2.NE.0) THEN
         WRITE(LIST,*) 'READ ERROR FOR SAB SNOW/ICE, IRET1=',IRET1,
     &      ' IRET2=', IRET2
         CALL EXIT(16)
      ENDIF
C
      IYR2D = KPDS(8)
      IMN = KPDS(9)
      IDY = KPDS(10)
      ICENT = KPDS(21)
      IF(IYR2D.LT.100) THEN
       IYR = (ICENT - 1) * 100 + IYR2D
      ELSE
       IYR = ICENT * 100
      ENDIF
C
      DO 20 I = 1, 1024
        DO 10 J = 1, 1024
           IF (ICE(I,J).GT.0. .OR. SCVH(I,J) .GT.0.) THEN
              SCVH(I,J) = 1.
           ELSE
              SCVH(I,J) = 0.
           ENDIF
 10     CONTINUE
 20   CONTINUE  
      RETURN
      END

      subroutine bilinb(cob,inb,jnb,im,jm,ime,jme,ww,wfbc)
!     **********************************************
!     *                                            *
!     *  routine for bilinear interpolation        *
!     *  of avn parameters into hibu bndry pts     *
!     *                                            *
!     **********************************************
      dimension cob(3,im,jm),inb(4,im,jm),jnb(4,im,jm)
      dimension ww(ime,jme),wfbc(im,jm)
!
              do j=1,jm
          do i=1,im

!
      i00=inb(1,i,j)
      i10=inb(2,i,j)
      i01=inb(3,i,j)
      i11=inb(4,i,j)
!
      j00=jnb(1,i,j)
      j10=jnb(2,i,j)
      j01=jnb(3,i,j)
      j11=jnb(4,i,j)
!
      p=cob(2,i,j)
      q=cob(3,i,j)
      pq=cob(1,i,j)
!
      wfbc(i,j)=ww(i00,j00)+p*(ww(i10,j10)-ww(i00,j00))
     &                     +q*(ww(i01,j01)-ww(i00,j00))
     &   +pq*(ww(i00,j00)-ww(i10,j10)-ww(i01,j01)+ww(i11,j11))
!
	if (i .eq. 1 .and. j .eq. 1) then
C	write(6,*) 'cob ', (cob(l,i,j),l=1,3)
C	write(6,*) 'inb ', (inb(l,i,j),l=1,4)
C	write(6,*) 'jnb ', (jnb(l,i,j),l=1,4)
	if (abs(wfbc(i,j)).gt.1 .and. abs(wfbc(i,j)).lt.100) then
C	write(6,*) 'ww values ',
C     +  ww(i00,j00),ww(i10,j10),
C     +  ww(i01,j01),ww(i11,j11)
C	write(6,*) 'output value: ', wfbc(i,j)
	endif

	endif
          enddo
              enddo
!-----------------------------------------------------------------------
      return
      end
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c===============================================================================
c 
C      subroutine ltlwin(ald,apd,im,jm,pus,pvs,tlm0d,dtr,ctph0,stph0
C     &                 ,tpus,tpvs)
      subroutine ltlwin(ald,apd,pus,pvs,dtr
     &                 ,tpus,tpvs)
!     ******************************************************************
!     *                                                                *
!     *  ll to tll transformation of velocity                          *
!     *                                                                *
!     *  programer: z.janjic, yugoslav fed. hydromet. inst.,           *
!     *             beograd, 1982                                      *
!     *                                                                *
!     ******************************************************************
!
Cmp
	include 'ecommons.h'
      dimension
     & pus(im,jm),pvs(im,jm),tpus(im,jm),tpvs(im,jm)
     &,ald(im,jm),apd(im,jm)
!
              do j=1,jm
          do i=1,im
!
      relm=(ald(i,j)-tlm0d)*dtr
      srlm=sin(relm)
      crlm=cos(relm)
!
      ph=apd(i,j)*dtr
      sph=sin(ph)
      cph=cos(ph)
!
      cc=cph*crlm
      tph=asin(ctph0*sph-stph0*cc)
      rctph=1./cos(tph)
!
      cray=stph0*srlm*rctph
      dray=(ctph0*cph+stph0*sph*crlm)*rctph
!
      tpus(i,j)=dray*pus(i,j)-cray*pvs(i,j)
      tpvs(i,j)=cray*pus(i,j)+dray*pvs(i,j)
!
          enddo
              enddo
!-----------------------------------------------------------------------
      return
      end
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c===============================================================================
C
C
      subroutine gtll(coh,inh,jnh,cov,inv,jnv,ald,apd,ime,jme,gproj,gds)
!-----------------------------------------------------------------------
      include 'ecommons.h'
      parameter(dtr=3.141592654/180.)
!
      character*2 gproj
	integer gds(200)
                 d i m e n s i o n
     & coh(3,im,jm),inh(4,im,jm),jnh(4,im,jm)
     &,cov(3,im,jm),inv(4,im,jm),jnv(4,im,jm)
     &,ald(im,jm),apd(im,jm)
!--------------- hibu domain geometry-----------------------------------

C	write(6,*) 'gds in  dutil: ', (gds(i),i=1,14)
      wb=wbd*dtr
      sb=sbd*dtr
      tph0=tph0d*dtr
      tlm0=tlm0d*dtr
      ctph0=cos(tph0)
      stph0=sin(tph0)
      dlm=dlmd*dtr
      dph=dphd*dtr
      tdlm=dlm+dlm
!-------------- entry to the hibu i,j loop -----------------------------
!               hibu height pts
!-----------------------------------------------------------------------
      tph=sb-dph
              do j=1,jm
          tph=tph+dph
          tlm=wb-tdlm+mod(j+1,2)*dlm
!
          do i=1,im
      tlm=tlm+tdlm
!------------- tll to ll conversion ------------------------------------
      call  rtll(tlm,tph,tlm0d,dtr,ctph0,stph0,almd,aphd)
!-------------conversion from -180,180 range to 0,360 range-------------
!      if(almd.lt.0.) almd=360.+almd
!--------------check if hibu pt is out of avn domain--------------------
	
	if (gproj .eq. 'PS') then
  	  call str_ij(aphd,almd,x,y,gds)
	elseif (gproj .eq. 'LC') then
	  call lcc_ij(aphd,almd,x,y,gds)
	elseif(gproj .eq. 'LL') then
	  call ced_ij(aphd,almd,x,y,gds)
        endif

!
            if (x .lt. 1. .or. x .gt. float(ime) .or.
     .          y .lt. 1. .or. y. gt. float(jme)) then
Cmp     if 360 X 181 grid assume periodicity and adjust the x index accordingly
        if (ime.eq. 360) then
        if (x .lt. 1) x=x+360.
        if (x .gt. ime) x=x-360.
C
	  elseif (ime .eq. 384) then
	  if (x .lt. 0.9) x=x+384
	  if (x .gt. ime) x=x-384
C
	  elseif (ime .eq. 640) then
	  if (x .lt. 0.5) x=x+640
	  if (x .gt. ime) x=x-640
C	  
	elseif (ime .eq. 144) then
C
C	reanalysis grid
C
	if (x .lt. 1) then
	write(6,*) 'aphd,almd,x,y ', aphd,almd,x,y
	if (x .lt. 0.5) x=144
	if (x .gt. 0.5) x=1
	endif

	if (x .gt. ime) then
	write(6,*) 'aphd,almd,x,y ', aphd,almd,x,y
	if (x .gt. ime+0.5) x=1
	if (x .lt. ime+0.5) x=ime
	endif

        else
               print *,'hibupt outside domain i,j=',i,j,aphd,almd,x,y
               stop
	endif
          endif
!
!-----------------------------------------------------------------------
C      coh(2,i,j)=x/delon
C      coh(3,i,j)=y/delat
            coh(2,i,j)=x-float(int(x))
            coh(3,i,j)=y-float(int(y))

      coh(1,i,j)=coh(2,i,j)*coh(3,i,j)
!-----------------------------------------------------------------------
      inh(1,i,j)=int(x)
        if (inh(1,i,j) .eq. 0 ) then
           inh(1,i,j)=ime
        end if
      inh(2,i,j)=inh(1,i,j)+1
      inh(3,i,j)=inh(1,i,j)
      inh(4,i,j)=inh(1,i,j)+1
!
C
C
          if(inh(1,i,j).eq.ime) then
      inh(2,i,j)=1
      inh(4,i,j)=1
          endif
!
      jnh(1,i,j)=int(y)
      jnh(2,i,j)=jnh(1,i,j)
      jnh(3,i,j)=jnh(1,i,j)+1
      jnh(4,i,j)=jnh(1,i,j)+1
          enddo
              enddo
!-----------------------------------------------------------------------
!                      wind points
!-----------------------------------------------------------------------
      tph=sb-dph
              do j=1,jm
          tph=tph+dph
          tlm=wb-tdlm+mod(j,2)*dlm
!
          do i=1,im
      tlm=tlm+tdlm
!--------------------- tll to ll conversion ----------------------------
      call  rtll(tlm,tph,tlm0d,dtr,ctph0,stph0,almd,aphd)
      ald(i,j)=almd
      apd(i,j)=aphd
!-------------conversion from -180,180 range to 0,360 range-------------
!      if(almd.lt.0.) almd=360.+almd
!-----------------------------------------------------------------------
!
!
	if (gproj .eq. 'PS') then
  	  call str_ij(aphd,almd,x,y,gds)
	elseif (gproj .eq. 'LC') then
	  call lcc_ij(aphd,almd,x,y,gds)
	elseif(gproj .eq. 'LL') then
	  call ced_ij(aphd,almd,x,y,gds)
        endif

            if (x .lt. 1. .or. x .gt. float(ime) .or.
     .          y .lt. 1. .or. y. gt. float(jme)) then
Cmp     if 360 X 181 grid assume periodicity and adjust the x index accordingly
        if (ime.eq. 360) then
        if (x .lt. 1) x=x+360.
        if (x .gt. ime) x=x-360.
C
	  elseif (ime .eq. 384) then
	  if (x .lt. 0.9) x=x+384
	  if (x .gt. ime) x=x-384
C	
	  elseif (ime .eq. 640) then
	  if (x .lt. 0.5) x=x+640
	  if (x .gt. ime) x=x-640
C	
        elseif (ime .eq. 144) then
C
C	reanalysis grid
C
	if (x .lt. 1) then
	if (x .lt. 0.5) x=144
	if (x .gt. 0.5) x=1
	endif

	if (x .gt. ime) then
	if (x .gt. ime+0.5) x=1
	if (x .lt. ime+0.5) x=ime
	endif

        else
           print *,'wind point outside domain i,j=',i,j,aphd,almd,x,y
               stop
        endif
            endif

!
!-----------------------------------------------------------------------
      cov(2,i,j)=x-float(int(x))
      cov(3,i,j)=y-float(int(y))
      cov(1,i,j)=cov(2,i,j)*cov(3,i,j)
!-----------------------------------------------------------------------
      inv(1,i,j)=int(x)
        if (inv(1,i,j) .eq. 0) then
           inv(1,i,j)=ime
        endif
      inv(2,i,j)=inv(1,i,j)+1
      inv(3,i,j)=inv(1,i,j)
      inv(4,i,j)=inv(1,i,j)+1
!
          if(inv(1,i,j).eq.ime) then
      inv(2,i,j)=1
      inv(4,i,j)=1
          endif
!
      jnv(1,i,j)=int(y)
      jnv(2,i,j)=jnv(1,i,j)
      jnv(3,i,j)=jnv(1,i,j)+1
      jnv(4,i,j)=jnv(1,i,j)+1
          enddo
              enddo
!-----------------------------------------------------------------------
      return
      end

c
      subroutine blwts(coh,inh,jnh,cov,inv,jnv,ald,apd
     .                ,gproj)
c
c *** Compute bilinear interpolation weights.
c
      implicit none
c
      include 'ecommons.h'
c
      real*4 coh(3,imjm),inh(4,imjm),jnh(4,imjm)
     .      ,cov(3,imjm1),inv(4,imjm1),jnv(4,imjm1)
     .      ,ald(imjm1),apd(imjm1)
     .      ,khl0(jm),kvl0(jm),khh0(jm),kvh0(jm)
     .      ,tdlmd
     .      ,tphd,tlmd,aphd,almd,x,y
c
	integer GDS(200)
      integer khl,khh,kvl,kvh
     .         ,i,j,k
c
      character*2 gproj
c
      integer nxsec,nysec,nzsec
      common /sectorsize/nxsec,nysec,nzsec
c_______________________________________________________________________________
c
      write(6,*) 'in blwts:'
C     print *,'im=',im,'jm=',jm
C     print *,'Input data dimensions:',nxsec,nysec,nzsec
c
c *** Hibu model conts.
c
      do j=1,jm
         khl0(j)=im*(j-1)-(j-1)/2+1
         kvl0(j)=im*(j-1)   - j/2+1
         khh0(j)=im* j      - j/2
         kvh0(j)=im* j   -(j+1)/2
      enddo
c
c *** Define some constants.
c
      tdlmd=dlmd+dlmd
c
c *** Compute weights for hibu height pts.
c
      tphd=sbd-dphd
c
      do j=1,jm
         khl=khl0(j)
         khh=khh0(j)
         tphd=tphd+dphd
c
         do k=khl,khh
            tlmd=wbd+tdlmd*(k-khl)*mod(j,2)
     .          +mod(j+1,2)*(dlmd+(k-khl)*tdlmd)
c
c ********* tll to ll conversion.
c
            call rtll(tlmd,tphd,tlm0d,ctph0,stph0,almd,aphd)
c
c ********* Determine location of eta grid point in native data i,j space.
c
            if (gproj .eq. 'PS') then
	    	call str_ij(aphd,almd,x,y,gds)
            elseif (gproj .eq. 'LC') then
	    	call lcc_ij(aphd,almd,x,y,gds)
            elseif (gproj .eq. 'LL') then
	    	call ced_ij(aphd,almd,x,y,gds)
            endif

c
c ********* Check if hibu pt is out of native data domain.
c
C          print *,'k,lat,lon,x,y ',k,aphd,almd,x,y
            if (x .lt. 1. .or. x .gt. float(nxsec) .or.
     .          y .lt. 1. .or. y. gt. float(nysec)) then 
Cmp               print *,'hibupt outside domain k=',k,aphd,almd,x,y
Cmp	if 360 X 181 grid assume periodicity and adjust the x index accordingly
	if (nxsec .eq. 360) then
	if (x .lt. 1) x=x+360.
	if (x .gt. nxsec) x=x-360.
	else
               print *,'hibupt outside domain k=',k,aphd,almd,x,y
               stop
	endif
            endif
c
            coh(2,k)=x-float(int(x))
            coh(3,k)=y-float(int(y))
            coh(1,k)=coh(2,k)*coh(3,k)
c
            inh(1,k)=int(x)
            inh(2,k)=inh(1,k)+1
            inh(3,k)=inh(1,k)
            inh(4,k)=inh(1,k)+1
c
            jnh(1,k)=int(y)
            jnh(2,k)=jnh(1,k)
            jnh(3,k)=jnh(1,k)+1
            jnh(4,k)=jnh(1,k)+1
c
         enddo
      enddo
c
c *** Compute weights for hibu wind points
c
      tphd=sbd-dphd
c
      do j=1,jm
         kvl=kvl0(j)
         kvh=kvh0(j)
         tphd=tphd+dphd
c
         do k=kvl,kvh
            tlmd=wbd+dlmd*mod(j,2)+(k-kvl)*tdlmd
c
c ********* tll to ll conversion.
c
            call rtll(tlmd,tphd,tlm0d,ctph0,stph0,almd,aphd)
c
            ald(k)=almd
            apd(k)=aphd
c
c ********* Determine location of eta grid point in native data i,j space.
c
            if (gproj .eq. 'PS') then
	    	call str_ij(aphd,almd,x,y,gds)
            elseif (gproj .eq. 'LC') then
              	call lcc_ij(aphd,almd,x,y,gds)
            elseif (gproj .eq. 'LL') then
                call ced_ij(aphd,almd,x,y,gds)
            endif
c
c *** check if hibu pt is out of native data domain.
c
            if (x .lt. 1. .or. x .gt. float(nxsec) .or.
     .          y .lt. 1. .or. y. gt. float(nysec)) then 
cmp               print *,'wind point outside domain k=',k,aphd,almd,x,y
Cmp	if 360 X 181 grid assume periodicity and adjust the x index accordingly
	if (nxsec .eq. 360) then
	if (x .lt. 1) x=x+360.
	if (x .gt. nxsec) x=x-360.
	else
               print *,'wind point outside domain k=',k,aphd,almd,x,y
               stop
	endif
            endif
c
            cov(2,k)=x-float(int(x))
            cov(3,k)=y-float(int(y))
            cov(1,k)=cov(2,k)*cov(3,k)
c
            inv(1,k)=int(x)
            inv(2,k)=inv(1,k)+1
            inv(3,k)=inv(1,k)
            inv(4,k)=inv(1,k)+1
c
            jnv(1,k)=int(y)
            jnv(2,k)=jnv(1,k)
            jnv(3,k)=jnv(1,k)+1
            jnv(4,k)=jnv(1,k)+1
c
         enddo
      enddo
c
      return
      end
c
c===============================================================================
c
      subroutine get_sector_size(fname,gdsfile)
c
      implicit none
c
      integer*4 nx,ny,nz,nxsec,nysec,ip,jp,nsfcfld,l
	integer GDS(200)
      character*(*) fname
      character*(*) gdsfile
      character*2   gproj
c
      common/sectorsize/nxsec,nysec,nz
c_______________________________________________________________________________
c
      print *,' '
      l=index(fname//' ',' ')-1
      print *,'Ingesting data - file = ',fname(1:l)
      open(1,file=fname,status='old',form='unformatted')
	read(1) nz
c
c *** Read sector grid information.
c
	close(14)
	open(14,file=gdsfile,status='old',form='unformatted')
       read(14) GDS

	nxsec=gds(2)
	nysec=gds(3)

      close(1)
      close(14)
      return
      end
c
c===============================================================================
c
      subroutine getdata(fname,pr,uw,vw,ht,mr,sfcgrid)
c
c *** Read input upper air data.
c
      implicit none
c
      real*4 cpi,kappi
      parameter (cpi=1./1004.,kappi=1004./287.)
c
      integer nx,ny,nz,dummy(7),nsfcfld,i,j,k,pres
c
Cmp      real*4 sfcgrid(nx,ny,nsfcfld)
      real*4 sfcgrid(nx,ny,12),tmp
c
c *** Output data variables.
c
      real*4 uw(nx,ny,nz)    !u-wind (m/s)
     .      ,vw(nx,ny,nz)    !v-wind (m/s)
     .      ,ht(nx,ny,nz)    !height (m)
     .      ,mr(nx,ny,nz)    !mixing ratio (kg/kg)
     .      ,pr(nz)          !pressure (Pa)
c
      character*(*) fname
      character*2   gproj
c
      common /sectorsize/nx,ny,nz
c_______________________________________________________________________________
c
      print *,'In getdata'
      print *,'   - data sector size:  ',nx,ny,nz
c     print *,' '
c
c *** Open data file.
c
      open(1,file=fname,status='old',form='unformatted',err=100)
c
c *** Skip through header stuff and surface fields.
c
      rewind(1)

Cmp(2001/12/13 	eliminate header information)

c
c *** Read upper air data.
c        (Read in upside down since that is how ETA wants it.)
c
	write(6,*) 'reading in getdata ', nx,ny,nz

      read(1) dummy(1)
      read(1) (((uw(i,j,k),i=1,nx),j=1,ny),k=nz,1,-1)
      read(1) (((vw(i,j,k),i=1,nx),j=1,ny),k=nz,1,-1)
      read(1) (((ht(i,j,k),i=1,nx),j=1,ny),k=nz,1,-1)
      read(1) (((mr(i,j,k),i=1,nx),j=1,ny),k=nz,1,-1)

	write(6,*) 'U,V,Z,Q : ', uw(nx/2,ny/2,5),vw(nx/2,ny/2,5),
     +			ht(nx/2,ny/2,5),mr(nx/2,ny/2,5)
	read(1) (pr(k),k=nz,1,-1)
        read(1) sfcgrid

      close(1)
c
      do k=1,nz
	pr(k)=pr(k)*100.
      enddo
c
      return
100   print*,'Error reading upper data.'
c
      return
      end

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

	 subroutine str_ij(RLAT,RLON,XPTS,YPTS,KGDS)
      INTEGER KGDS(200)
      REAL XPTS,YPTS,RLON,RLAT
      PARAMETER(RERTH=6.3712E6)
      PARAMETER(PI=3.14159265358979,DPR=180./PI)
C
C       Hardwired for Grid 104
C      data kgds/005,147,110,-268,-139475,8,-105000,90755,90755,
C     +0,64,0/
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	fill=-999

        IM=KGDS(2)
        JM=KGDS(3)
        RLAT1=KGDS(4)*1.E-3
        RLON1=KGDS(5)*1.E-3
        IROT=MOD(KGDS(6)/8,2)
        ORIENT=KGDS(7)*1.E-3
        DX=KGDS(8)
        DY=KGDS(9)
        IPROJ=MOD(KGDS(10)/128,2)
        ISCAN=MOD(KGDS(11)/128,2)
        JSCAN=MOD(KGDS(11)/64,2)
        NSCAN=MOD(KGDS(11)/32,2)
        H=(-1.)**IPROJ
        HI=(-1.)**ISCAN
        HJ=(-1.)**(1-JSCAN)
        DXS=DX*HI
        DYS=DY*HJ
        DE=(1.+SIN(60./DPR))*RERTH
        DR=DE*COS(RLAT1/DPR)/(1+H*SIN(RLAT1/DPR))
        XP=1-H*SIN((RLON1-ORIENT)/DPR)*DR/DXS
        YP=1+COS((RLON1-ORIENT)/DPR)*DR/DYS
        DE2=DE**2
        XMIN=0
        XMAX=IM+1
        YMIN=0
        YMAX=JM+1
        NRET=0
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C  TRANSLATE EARTH COORDINATES TO GRID COORDINATES
        IOPT=-1
        IF(IOPT.EQ.-1) THEN
            IF(ABS(RLON).LE.360.AND.ABS(RLAT).LE.90.AND.
     &                                 H*RLAT.NE.-90) THEN
              DR=DE*TAN((90-H*RLAT)/2/DPR)
C       write(6,*) 'DE,DR ', de,dr
              XPTS=XP+H*SIN((RLON-ORIENT)/DPR)*DR/DXS
              YPTS=YP-COS((RLON-ORIENT)/DPR)*DR/DYS
C       write(6,*) 'xpts,ypts ', xpts,ypts
              IF(XPTS.GE.XMIN.AND.XPTS.LE.XMAX.AND.
     &           YPTS.GE.YMIN.AND.YPTS.LE.YMAX) THEN
                NRET=NRET+1
              ELSE
                XPTS=FILL
                YPTS=FILL
              ENDIF
            ELSE
              XPTS=FILL
              YPTS=FILL
            ENDIF
        ENDIF
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
        return
        END

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

Cfut	subroutine lcc_ij(KGDS,RLAT,RLON,XPTS,YPTS)
	subroutine lcc_ij(RLAT,RLON,XPTS,YPTS,KGDS)

C
C	based on iplib GDSWIZ03 by M. Iredell

C   INPUT ARGUMENT LIST:
C     KGDS     - INTEGER (200) GDS PARAMETERS AS DECODED BY W3FI63
C     RLON     - REAL EARTH LONGITUDE IN DEGREES E
C                (ACCEPTABLE RANGE: -360. TO 360.)
C     RLAT     - REAL EARTH LATITUDE IN DEGREES N 
C                (ACCEPTABLE RANGE: -90. TO 90.)
C

C    OUTPUT ARGUMENT LIST:
C     XPTS     - REAL GRID X POINT COORDINATE 
C     YPTS     - REAL GRID Y POINT COORDINATE

	INTEGER KGDS(200)
	REAL XPTS,YPTS,RLON,RLAT
      PARAMETER(RERTH=6.3712E6)
      PARAMETER(PI=3.14159265358979,DPR=180./PI)

Cmp	hardwired gds for 212 for the moment
C	data kgds/003,185,129,12190,-133459,8,-95000,40365,
C     +		40365,0,64,25000,25000,187*-1/

	fill=-999

	
        IM=KGDS(2)
        JM=KGDS(3)
        RLAT1=KGDS(4)*1.E-3
        RLON1=KGDS(5)*1.E-3
        IROT=MOD(KGDS(6)/8,2)
        ORIENT=KGDS(7)*1.E-3
        DX=KGDS(8)
        DY=KGDS(9)
        IPROJ=MOD(KGDS(10)/128,2)
        ISCAN=MOD(KGDS(11)/128,2)
        JSCAN=MOD(KGDS(11)/64,2)
        NSCAN=MOD(KGDS(11)/32,2)
        RLATI1=KGDS(12)*1.E-3
        RLATI2=KGDS(13)*1.E-3
        H=(-1.)**IPROJ
        HI=(-1.)**ISCAN
        HJ=(-1.)**(1-JSCAN)
        DXS=DX*HI
        DYS=DY*HJ
        IF(RLATI1.EQ.RLATI2) THEN
          AN=SIN(H*RLATI1/DPR)
        ELSE
          AN=LOG(COS(RLATI1/DPR)/COS(RLATI2/DPR))/
     &       LOG(TAN((H*RLATI1+90)/2/DPR)/TAN((H*RLATI2+90)/2/DPR))
        ENDIF
        DE=RERTH*COS(RLATI1/DPR)*TAN((H*RLATI1+90)/2/DPR)**AN/AN
        IF(H*RLAT1.EQ.90) THEN
          XP=1
          YP=1
        ELSE
          DR=DE/TAN((H*RLAT1+90)/2/DPR)**AN
          DLON1=MOD(RLON1-ORIENT+180+3600,360.)-180
          XP=1-H*SIN(AN*DLON1/DPR)*DR/DXS
          YP=1+COS(AN*DLON1/DPR)*DR/DYS
        ENDIF
        ANTR=1/(2*AN)
        DE2=DE**2
        XMIN=0
        XMAX=IM+1
        YMIN=0
        YMAX=JM+1
        NRET=0
C
C  TRANSLATE EARTH COORDINATES TO GRID COORDINATES
C

            IF(ABS(RLON).LE.360.AND.ABS(RLAT).LE.90.AND.
     &                                 H*RLAT.NE.-90) THEN
              DR=DE*TAN((90-H*RLAT)/2/DPR)**AN
              DLON=MOD(RLON-ORIENT+180+3600,360.)-180
              XPTS=XP+H*SIN(AN*DLON/DPR)*DR/DXS
              YPTS=YP-COS(AN*DLON/DPR)*DR/DYS
C	write(6,*) 'executed... ', xpts,ypts
              IF(XPTS.GE.XMIN.AND.XPTS.LE.XMAX.AND.
     &           YPTS.GE.YMIN.AND.YPTS.LE.YMAX) THEN
                NRET=NRET+1
              ELSE
                XPTS=FILL
                YPTS=FILL
              ENDIF
            ELSE
              XPTS=FILL
              YPTS=FILL
            ENDIF

	return
	end
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

	subroutine ced_ij(RLAT,RLON,XPTS,YPTS,KGDS)

	integer kgds(200)

	fill=-999
	LROT=-999
	
	IM=KGDS(2)
        JM=KGDS(3)
        RLAT1=KGDS(4)*1.E-5
        RLON1=KGDS(5)*1.E-5
        RLAT2=KGDS(7)*1.E-5
        RLON2=KGDS(8)*1.E-5
        ISCAN=MOD(KGDS(11)/128,2)
        JSCAN=MOD(KGDS(11)/64,2)
        NSCAN=MOD(KGDS(11)/32,2)
        HI=(-1.)**ISCAN
        HJ=(-1.)**(1-JSCAN)
        DLON=HI*(MOD(HI*(RLON2-RLON1)-1+3600,360.)+1)/(IM-1)
        DLAT=(RLAT2-RLAT1)/(JM-1)
        XMIN=0
        XMAX=IM+1
        IF(IM.EQ.NINT(360/ABS(DLON))) XMAX=IM+2
        YMIN=0
        YMAX=JM+1
        NRET=0

            IF(ABS(RLON).LE.360.AND.ABS(RLAT).LE.90) THEN
              XPTS=1+HI*MOD(HI*(RLON-RLON1)+3600,360.)/DLON
              YPTS=1+(RLAT-RLAT1)/DLAT
              IF(XPTS.GE.XMIN.AND.XPTS.LE.XMAX.AND.
     &           YPTS.GE.YMIN.AND.YPTS.LE.YMAX) THEN
                NRET=NRET+1
                IF(LROT.EQ.1) THEN
                  CROT=1
                  SROT=0
                ENDIF
              ELSE
                XPTS=FILL
                YPTS=FILL
              ENDIF
            ELSE
              XPTS=FILL
              YPTS=FILL
            ENDIF

	return
	end

      subroutine eta_const
c
c *** Original code received from U. of Athens and modified at FSL.
c
c *** Two-dimensional horizontal indexing into one-dimensional,     
c     defines dummy initial and boundary moisture values        
c     and calculates constants needed for the one-dimensional  
c     version of the ub/nmc model.                            

C	revisions adapted from Z. Janjic version of this code.  Now 
C	stays in im,jm indexing, and seems to produce better results

c
      implicit none
c
      include 'ecommons.h'
c
      real*4 pt,aeta(lm),eta(lmp1),dfl(lmp1),detac(lm)

	REAL,ALLOCATABLE:: RES(:,:),SNO(:,:)
	REAL,ALLOCATABLE:: SST(:,:),SI(:,:),CMC(:,:),ALBEDO(:,:)

	REAL,ALLOCATABLE:: HBM2(:,:),VBM2(:,:),VBM3(:,:)
	REAL,ALLOCATABLE:: SM(:,:),SICE(:,:),HTM(:,:,:),VTM(:,:,:)
c
      real*4 pdb(kb,2)
     .      ,tb(kb,lm,2),qb(kb,lm,2)
     .      ,ub(kb,lm,2),vb(kb,lm,2)
     .      ,pd(im,jm)
     .      ,pdt(im,jm),fist(im,jm)  

	REAL,ALLOCATABLE:: TT(:,:,:),UT(:,:,:),VT(:,:,:),QT(:,:,:)
	REAL,ALLOCATABLE:: SFCGRID(:,:,:),SMC(:,:,:),STC(:,:,:)
	REAL,ALLOCATABLE:: SH2O(:,:,:)

       real dum2(im,jm)

c
C	real smc,stc,tg
     	real	tg(im,jm)
      integer*4 idat(3),ihrst,ntsd,i,j,k,l,len,II,JJ
	common /mytime/idat
	real*4 pdmin
c
      logical run
c_______________________________________________________________________________
c
      print*,'im,jm=',im,jm

c
      len=index(init_out//' ',' ')-1
      if (init_out(len:len) .ne. '/') then
         len=len+1
         init_out(len:len)='/'
      endif
      open(1,file=init_out(1:len)//'preproc.init'
     .    ,status='old',form='unformatted')

	ALLOCATE(UT(IM,JM,LM),VT(IM,JM,LM),TT(IM,JM,LM),QT(IM,JM,LM))
	ALLOCATE(SM(IM,JM),RES(IM,JM))
	write(6,*) 'to preproc.init read'
C
C	       L   I3    I    
      read(1) run,idat,ihrst,ntsd,ut,vt
	write(6,*) 'middle of preproc.init read'
      read(1) tt,qt,pdt,fist,sm,res,eta,pt,detac,aeta,dfl            
	write(6,*) 'past preproc.init read'

	write(6,*) 'some res values: ', (res(i,jm/2),i=1,im)
	

C        do J=jm,1,-1
C        write(6,666) (pdt(i,j)/100.,i=im-18,im)
C        enddo
  666   format(20(f5.0,1x))

	ALLOCATE(SFCGRID(IM,JM,12))
	read(1) sfcgrid
	
	ALLOCATE(STC(IM,JM,NSOIL),SMC(IM,JM,NSOIL))

	
	if (GRIBSOIL .and. .NOT. REAN) then

	write(6,*) 'pulling soil from sfcgrid'

	do K=1,4
          do j=1,jm
            do i=1,im
              stc(i,j,K)=sfcgrid(i,j,2*K+3)
              smc(i,j,K)=sfcgrid(i,j,2*K+4)
            enddo
          enddo
	enddo

C Isabel Jul2016 Include soil layers
        do K=5,8
           do j=1,jm
             do i=1,im
               stc(i,j,K)=sfcgrid(i,j,11)
               smc(i,j,K)=sfcgrid(i,j,12)
             enddo
           enddo
        enddo    
C Isabel


	endif

      close(1)
c
	ALLOCATE(HBM2(IM,JM),VBM2(IM,JM),VBM3(IM,JM),HTM(IM,JM,LM))
	ALLOCATE(VTM(IM,JM,LM),SICE(IM,JM),SNO(IM,JM))
	ALLOCATE(SST(IM,JM),SI(IM,JM),ALBEDO(IM,JM),SH2O(IM,JM,NSOIL))
      call cnsts(pt,aeta,eta,dfl,detac
     .          ,res,fist,sno,sst,si,albedo
     .          ,hbm2,vbm2,vbm3,sm,sice,htm,vtm,smc,stc,tg,sh2o)
c
	do j=1,jm
	do i=1,im
         res(i,j)=1./res(i,j)                                                  
        enddo
	enddo
C
      print *,' '
      print *,'Creating eta initial condition file...'
      print *,'Write to file : ',init_out(1:len)//'init.file'
      open(1,file=init_out(1:len)//'init.file'
     .    ,status='unknown',form='unformatted')
      write(1) run,idat,ihrst,ntsd

Cmp----------------------------
	write(6,*) 'in CONST: pd values'
	pdmin=9999999.
	do JJ=jm,1,-1
	do II=1,IM
	if (pdt(II,JJ) .lt. pdmin) pdmin=pd(II,JJ)
	enddo
	enddo
	write(6,*) 'pdmin in CONST is: ', pdmin
      write(1) pdt
      write(6,*) 'pdt: ',pdt(1,1),pdt(21,21),pdt(im,jm)
Cmp---------------------------
      write(1) res
C-----------------------------
	write(6,*) 'fist: ', fist(1,1),fist(21,21),fist(im,jm)
      write(1) fist
C-----------------------------
      do l=1,lm
	do j=1,jm
	do i=1,im
	dum2(i,j)=ut(i,j,l)
	enddo
	enddo
         write(1) dum2
        print *,'u: ',L,dum2(1,1),dum2(21,21),dum2(im,jm)
      enddo

	DEALLOCATE(UT)
C-----------------------------
      do l=1,lm
	do j=1,jm
        do i=1,im
        dum2(i,j)=vt(i,j,l)
        enddo
        enddo
         write(1) dum2
        if (l.eq.20) print *,'v:',dum2(1,1),dum2(21,21),dum2(im,jm)
      enddo
	DEALLOCATE(VT)
C----------------------------
      do l=1,lm
	do J=1,jm
	do I=1,im
	dum2(i,j)=tt(i,j,l)
	enddo
	enddo
         write(1) dum2
        if (l.eq.20) print *,'t:',dum2(1,1),dum2(21,21),dum2(im,jm)
      enddo
	DEALLOCATE(TT)
C------------------------------
      do l=1,lm
        do J=1,jm
        do I=1,im
        dum2(i,j)=qt(i,j,l)
        enddo
        enddo
         write(1) dum2
        if (l.eq.20) print *,'q:',dum2(1,1),dum2(21,21),dum2(im,jm)
      enddo
	DEALLOCATE(QT)
C------------------------------
C	wet --> si
	write(6,*) 'SI VALUES'
	do JJ=JM,1,-JM/30
	write(6,969) (si(II,JJ),II=1,IM,IM/12)
  969	format(25(f4.2,1x))
	enddo
      write(1) si
	write(6,*) 'SNO VALUES'
	do JJ=JM,1,-JM/30
	write(6,969) (sno(II,JJ),II=1,IM,IM/12)
	enddo

	do J=1,jm
	do I=1,im
	if (smc(i,j,1) .eq. 0. .and. sm(i,j) .eq. 0) then
!	write(6,*) 'LAND POINT WITH ZERO SMC VAL: ', I,J,SICE(I,J)
	do II=1,nsoil
	SMC(I,J,II)=0.14
	STC(I,J,II)=271.
	enddo
	endif
	enddo
	enddo
      write(1) sno
      write(1) smc

	DEALLOCATE(SNO,SMC)
C-----------------------------------
C  SET VEGETATION CANOPY WATER CONTENT EQUAL TO ZERO EVERYWHERE FOR NOW
	ALLOCATE(CMC(IM,JM))
	cmc=0.
      write(1) cmc
	DEALLOCATE(CMC)
C-----------------------------------
	do JJ=1,JM
	do II=1,IM
	if (STC(II,JJ,1) .eq. 0 .and. sm(II,JJ) .eq. 0) then
	write(6,*) 'STC zero at land point!!! ', II,JJ
	endif
	enddo
	enddo
      write(1) stc
	write(6,*) ' soil tmps (layer 1) '
	do JJ=JM,1,-JM/30
	write(6,922) (stc(II,JJ,1),II=1,IM,IM/12)
  922	format(25(f4.0,1x))
	enddo

	DEALLOCATE(STC)

	write(6,*) 'sh2o values: '
        do JJ=JM,1,-JM/30
        write(6,923) (sh2o(II,JJ,1),II=1,IM,IM/12)
	enddo

	write(1) sh2o
	deallocate (sh2o)
	write(6,*) 'albedo values: '
        do JJ=JM,1,-JM/30
        write(6,923) (albedo(II,JJ),II=1,IM,IM/12)
	enddo
  923	format(25(f4.2,1x))

	write(1) albedo
	deallocate (albedo)
C-------------------------------------
      close(1)
      end                                        
c
c===============================================================================
c
      subroutine cnsts(pt,aeta,eta,dfl,detac
     .                ,res,fis,sno,sst,si,albedo
     .                ,hbm2,vbm2,vbm3,sm,sice,htm,vtm
     .		      ,smc,stc,tg,sh2o)
c
c *** Routine for initialization of constants and variables         
c
      implicit none
c
      include 'ecommons.h'
      include 'econstants.h'
c
      integer*4 itb,jtb,itbq,jtbq,JJ,NSOTYP,NFLT

      parameter (itb=76,jtb=134
     .          ,itbq=152,jtbq=440)

      real frh2o,rsnow,snofac

c
c     common/pteta/                       
      real*4 pt,aeta(lm),eta(lmp1),dfl(lmp1),detac(lm)
     .      ,res(im,jm),fis(im,jm),sno(im,jm)              
     .      ,sst(im,jm),si(im,jm),cmc(im,jm)
c
c     common/masks/                        
      real*4 hbm2(im,jm),vbm2(im,jm),vbm3(im,jm)
     .      ,sm(im,jm),sice(im,jm)  
     .      ,htm(im,jm,lm),vtm(im,jm,lm)

C
C       COMMON /OLDALB/ ALBASE(IM,JM)
       REAL ALBASE(IM,JM)
C

c
      real*4 dxj(jm),wpdarj(jm),cpgfuj(jm),curvj(jm),fcpj(jm)      
     .      ,fdivj(jm),emj(jm),emtj(jm),fadj(jm)                  
     .      ,ddmpuj(jm),ddmpvj(jm),hdacj(jm)                              
     .      ,qsold(jtb),pold(jtb),qsnew(jtb),pnew(jtb)                  
     .      ,y2p(jtb),app(jtb),aqp(jtb)                              
     .      ,theold(jtb),told(jtb),thenew(jtb),tnew(jtb)                  
     .      ,y2t(jtb),apt(jtb),aqt(jtb)                              

Cmp
C	real smc,stc,tg
	real smc(im,jm,nsoil),stc(im,jm,nsoil),
     +			tg(im,jm),sh2o(im,jm,nsoil),bx,fk
Cmp
c
      integer*4 khla(jam),khha(jam),kvla(jam),kvha(jam)                  
     .         ,khl2(jm),khh2(jm),kvl2(jm),kvh2(jm),kvl                  
Cmp     .	       ,ihw(jm),ihe(jm),ivw(jm),ive(jm),ihl,ihh
     .	       ,ihl,ihh,ihe,ihw
c
      integer lmh(im,jm),lmv(im,jm)                                        
c
      real*4 rdeta(lm),f4q2(lm),diff
     .      ,em(jam),emt(jam)                                          
     .      ,dx(im,jm),wpdar(im,jm),cpgfu(im,jm),curv(im,jm),fcp(im,jm) 
     .      ,fdiv(im,jm),fad(im,jm),f(im,jm),ddmpu(im,jm),ddmpv(im,jm) 
     .      ,glat(im,jm),glon(im,jm),glatr(im,jm),glonr(im,jm)        
     .      ,deta2(lm),aeta2(lm),eta2(lmp1),dfrlg(lmp1)                         
     .      ,qs0(jtb),sqs(jtb),the0(itb),sthe(itb)                  
     .      ,epsr(im,jm),gffc(im,jm)         
     .      ,hdac(im,jm),hdacv(im,jm)                                        
     .      ,ptbl(itb,jtb),ttbl(jtb,itb)                                  
cds new convection
     .      ,ttblq(jtbq,itbq),the0q(itbq),stheq(itbq)
c
      integer*4 idum2(im,jm),idat(3),ierr
c
      real*4 deta1(lm),aeta1(lm),eta1(lmp1)                                
     .      ,dum2(im,jm),dum2b(im,jm),dum2a(im,jm)
     .      ,dum2sm(im,jm)
c
      integer*4 kpm,kpm1,kthm,kthm1,kvh,khl,khh
     .         ,nddamp
     .         ,list,len,i,j,k,l,ja,nfcst,nbc,nx,ny
c
      real*4 vegfrc(im,jm),sldpth(nsoil),rtdpth(nsoil)
     .      ,f4d,f4q,ctlm,ef4t,stlm,aph,stph,ctph,tlm
     .      ,sinphi,coslam,fp,fact,thl,en,ent,dy,cpgfv
     .      ,dtad,tsph,acdt,dxp,wbi
     .      ,rdph,rdlm,sbi,anbi,ebi
     .      ,rdq,rdth,rdthe,rdtheq,rdp,rdpq
     .      ,pl,pt1,pt2,r1,ph,tph0,tph,tdph,tdlm,cddamp
     .      ,thh,ti0,wb,dph,dlm,sb

C Soil parameter arrays used in cold start SH2O initialization
       real,allocatable:: PSIS(:),BETA(:),SMCMAX(:)
       
       REAL  PSISG(15),BETAG(15),SMCMAXG(15)
       REAL  PSISD(18),BETAD(18),SMCMAXD(18)
       REAl  PSISZ(9),BETAZ(9),SMCMAXZ(9)
C--------------------------------------------------------------
c
	INTEGER*4 I1D(360,180),IONETA(im,jm), JULM(13),JULD,
     .  ILON1,ILON2,ILAT1,ILAT2,ILONX,ILATX,GDS(200)
     .  
       REAL*4 ALBC1(361,180),ALBC2 (361,180),ALBC3(361,180),
     .	  ALBC4(361,180),ALBC  (361,180),ALBEDO(IM,JM),
     .		SNALMX(361,180),MXSNAL(IM,JM),
     .   S1,S2,W1,W2,AR1,AR2,AR3,AR4,H1,D5,D01,HM1,ELON,ELAT,
     .    H90,H360,WGT1,WGT2,D00,DIF,alb1d(IMJM),radfac

        real,allocatable:: GGSTC1(:,:),GGSTC2(:,:)
        real,allocatable:: GGSMC1(:,:),GGSMC2(:,:)
        real,allocatable:: SSTRAW(:,:),SNOWRAW(:,:)
        real,allocatable:: GGLAND(:,:),GGICE(:,:)
        
        parameter(nx=192,ny=94)


	parameter (H1=1.0,D5=5.E-1,D01=1.00E-2,HM1=-1.0,
     .	H90=90.0,H360=360.0,D00=0.0,radfac=57.295777951)
    
Cmp
	common /mytime/idat
	DATA JULM/0,31,59,90,120,151,181,212,243,273,304,334,365/
c
c *** Universal constants.
c
      real*4 a,twom,SNUP,SALP,ARX
      data a/6376000./,twom/.00014584/
      DATA SNUP,SALP /0.040, 2.6/

c
c *** Dissipation & turbulence.
c
      real*4 coac,codamp,tddamp,dfc,ddfc
	data codamp/0150.00/,w/0.25/
CGSM     .    ,tddamp/48.00/,dfc/01./,ddfc/8.0/
     .    ,tddamp/72.00/,dfc/01./,ddfc/1.0/
     
c
c
c *** Surface data.
c
Cmp	these should be same as operational now.

      real*4 ros,cs,ds,aks,dzg,tg0,tga,roi,ci,di,aki,dzi,elwv,plq
      data ros/1500./,cs/1339.2/,ds/.100/,aks/.0000005  /,dzg/02.50/       
     .,tg0/258.16/,tga/30./                                             
     .,roi/916.6/,ci/2060.0/,di/.100/,aki/.000001075/,dzi/2.0/          
     .,ti0/271.16/                                                      
     .,elwv/2.50e6/                                                     
     .,plq/70000./

C-----------------------------------------------------------------------
C Constants/data used in cold start SH2O initialization
	REAL HLICE, GRAV, BLIM
C      DATA HLICE/3.335E5/,GRAV/9.81/,T0/273.15/
      DATA HLICE/3.335E5/,GRAV/9.81/
      DATA BLIM/5.5/
      
      logical vegflag
      logical noz,lusaf
      
C Parameter used in cold start SH2O initialization
C      write(6,*) 'lendo a QUANTIDADE DE TIPOS DE SOLO '
      open(1,file='TYPSOLO',form='formatted',status='old')
      read(1,10)NSOTYP
10    format(I2)    
C      write(6,*) 'leu a QUANTIDADE DE TIPOS DE SOLO '
      close(1)
C      NSOTYP=15
      print*,"QUANTIDADE DE TIPOS DE SOLO",NSOTYP
      
      allocate (PSIS(NSOTYP),BETA(NSOTYP),SMCMAX(NSOTYP)) 

CPARAMETROS ZOGBLER
      DATA PSISZ /0.04,0.62,0.47,0.14,0.10,0.26,0.14,0.36,0.04/
      DATA BETAZ /4.26,8.72,11.55,4.74,10.73,8.17,6.77,5.25,4.26/
      DATA SMCMAXZ /0.421,0.464,0.468,0.434,0.406,
     &             0.465,0.404,0.439,0.421/
CPARAMETROS ZOGBLER

CDANIEL PARAMETROS CLASIFICACION DE MOIRA
       DATA PSISD /0.265,0.103,0.252,0.106,0.088,0.052,
     &           0.109,0.042,0.018,0.424,0.400,0.220, 
     &           0.601,0.500,0.132,0.929,1.294,0.8500/
       DATA BETAD /2.02,2.78,3.03,2.25,2.62,3.02,
     &           1.97,2.53,2.98,2.13,2.44,2.90,
     &           2.01,2.42,2.97,2.81,1.83,2.29/
       DATA SMCMAXD /0.240,0.354,0.514,0.402,0.477,0.564,
     &             0.440,0.566,0.631,0.443,0.517,0.566,
     &             0.478,0.562,0.675,0.505,0.534,0.580/
CDANIEL

CAROL PARAMETROS NEW GLOBAL SOIL 
      DATA PSISG /0.069,0.036,0.141,0.759,0.759,0.355,
     &           0.135,0.617,0.263,0.098,0.324,0.468, 
     &           0.355,0.069,0.036/
      DATA BETAG /2.79,4.26,4.74,5.33,5.33,5.25,
     &           6.66,8.72,8.17,10.73,10.39,11.55,
     &           5.25,2.79,4.26/
      DATA SMCMAXG /0.339, 0.421, 0.434, 0.476, 0.476, 0.439,
     &            0.404, 0.464, 0.465, 0.406, 0.468, 0.468,
     &            0.439, 0.200, 0.421/
CAROL      
C-----------------------------------------------------------------------

c_______________________________________________________________________________
c
      
      IF (NSOTYP.eq.15) THEN
	   PSIS=PSISG
	   BETA=BETAG
       	   SMCMAX=SMCMAXG
      ENDIF
      
      IF (NSOTYP.eq.9) THEN	
       	   PSIS=PSISZ
	   BETA=BETAZ
	   SMCMAX=SMCMAXZ
      ENDIF
      
      IF (NSOTYP.eq.18) THEN	
	    PSIS=PSISD
	    BETA=BETAD
	    SMCMAX=SMCMAXD
      ENDIF
      
      namelist/VEG/vegflag

CJLG     
	write(6,*) 'lendo VEGETATION '
       open(1,file='VEGETATION',form='formatted',status='old')
       read(1,VEG)
       close(1)
	write(6,*) 'leu VEGETATION '
CJLG      

c------------------------------------------------------------------------------------------------------
Cmp
	tg=-99.
Cmp
      noz=.true.
      list=3
	nfcst=13
	nbc=16

	write(6,*) 'executing cnsts....GRIBSOIL is: ', GRIBSOIL

	write(6,*) 'const believes there are ', nsoil, ' soil layers'

Cmp
Cmp	compute coac based on resolution!
Cmp	
Cmp	coac=.04*(.53846154/DPHD)**2.


C	removed squaring per t. black recommendation

	   
CGSM 1km	tddamp=nhour

	coac=.04*(.53846154/DPHD)

C	cap at 0.2
CGSM	coac=amin1(coac,0.2)
CGSM        coac=amin1(coac,0.35)

CGSM 1km
      IF (DPHD.LT.0.108) THEN

!GSM        coac=(0.04+0.08*(0.108-DPHD)/0.099)*(.53846154/DPHD)
!GSM          coac=0.8
!GSM          coac=1
!GSM          coac=0.35
!GSM          coac=0.583
!GSM          coac=1.01 
!GSM          coac=0.6
          coac=0.6
      ENDIF

	write(6,*) 'computed coac based on grid resolution...'
	write(6,*) 'will use coac, dfc, ddfc, tddamp= ', coac, dfc, ddfc,tddamp
Cmp

c *** Derived vertical constants.
c
      do l=1,lmp1                             
         dfrlg(l)=dfl(l)                            
         dfl(l)=dfl(l)*g                            
      enddo
c
c *** Dummy constants.
c
      do l=1,lmp1                             
         eta1(l)=eta(l)                                                    
         eta2(l)=eta(l)                                                    
      enddo
      do l=1,lm                              
         deta1(l)=detac(l)                                                  
         aeta1(l)=aeta(l)                                                  
         deta2(l)=detac(l)                                                  
         aeta2(l)=aeta(l)                                                  
      enddo
c
c *** Derived geometrical constants.
c
      tph0=tph0d*dtr                                                    
      wb=wbd*dtr                                                        
      sb=sbd*dtr                                                        
      dlm=dlmd*dtr                                                      
      dph=dphd*dtr                                                      
      tdlm=dlm+dlm                                                      
      tdph=dph+dph                                                      
      rdlm=1./dlm                                                       
      rdph=1./dph                                                       
c                                                                       
      wbi=wb+tdlm                                                       
      sbi=sb+tdph                                                       
      ebi=wb+im2*tdlm                                                   
      anbi=sb+jm3*dph                                                   
c                                                                       
c     stph0=sin(tph0)                                                   
c     ctph0=cos(tph0)                                                   
c
c *** Time stepping related constants.
c
      tsph=3600./dt                                                     
      nddamp=tddamp*tsph+.5                                             
c                                                                       
      dtad=idtad                                                        
c
c *** Derived horizontal grid constants.
c
      dy=a*dph                                                          
      cpgfv=-dt/(48.*dy)                                                
      en= dt/( 4.*dy)*dtad                                              
      ent=dt/(16.*dy)*dtad                                              
c                                                                       
      tph=sb-dph                                                        
      do j=1,jm                                            
C      ihw(j)=-mod(j,2)
C      ihe(j)=ihw(j)+1
C      ivw(j)=-mod(j+1,2)
C      ive(j)=ivw(j)+1
c                                                                       
         tph=tph+dph                                               
         dxp=a*dlm*cos(tph)                                        
         dxj(j)=dxp                                                
cvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
csd      wpdarj(j)=-dt*w/(32.*dxp*dy)                      
csd      wpdarj(j)=-dt*w*100000./(32.*dxp*dy)                      
         wpdarj(j)=-w*((a*dlm*amin1(cos(anbi),cos(sbi)))**2+dy**2)
     .            /(dt*32.*dxp*dy)*.88
caaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa
         cpgfuj(j)=-dt/(48.*dxp)                                   
         curvj(j)=.5*dt*tan(tph)/a                                 
         fcpj(j)=dt/(cp*192.*dxp*dy)                               
         fdivj(j)=1./(12.*dxp*dy)                                  
         emj(j)= dt/( 4.*dxp)*dtad                                 
         emtj(j)=dt/(16.*dxp)*dtad                                 
         fadj(j)=-dt/(48.*dxp*dy)*dtad                             
Cmp         acdt=coac*dt                                              
Cmp     .       *sqrt((a*dlm*amin1(cos(anbi),cos(sbi)))**2+dy**2)     
        ACDT=DT
     2            *SQRT((A*DLM*AMIN1(COS(ANBI),COS(SBI)))**2+DY**2)
Cmp         cddamp=codamp*acdt                                        
         cddamp=.04*codamp*acdt                                        
Cmp         hdacj(j)=acdt/(4.*dxp*dy)                                 
         hdacj(j)=coac*acdt/(4.*dxp*dy)                                 
         ddmpuj(j)=cddamp/dxp                                      
         ddmpvj(j)=cddamp/dy                                       
      enddo
c
c *** Spreading of upstream height-point advection factor.
c
      ja=0                                                              
      do j=3,5                                              
         ja=ja+1                                                       
      khla(ja)=2
      khha(ja)=im-1-mod(j+1,2)
         emt(ja)=emtj(j)                                               
      enddo

      do j=jm4,jm2                                          
         ja=ja+1                                                       
         khla(ja)=2                                 
         khha(ja)=im-1-mod(j+1,2)                                            
         emt(ja)=emtj(j)                                               
      enddo

      do j=6,jm5                                            
         ja=ja+1                                                       
	khla(ja)=2
        khha(ja)=2+mod(j,2)
        emt(ja)=emtj(j)                                               
      enddo

      do j=6,jm5                                            
         ja=ja+1                                                       
      khla(ja)=im-2
      khha(ja)=im-1-mod(j+1,2)
      emt(ja)=emtj(j)
      enddo
      print*,'ja=',ja,' jam=',jam
c
c *** Spreading of upstream velocity-point advection factor.
c
      ja=0                                                              
      do j=3,5                                              
         ja=ja+1                                                       
	 kvla(ja)=2
         kvha(ja)=im-1-mod(j,2)
         em(ja)=emj(j)                                                 
      enddo

      do j=jm4,jm2                                          
         ja=ja+1                                                       
         kvla(ja)=2     
         kvha(ja)=im-1-mod(j,2)                                           
         em(ja)=emj(j)                                                 
      enddo

      do j=6,jm5                                            
         ja=ja+1                                                       
         kvla(ja)=2                                          
         kvha(ja)=2+mod(j+1,2)                                              
         em(ja)=emj(j)                                                 
      enddo

      do j=6,jm5                                            
         ja=ja+1                                                       
         kvla(ja)=im-2
         kvha(ja)=im-1-mod(j,2)
         em(ja)=emj(j)                                                 
      enddo
c
c *** Coriolis parameter in tll system & related constants.
c
      tph=sb-dph                                                
      do j=1,jm                                            
c                                                                       
         tlm=wb-tdlm+mod(j,2)*dlm                                  
         tph=tph+dph                                               
         stph=sin(tph)                                             
         ctph=cos(tph)                                             
c                                                                       
         do i=1,im                                             
            tlm=tlm+tdlm                                                      
            fp=twom*(ctph0*stph+stph0*ctph*cos(tlm))                          
            f(i,j)=0.5*dt*fp                                                    
         enddo
      enddo
c
c *** Geographic lat and long of tll grid points.
c
      tph=sb-dph                                                
      do j=1,jm                                            
         tlm=wb-tdlm+mod(j+1,2)*dlm                                
         tph=tph+dph                                               
         stph=sin(tph)                                             
         ctph=cos(tph)                                             
c                                                                       
	do i=1,im
            tlm=tlm+tdlm                                                      
            sinphi=ctph0*stph+stph0*ctph*cos(tlm)                             
            glatr(i,j)=asin(sinphi)
            coslam=ctph*cos(tlm)/(cos(glatr(i,j))*ctph0)
     .            -tan(glatr(i,j))*tan(tph0) 
            coslam=min(coslam,1.)
            fact=1.                                                           
            if (tlm .gt. 0.0) fact=-1.
            glonr(i,j)=-tlm0d*dtr+fact*acos(coslam)                            
         enddo
      enddo
c
c *** Derived vertical grid constants.
c
      ef4t=.5*dt/cp                                                     
      f4q =   -dt*dtad                                                  
      f4d =-.5*dt*dtad                                                  
      do l=1,lm                          
         rdeta(l)=1./detac(l)                        
         f4q2(l)=-.25*dt*dtad/detac(l)               
      enddo
c
c *** Boundary masks.
c
      do j=1,jm                                          
	do i=1,im
         hbm2(i,j)=0.                                                        
         vbm2(i,j)=0.                                                        
         vbm3(i,j)=0.                                                        
	enddo
      enddo
	
      do j=3,jm2                                            
         do i=2,im-1-mod(j+1,2)                                      
            hbm2(i,j)=1.                                                        
         enddo
	 do i=2,im-1-mod(j,2)
            vbm2(i,j)=1.
         enddo
      enddo

      do j=4,jm3                                            
          do i=2+mod(j+1,2),im-2
            vbm3(i,j)=1.                                                        
          enddo
      enddo
c
c *** Topography masks & maximum vertical indices.
c
	do j=1,jm
         do i=1,im                                          
         lmh(i,j)=lm                                                         
         lmv(i,j)=lm                                                         
         enddo
	enddo
      do l=1,lm                              
      do j=1,jm                                          
	do i=1,im
         htm(i,j,l)=1.                                                       
         vtm(i,j,l)=1.                                                       
        enddo
      enddo
      enddo
c
c *** Topography masks & maximum vertical indices.
c
      if (.not. sigma) then                                            
c
      DO L=1,LM
       DO J=1,JM
        DO I=1,IM
         IF(LMH(I,J).EQ.LM.AND.ETA(L+1).GE.RES(I,J)) LMH(I,J)=L
        ENDDO
       ENDDO
      ENDDO

c                                                                       
         do l=1,lm                              
         do j=1,jm                                          
	 do i=1,im
            if (eta(l+1) .gt. res(i,j)) htm(i,j,l)=0.
              IF(I.EQ.33.AND.J.EQ.33) THEN
               DIFF=ETA(L+1)-RES(I,J)
               WRITE(6,28000)I,J,L,ETA(L+1),RES(I,J),DIFF
28000          FORMAT(1X,3I6,3(1X,E18.11))
              ENDIF
         enddo
         enddo
	 enddo
c                                                                       
      DO L=1,LM
       DO J=2,JM1
        IHE=MOD(J+1,2)
        IHW=IHE-1
        KHL=1+MOD(J,2)
        KHH=IM-1
        DO I=KHL,KHH
           IF(ETA(L+1).GT.RES(I,J)) THEN
                  VTM(I+IHE,J,L)=0.
                  VTM(I+IHW,J,L)=0.
                  VTM(I,J-1,L)=0.
                  VTM(I,J+1,L)=0.
           ENDIF
        ENDDO
       ENDDO
      ENDDO

c                                                                       

      DO L=1,LM
       DO J=2,JM1
       KVL=2-MOD(J,2)
         DO I=KVL,IM-1
           IF(LMV(I,J).EQ.LM.AND.VTM(I,J,L).LT.0.1) LMV(I,J)=L-1
         ENDDO
       ENDDO
      ENDDO

c
      endif
c

C next 80 lines or so from operational CNSTS.f
C--------------SPREADING OF LATITUDE DEPENDENT CONSTANTS----------------

      DO J=1,JM
        DO I=1,IM
c       KHH=IM-1+MOD(J,2)
c       DO I=1,KHH
          DX(I,J)=DXJ(J)
Cmp          WPDAR(I,J)=WPDARJ(J)*HBM2(I,J)
	if (.not. SIGMA) then
          WPDAR(I,J)=WPDARJ(J)*HBM2(I,J)
	else
	  if (I .eq. 1 .and. J .eq. 1) then
	 	write(6,*) 'REDUCING WPDAR BECAUSE RUNNING IN SIGMA!!!'
	  endif
	WPDAR(I,J)=WPDARJ(J)*HBM2(I,J)*0.5
	endif
          FCP(I,J)=FCPJ(J)
          FDIV(I,J)=FDIVJ(J)
          FAD(I,J)=FADJ(J)
          HDAC(I,J)=HDACJ(J)*1.25*HBM2(I,J)
c       ENDDO
c       KVH=IM-MOD(J,2)
c       DO I=1,KVH
          HDACV(I,J)=HDACJ(J)
          CPGFU(I,J)=CPGFUJ(J)
          CURV(I,J)=CURVJ(J)
        ENDDO
      ENDDO
C--------------INCREASING DIFFUSION ALONG THE BOUNDARIES----------------
      DO J=3,JM2
        IF (J.LE.5.OR.J.GE.JM4) THEN
          KHH=IM-2+MOD(J,2)
          DO I=2,KHH
           HDAC(I,J)=HDAC(I,J)* DFC
          ENDDO
        ELSE
          KHH=2+MOD(J,2)
          DO I=2,KHH
           HDAC(I,J)=HDAC(I,J)* DFC
          ENDDO
          KHH=IM-2+MOD(J,2)
          DO I=IM-2,KHH
           HDAC(I,J)=HDAC(I,J)* DFC
          ENDDO
        ENDIF
      ENDDO
CMEB          KHL2(J)=IM*(J-1)-(J-1)/2+2 ! 2 if j odd or j even
CMEB          KHL3(J)=IM*(J-1)-J/2+3     ! 3 if j odd, 2 if j even
CMEB          KHH2(J)=IM*J-J/2-1         ! IM-1 if j odd, IM-2 if j even
CMEB          KHH3(J)=IM*J-(J+1)/2-1     ! IM-2 if j odd, or even

C-----------------------------------------------------------------------
      DO J=1,JM
CMEB          KVL0(J)=IM*(J-1)-J/2+1  1 if j odd, 1 if J even
CMEB          KVH0(J)=IM*J-(J+1)/2    IM-1 if j odd, IM if J even
        KVH=IM-MOD(J,2)
        DO I=1,KVH
         DDMPU(I,J)=DDMPUJ(J)*VBM2(I,J)
         DDMPV(I,J)=DDMPVJ(J)*VBM2(I,J)
         HDACV(I,J)=HDACV(I,J)*VBM2(I,J)
	 write(1201,*)I,J,DDMPU(I,J),VBM2(I,J)
        ENDDO
      ENDDO
C--------------INCREASING DIFFUSION ALONG THE BOUNDARIES----------------
      DO J=3,JM2
CMEB          KVL3(J)=IM*(J-1)-(J-1)/2+2 2 if j odd, 3 if j even
CMEB          KVL2(J)=IM*(J-1)-J/2+2     2 if j odd or even
CMEB          KVH2(J)=IM*J-(J+1)/2-1     IM-2 if j odd, IM-1 if j even
CMEB          KVH3(J)=IM*J-J/2-2         IM-2 if j odd or even
        IF (J.LE.5.OR.J.GE.JM4) THEN
          KVH=IM-1-MOD(J,2)
          DO I=2,KVH
            DDMPU(I,J)=DDMPU(I,J)*DDFC
            DDMPV(I,J)=DDMPV(I,J)*DDFC
            HDACV(I,J)=HDACV(I,J)* DFC
          ENDDO
        ELSE
          KVH=3-MOD(J,2)
          DO I=2,KVH
            DDMPU(I,J)=DDMPU(I,J)*DDFC
            DDMPV(I,J)=DDMPV(I,J)*DDFC
            HDACV(I,J)=HDACV(I,J)* DFC
          ENDDO
          KVH=IM-1-MOD(J,2)
          DO I=IM-2,KHH
            DDMPU(I,J)=DDMPU(I,J)*DDFC
            DDMPV(I,J)=DDMPV(I,J)*DDFC
            HDACV(I,J)=HDACV(I,J)* DFC
          ENDDO
        ENDIF
      ENDDO

c
c *** Surface parameters.


	if (REAN) then
	write (6,*) 'PROCESSING THE REANALYSIS FILE!'

C       special section for reanalysis data
C

        allocate(GGSTC1(nx,ny),GGSTC2(nx,ny))
        allocate(GGSMC1(nx,ny),GGSMC2(nx,ny))
        allocate(SSTRAW(nx,ny),SNOWRAW(nx,ny))
        allocate(GGLAND(nx,ny),GGICE(nx,ny))

        call snowsoilsst(im,jm,tlm0d,tph0d,dlmd,dphd,rean_sfc,
     +  GGSTC1,GGSTC2,GGSMC1,GGSMC2,SSTRAW,SNOWRAW,GGLAND,GGICE,GDS)

        call process_gaus(im,jm,tlm0d,tph0d,dlmd,dphd,sm,stc,smc,sst,
     +  sice,si,GGSTC1,GGSTC2,GGSMC1,GGSMC2,SSTRAW,SNOWRAW,GGLAND,GGICE,
     +  gds)

	do J=1,JM
	do I=1,IM
	if (smc(i,j,1) .eq. 0. .and. sm(i,j) .eq. 0.) then
	write(6,*) 'post process_gaus, bad smc ', i,j
	endif
	enddo
	enddo

        deallocate(GGSTC1,GGSTC2,GGSMC1,GGSMC2,SSTRAW,
     +		SNOWRAW,GGLAND,GGICE)


C       end special section for reanalysis data
	endif
C----------------------------------------
c
C READ MAX SNOW ALBEDO FILE
C 90N-20N VIA DAVE ROBINSON, JCAM, 1985, VOL. 24, 402-411
C 20N-90S VIA LAND-SFC TYPE 'CORRELATED' TO ROBINSON DATABASE
C SNALMX = GLOBAL 1-DEG x 1-DEG MAXIMUM SNOW ALBEDO
C Units in percent, later converted to fraction
C values over sea=0.0 (non-land mass)
C values over land between 21.0 and 80.0
	write(6,*) 'snalmx values read in:'
      READ(20)SNALMX
	do J=150,10,-10
	write(6,663) (.01*snalmx(i,j),i=1,361,20)
	enddo
  663	format(20(f4.2,1x))
C-----------------------------------------------------------------------
C READ ALBEDO FILES
C GLOBAL 1-DEG x 1-DEG (4) SEASONAL SNOWFREE ALBEDO
C 90N-90S VIA MATTHEWS ***get reference
C ALBC1 = 3-MONTH AVERAGE CENTERED ON 31 Jan
C ALBC2 = 3-MONTH AVERAGE CENTERED ON 30 Apr
C ALBC3 = 3-MONTH AVERAGE CENTERED ON 31 Jul
C ALBC4 = 3-MONTH AVERAGE CENTERED ON 31 Oct
C Units in percent, later converted to fraction
C values over sea=6.0 (non-land mass)
C values over land between 11.0 and 32.0 (exception, glacier=0.75)
C *NOTE: in future, replace w/high-res 0.144-deg albedo NESDIS database
C   ...and follow similar spatial/temporal averaging for greenness frac
C

	
      READ(21)ALBC1
      READ(22)ALBC2
      READ(23)ALBC3
      READ(24)ALBC4

C fIND jULIAN DAY OF YEAR TO DO THE TEMPORAL INTERPOLATION
      JULD = JULM(IDAT(1)) + IDAT(2)
      IF(JULD.LE.32) THEN
        S1 = 32 - JULD
        S2 = JULD + 30
        WGT1 = S2/(S1+S2)
        WGT2 = S1/(S1+S2)
        DO J = 1,180
        DO I = 1,361
        ALBC(I,J) = WGT1 * ALBC1(I,J) + WGT2 * ALBC4(I,J)
        END DO
        END DO
      ELSE IF(JULD.LE.121.AND.JULD.GT.32) THEN
        S1 = 121 - JULD
        S2 = JULD - 32
        WGT1 = S2/(S1+S2)
        WGT2 = S1/(S1+S2)
        DO J = 1,180
        DO I = 1,361
        ALBC(I,J) = WGT1 * ALBC2(I,J) + WGT2 * ALBC1(I,J)
        END DO
        END DO
      ELSE IF(JULD.LE.213.AND.JULD.GT.121) THEN
        S1 = 213 - JULD
        S2 = JULD - 121
        WGT1 = S2/(S1+S2)
        WGT2 = S1/(S1+S2)
        DO J = 1,180
        DO I = 1,361
        ALBC(I,J) = WGT1 * ALBC3(I,J) + WGT2 * ALBC2(I,J)
        END DO
        END DO
      ELSE IF(JULD.LE.305.AND.JULD.GT.213) then
        S1 = 305 - JULD
        S2 = JULD - 213
        WGT1 = S2/(S1+S2)
        WGT2 = S1/(S1+S2)
        DO J = 1,180
        DO I = 1,361
        ALBC(I,J) = WGT1 * ALBC4(I,J) + WGT2 * ALBC3(I,J)
        END DO
        END DO
      ELSE
        S1 = 365 - JULD + 32
        S2 = JULD - 305
        WGT1 = S2/(S1+S2)
        WGT2 = S1/(S1+S2)
        DO J = 1,180
        DO I = 1,361
        ALBC(I,J) = WGT1 * ALBC1(I,J) + WGT2 * ALBC4(I,J)
        END DO
        END DO
      END IF
C
C BEGIN SPATIAL INTERPOLATION FOR BASELINE SNOWFREE ALBEDO AND MAX SNOW
C ALBEDOS
C
      DO J=1,JM
        DO I=1,IM
Cnew
                ALBASE(I,J)=20.
                MXSNAL(I,J)=55.
Cnew
          IF (SM(I,J) .LT. 0.9) THEN
C
C-----------------------------------------------------------------------
C IF LANDMASS, DETERMINE LAT,LON AND WEIGHTS
C
      ELAT=90.+glatr(I,J)/DTR
      ELON=360.-glonr(I,J)/DTR
      IF(ELON.GT.360.)ELON=ELON-360.
      ILON1=INT(ELON)
      DIF=ELON-ILON1
      IF(DIF.GT.D5)ILON1=ILON1+1
      IF(ILON1.EQ.D00)ILON1=360
      ILON2=ILON1+1
      ILAT1=INT(ELAT)
      DIF=ELAT-ILAT1
      IF(DIF.GT.D5)ILAT1=MIN(ILAT1+1,179)
      ILAT2=ILAT1+1
      W1=ELON-ILON1+D5
      IF(W1.LT.D00)W1=W1+360.
      W2=ELAT-ILAT1+D5
C
      AR1=W1*W2
      AR2=W1*(H1-W2)
      AR3=(H1-W1)*(H1-W2)
      AR4=(H1-W1)*W2
C-----------------------------------------------------------------------
C INTERPOLATE BASELINE SNOWFREE ALBEDO TO E GRID
C INPUT:  ALBC (GLOBAL 1-DEG x 1-DEG)
C OUTPUT: ALBASE (SPECIFIED ETA GRID)
C
C INTERPOLATE MAX SNOW ALBEDO TO E GRID
C INPUT:  SNALMX (GLOBAL 1-DEG x 1-DEG)
C OUTPUT: MXSNAL (SPECIFIED ETA GRID)
C
C DOING BOTH BASELINE SNOWFREE ALBEDO AND MAX SNOW ALBEDO INTERPOLATIONS
C IN THE SAME BLOCK IS POSSIBLE SINCE THEY HAVE IDENTICAL LAND-SEA MASKS
c            IF ( (ALBC(ILON2,ILAT2) .NE. 0.) .AND.
c     .           (ALBC(ILON2,ILAT1) .NE. 0.) .AND.
c     .           (ALBC(ILON1,ILAT1) .NE. 0.) .AND.
c     .           (ALBC(ILON1,ILAT2) .NE. 0.) ) THEN
c the quarterly mathews albedo data base sea values = 6.0
C beginning lat/long=-90,0 (southpole, prime meredian)
c lowest land value = 11.0
c max non-glacial value about 32.0 +/-
c glacial value = 75.0
            IF ( (ALBC(ILON2,ILAT2) .GT. 7.) .AND.
     .           (ALBC(ILON2,ILAT1) .GT. 7.) .AND.
     .           (ALBC(ILON1,ILAT1) .GT. 7.) .AND.
     .           (ALBC(ILON1,ILAT2) .GT. 7.) ) THEN
C-----------------------------------------------------------------------
C ALL 4 SURROUNDING POINTS ARE LAND POINTS
              ALBASE(I,J)=AR1*ALBC(ILON2,ILAT2)+
     .                    AR2*ALBC(ILON2,ILAT1)+
     .                    AR3*ALBC(ILON1,ILAT1)+
     .                    AR4*ALBC(ILON1,ILAT2)
              MXSNAL(I,J)=AR1*SNALMX(ILON2,ILAT2)+
     .                    AR2*SNALMX(ILON2,ILAT1)+
     .                    AR3*SNALMX(ILON1,ILAT1)+
     .                    AR4*SNALMX(ILON1,ILAT2)
C
c            if(i.eq.303 .and .j.eq.143 .or.
c     &         i.eq.309 .and. j.eq.143) then
c           if(mod(i,20).eq.0 .and. mod(j,20).eq.0) then
c              print *,'albase ',i,j,ar1,ar2,ar3,ar4,ALBC(ILON2,ILAT2),
c     &            ALBC(ILON2,ILAT1),ALBC(ILON1,ILAT1),
c     &            ALBC(ILON1,ILAT2),ALBASE(I,J)
c              print *,'mxsnal ',i,j,ar1,ar2,ar3,ar4,SNALMX(ILON2,ILAT2),
c     &            SNALMX(ILON2,ILAT1),SNALMX(ILON1,ILAT1),
c     &            SNALMX(ILON1,ILAT2),MXSNAL(I,J)
c            endif
C
            ELSE
C-----------------------------------------------------------------------
C ONE OR MORE OF THE 4 SURROUNDING POINT ARE NOT LAND POINTS
C TAKE NEAREST NEIGHBOR LAND POINT IN THE FOLLOWING ORDER:
C (ILON2,ILAT2),(ILON2,ILAT1),(ILON1,ILAT1),(ILON1,ILAT2)
C
              ARX=-999.
              IF (ALBC(ILON2,ILAT2) .GT. 7.) THEN
                IF (AR1 .GT. ARX) THEN
                  ARX=AR1
                  ILONX=ILON2
                  ILATX=ILAT2
                ENDIF
              ENDIF
              IF (ALBC(ILON2,ILAT1) .GT. 7.) THEN
                IF (AR2 .GT. ARX) THEN
                  ARX=AR2
                  ILONX=ILON2
                  ILATX=ILAT1
                ENDIF
              ENDIF
              IF (ALBC(ILON1,ILAT1) .GT. 7.) THEN
                IF (AR3 .GT. ARX) THEN
                  ARX=AR3
                  ILONX=ILON1
                  ILATX=ILAT1
                ENDIF
              ENDIF
              IF (ALBC(ILON1,ILAT2) .GT. 7.) THEN
                IF (AR4 .GT. ARX) THEN
                  ARX=AR4
                  ILONX=ILON1
                  ILATX=ILAT2
                ENDIF
              ENDIF
C-----------------------------------------------------------------------
C Use nearest land neighbor:
              IF (ARX .GT. 0.) THEN
                ALBASE(I,J)=ALBC(ILONX,ILATX)
                MXSNAL(I,J)=SNALMX(ILONX,ILATX)
              ELSE
C-----------------------------------------------------------------------
C NO SURROUNDING POINTS ARE LAND (ARX=-999):
C SET DEFAULT SNOWFREE ALBEDO=20 PERCENT, DEFAULT SNOWALB=55 PERCENT
                ALBASE(I,J)=20.
                MXSNAL(I,J)=55.
                PRINT *,'AT: LAT,LON',ELAT,ELON
                PRINT *,'SNOWFREE ALBEDO SET TO DEFAULT VALUE OF 20%'
                PRINT *,'MAX SNOW ALBEDO SET TO DEFAULT VALUE OF 55%'
C-----------------------------------------------------------------------
C end of ALBASE,MXSNAL land points<4 block
              ENDIF
C-----------------------------------------------------------------------
C end of ALBASE,MXSNAL interpolation block
            ENDIF
C-----------------------------------------------------------------------
C end of land (SM=0) block
          ENDIF
C-----------------------------------------------------------------------
C CONVERT ALBEDO UNITS: PERCENT TO FRACTION
          ALBASE(I,J)=ALBASE(I,J)*D01
          MXSNAL(I,J)=MXSNAL(I,J)*D01
        ENDDO
      ENDDO

Cmp    END ALBEDO SECTION **************************************************

      tph=sb-dph                                                
      print *,' '

	if (.NOT. REAN) then
	CALL SSTHIRES(sst,sm,glatr,glonr,IDAT,6,DTR)
	write(6,*) 'back from SSTHIRES call'
	endif

	lusaf=.true.
	if (.NOT. REAN) then
	CALL SNOHIRES(si,sm,glatr,glonr,6,LUSAF,DTR)
	write(6,*) 'back from SNOHIRES call'
	endif

	write(6,*) 'STPH0= ', stph0
      do j=1,jm                                            
	TLM=WB-TDLM+MOD(J+1,2)*DLM
        TPH=TPH+DPH
        STPH=SIN(TPH)
        CTPH=COS(TPH)
        KHH=IM-MOD(J,2)
	do i=1,im
          TLM=TLM+TDLM
          CTLM=COS(TLM)
          STLM=SIN(TLM)
          APH=ASIN(STPH0*CTPH*CTLM+CTPH0*STPH)

Cmp	operational line only used if dont have snowdepth data
        if (.NOT.lusaf.and.sm(i,j).lt.0.9) then
        write(6,*) 'NOT LUSAF!'
	SI(I,J)=0.333*SI(I,J)*SIN(APH)
	endif

        enddo
      enddo
	do J=1,JM
	do I=1,IM
	if (smc(i,j,1) .eq. 0. .and. sm(i,j) .eq. 0.) then
	write(6,*) 'pre important doloop, bad smc ', i,j
	endif
	enddo
	enddo


C------------------------------------------------
c
C  DO-LOOP BELOW DEFINES SOME MASKS AND CHANGES THE MEANING OF OTHERS.
C  MASKS DEFINITIONS FOLLOWING THIS DO-LOOP ARE THOSE CONVENTIONS
C    EXPECTED BY ETA MODEL.
C  --
C  PRIOR TO THIS DO-LOOP:
C
C    SM      LANDMASS (=0), OPEN SEA OR SEAICE (=1)
C    SI      SM=0
C              SI=SNOW DEPTH (0 TO 10.9 M)
C            SM=1
C              SI=1, SEAICE
C              SI=0, OPEN SEA
C    SNO     UNDEFINED
C    SICE    UNDEFINED
C    ALBEDO  UNDEFINED
C  --
C  AFTER THIS DO-LOOP:
C
C    SM      LANDMASS OR SEAICE (=0), OPEN SEA (=1)
C    SI      SNOW DEPTH (M) (ALWAYS ZERO OVER OPEN SEA OR SEAICE)
C    SNO     SNOW WATER EQUIVALENT (M), = 0.2*SI
C    SICE    SICE=0
C              LANDMASS OR OPEN SEA
C            SICE=1
C              SEAICE
C    ALBEDO  SM=1
C              ALBEDO=0.06 OVER OPEN SEA
C            SM=0
C              SICE=0, ALBEDO=DYNAMIC LAND ALBEDO, A FUNCTION OF THE
C                BASELINE SNOWFREE ALBEDO (ALBASE, FROM MATTHEWS) AND
C                INCLUDING A SNOW EFFECT (FROM ROBINSON)
C                SO, DYNAMIC LAND ALBEDO=FCT(ALBASE,MXSNAL,SNO)
C              SICE=1, ALBEDO=0.60 OVER SEAICE
C-----------------------------------------------------------------------
C
      DO J=1,JM
        DO I=1,IM

   	  IF (REAN .and. SICE(I,J) .eq. 1) SI(I,J)=1

	  SICE(I,J)=0.
          SNO (I,J)=0.
          IF(ALBEDO(I,J).GT.0.99999999)    ALBEDO(I,J)=0.99999999

        IF(SM(I,J).GT.0.9) THEN
C  SEA
          EPSR(I,J)=.97
          GFFC(I,J)=0.
          ALBEDO(I,J)=.06
	  ALBASE(I,J)=.06

          IF(SI (I,J).GT.0.    ) THEN
C  SEA-ICE
            SM(I,J)=0.
	    SI(I,J)=0.
            SICE(I,J)=1.
             TG(I,J)=TI0
            GFFC(I,J)=ROI*CI*AKI/DZI
            ALBEDO(I,J)=.60
            ALBASE(I,J)=.60
          END IF

        ELSE
C  LAND
          EPSR(I,J)=1.0
          GFFC(I,J)=ROS*CS*AKS/DZG
          SICE(I,J)=0.
          SNO(I,J)=SI(I,J)*.20
        END IF
        ENDDO
      ENDDO
Cmp
C	convert lat/lon from rad to deg
	do J=1,JM
	do I=1,IM
	glon(I,J)=360.-glonr(I,J)*radfac
	glat(I,J)=glatr(I,J)*radfac
	if (glon(i,j) .ge. 360.) glon(I,J)=glon(I,J)-360.
	enddo
	enddo

	if (.NOT. GRIBSOIL) then
	CALL READSFC(glat,glon,sm,sice,smc,stc,tg)
	endif

C-----------------------------------------------------------------------
      DO J=1,JM
       DO I=1,IM
        GFFC(I,J)=GFFC(I,J)*HBM2(I,J)
        EPSR(I,J)=EPSR(I,J)*HBM2(I,J)
       ENDDO
      ENDDO

c
c *** Coarse look-up table for saturation point.
c
      kthm=jtb                                                          
      kpm=itb                                                           
      kthm1=kthm-1                                                      
      kpm1=kpm-1                                                        
c                                                                       
      thl=210.                                                          
      thh=350.                                                          
      pl=pt                                                             
      ph=105000.                                                        
      r1=r
      pt1=pt
c-----------------------------------------------------------------------
csd new convection
      call table(ptbl,ttbl,pt
     .          ,rdq,rdth,rdp,rdthe,pl,thl,qs0,sqs,sthe,the0)
      call tableq(ttblq,rdpq,rdtheq,plq,thl,stheq,the0q)
c-----------------------------------------------------------------------
      len=index(init_out//' ',' ')-1

      open(1,file=init_out(1:len)//'cnst.file'
     .    ,status='unknown',form='unformatted')
c
      write(1)                                                      
     . nfcst,nbc,list
     .,dt,idtad,sigma                                                   
     .,khla,khha,kvla,kvha,khl2,khh2,kvl2,kvh2
c
      write(1) lmh
      write(1) lmv
      write(1) hbm2 
      write(1) vbm2 
      write(1) vbm3 
      write(1) sm
Cmp
        write(6,*) 'sea ice being written'
        do J=jm,1,-JM/5
        write(6,372) (sice(I,J),I=1,im,2)
  372   format(50(f2.0))
        enddo

      write(1) sice
      do l=1,lm
         write(1) ((htm(i,j,l),i=1,im),j=1,jm)
      enddo
      do l=1,lm
         write(1) ((vtm(i,j,l),i=1,im),j=1,jm)
      enddo
      write(1) dy,cpgfv,en,ent,r,pt,tddamp
     .        ,f4d,f4q,ef4t,detac,rdeta,aeta,f4q2,eta,dfl
     .        ,em,emt
      write(1) dx
      write(1) wpdar
      write(1) cpgfu
      write(1) curv
      write(1) fcp
      write(1) fdiv
      write(1) fad
      write(1) f
      write(1) ddmpu
      write(1) ddmpv
      pt2=pt
      write(1) pt2,glatr
      write(1) glonr
      write(1) plq,rdpq,rdtheq,stheq,the0q
      write(1) ros,cs,ds,roi,ci,di
     .        ,pl,thl,rdq,rdth,rdp,rdthe
     .        ,deta2,aeta2,dfrlg
     .        ,qs0,sqs,sthe,the0
      write(1) mxsnal
      write(1) epsr
Cmp
	do J=1,jm
	 do I=1,im
	  tg(I,J)=amax1(stc(I,J,4),273.15)
	 enddo
	enddo
Cmp
      write(1) tg
      write(1) gffc 

C  20020531
C
C       9-point filter SST data

        do NFLT=1,4
        do J=2,JM-1
        do I=2,IM-1
        SST(I,J)=0.25*SST(I,J)+0.125*(SST(I+1,J)+SST(I-1,J)+
     &                               SST(I,J+1)+SST(I,J-1))
     &               +0.0625*(SST(I+1,J+1)+SST(I+1,J-1)+
     &                        SST(I-1,J+1)+SST(I-1,J-1))
        enddo
        enddo
        enddo

      write(1) sst
C
	write(6,*) 'sample SST values '
	do J=jm,1,-JM/30
	write(6,369) (sst(I,J),I=1,im,IM/12)
  369	format(31(f4.0,x))
	enddo
C
      write(1) albase
      write(1) hdac
      write(1) hdacv
      write(1) ttblq
      write(1) ptbl,ttbl
     .        ,r1,pt1,tsph
     .        ,wbd,sbd,tlm0d,tph0d,dlmd,dphd,tlm0d,dp30
     .        ,x1p,y1p,ixm,iym
     .        ,deta1,aeta1,eta1

C NEW CONTENT *********************************************

C    TIME TO WRITE THE SOIL MODEL STUFF TO NHIBU (1)
C
	
C **   FIRST THE VEGETATION TYPES ************************

       REWIND 30
       READ (30) I1D
C        SET DEFAULT FOR ETA LAND FAR FROM LAND IN GLOBAL
       IONETA=7
              CALL PUTEM(glat,glon,I1D,sm,si,IONETA)
	write(6,*) 'writing vegetation type'
	if (vegflag) then
          read(45)IONETA
          write(6,*) 'read new vegetation map'
        endif
	write(6,*)'Done vegetation type'
       WRITE(1) IONETA

	write(6,*) 'sample veg type values '
	do J=jm,1,-jm/30
	write(6,431) (IONETA(I,J),I=1,im,im/10)
  431	format(60(I2,x))
	enddo

C **   SECOND THE SOIL TYPES TYPES **********************

      IF ((NSOTYP.eq.15).or.(NSOTYP.eq.18)) THEN
          read(49)IONETA
      ELSEIF (NSOTYP.eq.9) THEN	
	 REWIND 31
         READ (31) I1D
C        SET DEFAULT FOR ETA LAND FAR FROM LAND IN GLOBAL
       IONETA=2
          CALL PUTEM(glat,glon,I1D,sm,si,IONETA)
       DO J = 1,JM
         DO I = 1,IM
         IF(IONETA(I,J).EQ.13) IONETA(I,J) = 9
         END DO
       END DO
      ENDIF
      
       write(6,*) 'writing soil type'
       WRITE(1) IONETA
	write(6,*) 'sample soil type values'
	do J=jm,1,-jm/30
	write(6,397) (IONETA(I,J),I=1,im,im/10)
  397	format(60(i2,x))
	enddo
       
C Add sh2o stuff right here
	DO 200 J=1,JM
	DO 100 I=1,IM
	DO 70 K=1,NSOIL
C ----------------------------------------------------------------------
C cold start:  determine liquid soil water content (SH2O)
C SH2O <= SMC for T < 273.149K (-0.001C)
C
Cnew
C
	if (SM(I,J) .eq. 1) then
	STC(I,J,K)=amax1(273.15,STC(I,J,K))
	endif
C
Cnew
C
            IF (STC(I,J,K) .LT. 273.149) THEN
C ----------------------------------------------------------------------
C first guess following explicit solution for Flerchinger Eqn from Koren
C et al, JGR, 1999, Eqn 17 (KCOUNT=0 in FUNCTION FRH2O).
              BX = BETA(IONETA(I,J))
              IF ( BETA(IONETA(I,J)) .GT. BLIM ) BX = BLIM
              FK = (((HLICE/(GRAV*(-PSIS(IONETA(I,J)))))*
     1             ((STC(I,J,K)-T0)/STC(I,J,K)))**
     1             (-1/BX))*SMCMAX(IONETA(I,J))
              IF (FK .LT. 0.02) FK = 0.02
              SH2O(I,J,K) = MIN ( FK, SMC(I,J,K) )
C ----------------------------------------------------------------------
C now use iterative solution for liquid soil water content using
C FUNCTION FRH2O (from the Eta "NOAH" land-surface model) with the
C initial guess for SH2O from above explicit first guess.
              SH2O(I,J,K)=FRH2O(STC(I,J,K),SMC(I,J,K),SH2O(I,J,K),
     .                    SMCMAX(IONETA(I,J)),BETA(IONETA(I,J)),
     .                    PSIS(IONETA(I,J)))
            ELSE
C ----------------------------------------------------------------------
C SH2O = SMC for T => 273.149K (-0.001C)
              SH2O(I,J,K)=SMC(I,J,K)
c
            ENDIF

   70	CONTINUE
  100	CONTINUE
  200	CONTINUE

C **   THIRD THE SURFACE SLOPE TYPES ***********************

       REWIND 32
       READ (32) I1D
C        SET DEFAULT FOR ETA LAND FAR FROM LAND IN GLOBAL
       IONETA=1
              CALL PUTEM(glat,glon,I1D,sm,si,IONETA)
	write(6,*) 'writing slope type'
       WRITE(1) IONETA

Cmp END NEW CONTENT ***************************************

C-----------------------------------------------------------------------

	write(6,*) 'calling VFRAC'
	CALL VFRAC(im,jm,glatr,glonr,TLM0D,TPH0D,DLMD,DPHD,sm,si,
     +	vegfrc)

	write(6,*) 'sample VEGFRC values (* 1000) '
	do J=jm,1,-jm/30
	write(6,396) (vegfrc(I,J)*1000,I=1,im,im/12)
  396	format(31(f4.0,x))
	enddo

C-----------------------------------------------------------------------
C DETERMINE ALBEDO OVER LAND
      DO J=1,JM
        DO I=1,IM
          IF(SM(I,J).LT.0.9.AND.SICE(I,J).LT.0.9) THEN
C SNOWFREE ALBEDO
            IF ( (SNO(I,J) .EQ. 0.0) .OR.
     .           (ALBASE(I,J) .GE. MXSNAL(I,J) ) ) THEN
CC        write(6,*) 'set albedo to albase: ', ALBASE(I,J)
              ALBEDO(I,J) = ALBASE(I,J)
            if(i.eq.303 .and .j.eq.143 .or.
     &         i.eq.309 .and. j.eq.143) then
                print *,i,j,sno(i,j),albase(i,j),mxsnal(i,j)
            endif
            ELSE
C MODIFY ALBEDO IF SNOWCOVER:
C BELOW SNOWDEPTH THRESHOLD...
              IF (SNO(I,J) .LT. SNUP) THEN
                RSNOW = SNO(I,J)/SNUP
                SNOFAC = 1. - ( EXP(-SALP*RSNOW) - RSNOW*EXP(-SALP))
C ABOVE SNOWDEPTH THRESHOLD...
              ELSE
                SNOFAC = 1.0
              ENDIF
C CALCULATE ALBEDO ACCOUNTING FOR SNOWDEPTH AND VEGFRC
              ALBEDO(I,J) = ALBASE(I,J)
     .          + (1.0-VEGFRC(I,J))*SNOFAC*(MXSNAL(I,J)-ALBASE(I,J))
            ENDIF
          END IF
        ENDDO
      ENDDO


      write(1) vegfrc

CGSM	sldpth(1)=0.1
CGSM	sldpth(2)=0.3
CGSM	sldpth(3)=0.6
CGSM	sldpth(4)=1.0
CGSM	rtdpth(1)=0.1
CGSM	rtdpth(2)=0.3
CGSM	rtdpth(3)=0.6
CGSM	rtdpth(4)=0.0

CIsabel
       sldpth(1)=0.1
       sldpth(2)=0.3
       sldpth(3)=0.6
       sldpth(4)=1.0
       sldpth(5)=1.5
       sldpth(6)=2.1
       sldpth(7)=2.8
       sldpth(8)=3.6
C    
       rtdpth(1)=0.1
       rtdpth(2)=0.3
       rtdpth(3)=0.6
       rtdpth(4)=0.0
       rtdpth(5)=0.0
       rtdpth(6)=0.0
       rtdpth(7)=0.0
       rtdpth(8)=0.0
CIsabel

C	write(6,*) 'writing sldpth ... ', sldpth
      write(1) sldpth  
C	write(6,*) 'writing rtdpth... ', rtdpth
      write(1) rtdpth   
      close(1)
c
      return                                     
      end
c
c===============================================================================
c
      subroutine spline(jtb,nold,xold,yold,y2,nnew,xnew,ynew,p,q)           
c
c *** This is a one-dimensional cubic spline fitting routine 
c        programed for a small scalar machine.                       
c
c *** Programer: Z. Janjic, Yugoslav Fed. Hydromet. Inst., Beograd 
c
c *** nold - number of given values of the function.  must be ge 3. 
c     xold - locations of the points at which the values of the     
c            function are given.  must be in ascending order.       
c     yold - the given values of the function at the points xold.   
c     y2   - the second derivatives at the points xold.  if natural 
c            spline is fitted y2(1)=0. and y2(nold)=0. must be      
c            specified.                                             
c     nnew - number of values of the function to be calculated.     
c     xnew - locations of the points at which the values of the     
c            function are calculated.  xnew(k) must be ge xold(1)   
c            and le xold(nold).                                     
c     ynew - the values of the function to be calculated.           
c     p, q - auxiliary vectors of the length nold-2.                
c                                                                   
      real*4 xold(jtb),yold(jtb),y2(jtb),p(jtb),q(jtb)                        
     .      ,xnew(jtb),ynew(jtb)                                              
c_______________________________________________________________________________
c
      noldm1=nold-1                                                     
c                                                                       
      dxl=xold(2)-xold(1)                                               
      dxr=xold(3)-xold(2)                                               
      dydxl=(yold(2)-yold(1))/dxl                                       
      dydxr=(yold(3)-yold(2))/dxr                                       
      rtdxc=.5/(dxl+dxr)                                                
c                                                                       
      p(1)= rtdxc*(6.*(dydxr-dydxl)-dxl*y2(1))                          
      q(1)=-rtdxc*dxr                                                   
c                                                                       
      if(nold.eq.3) go to 700                                           
c-----------------------------------------------------------------------
      k=3                                                               
c                                                                       
 100  dxl=dxr                                                           
      dydxl=dydxr                                                       
      dxr=xold(k+1)-xold(k)                                             
      dydxr=(yold(k+1)-yold(k))/dxr                                     
      dxc=dxl+dxr                                                       
      den=1./(dxl*q(k-2)+dxc+dxc)                                       
c                                                                       
      p(k-1)= den*(6.*(dydxr-dydxl)-dxl*p(k-2))                         
      q(k-1)=-den*dxr                                                   
c                                                                       
      k=k+1                                                             
      if(k.lt.nold) go to 100                                           
c-----------------------------------------------------------------------
 700  k=noldm1                                                          
c                                                                       
 200  y2(k)=p(k-1)+q(k-1)*y2(k+1)                                       
c                                                                       
      k=k-1                                                             
      if(k.gt.1) go to 200                                              
c-----------------------------------------------------------------------
      k1=1                                                              
c                                                                       
 300  xk=xnew(k1)                                                       
c                                                                       
      do 400 k2=2,nold                                                  
      if(xold(k2).le.xk) go to 400                                      
      kold=k2-1                                                         
      go to 450                                                         
 400  continue                                                          
      ynew(k1)=yold(nold)                                               
      go to 600                                                         
c                                                                       
 450  if(k1.eq.1)   go to 500                                           
      if(k.eq.kold) go to 550                                           
c                                                                       
 500  k=kold                                                            
c                                                                       
      y2k=y2(k)                                                         
      y2kp1=y2(k+1)                                                     
      dx=xold(k+1)-xold(k)                                              
      rdx=1./dx                                                         
c                                                                       
      ak=.1666667*rdx*(y2kp1-y2k)                                       
      bk=.5*y2k                                                         
      ck=rdx*(yold(k+1)-yold(k))-.1666667*dx*(y2kp1+y2k+y2k)            
c                                                                       
 550  x=xk-xold(k)                                                      
      xsq=x*x                                                           
c                                                                       
      ynew(k1)=ak*xsq*x+bk*xsq+ck*x+yold(k)                             
c                                                                       
 600  k1=k1+1                                                           
      if(k1.le.nnew) go to 300                                          
c
      return                                    
      end                                       
c
c===============================================================================
c
      subroutine albedo_vege(ivegetype,albedo)
c
c *** ssib vegetation types (dorman and sellers, 1989; jam)
c
c      1:   broadleaf-evergreen trees  (tropical forest)
c      2:   broadleaf-deciduous tress
c      3:   broadleaf and needleleaf tress (mixed forest)
c      4:   needleleaf-evergreen trees
c      5:   needleleaf-deciduous tress (larch)
c      6:   broadleaf tress with groundcover (savanna)
c      7:   groundcover only (perennial)
c      8:   broadleaf shrubs with perennial groundcover
c      9:   broadleaf shrubs with bare soil
c     10:   dwarf trees and shrubs with groundcover (tundra)
c     11:   bare soil
c     12:   cultivations (the same parameters for the type 7)
c     13:   glacial
c     14:   water, according to eta sm
c
      dimension albedo_veg(14)
c
      data albedo_veg/0.11, 0.19, 0.16, 0.13, 0.19, 0.19, 0.19
     .               ,0.29, 0.29, 0.14, 0.15, 0.19, 0.15, 0.10/
c_______________________________________________________________________________
c
      albedo=albedo_veg(ivegetype)
      return
      end

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

C	BLOCK DATA GSOIL

C	logical GRIBSOIL
C	DATA GRIBSOIL /.FALSE./

C	END


C-------------------------------------------------------

      FUNCTION FRH2O(TKELV,SMC,SH2O,SMCMAX,B,PSIS)

      IMPLICIT NONE

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CC  PURPOSE:  CALCULATE AMOUNT OF SUPERCOOLED LIQUID SOIL WATER CONTENT
CC  IF TEMPERATURE IS BELOW 273.15K (T0).  REQUIRES NEWTON-TYPE ITERATION
CC  TO SOLVE THE NONLINEAR IMPLICIT EQUATION GIVEN IN EQN 17 OF
CC  KOREN ET AL. (1999, JGR, VOL 104(D16), 19569-19585).
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C New version (FEB 2001): much faster and more accurate newton iteration
c achieved by first taking log of eqn cited above -- less than 4
c (typically 1 or 2) iterations achieves convergence.  Also, explicit
c 1-step solution option for special case of parameter Ck=0, which reduces
c the original implicit equation to a simpler explicit form, known as the
c ""Flerchinger Eqn". Improved handling of solution in the limit of
c freezing point temperature T0.
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C INPUT:
C
C   TKELV.........Temperature (Kelvin)
C   SMC...........Total soil moisture content (volumetric)
C   SH2O..........Liquid soil moisture content (volumetric)
C   SMCMAX........Saturation soil moisture content (from REDPRM)
C   B.............Soil type "B" parameter (from REDPRM)
C   PSIS..........Saturated soil matric potential (from REDPRM)
C
C OUTPUT:
C   FRH2O.........supercooled liquid water content.
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      REAL B
      REAL BLIM
      REAL BX
      REAL CK
      REAL DENOM
      REAL DF
      REAL DH2O
      REAL DICE
      REAL DSWL
      REAL ERROR
      REAL FK
      REAL FRH2O
      REAL GS
      REAL HLICE
      REAL PSIS
      REAL SH2O
      REAL SMC
      REAL SMCMAX
      REAL SWL
      REAL SWLK
      REAL TKELV
      REAL T0

      INTEGER NLOG
      INTEGER KCOUNT

      PARAMETER (CK=8.0)
C      PARAMETER (CK=0.0)
      PARAMETER (BLIM=5.5)
C      PARAMETER (BLIM=7.0)
      PARAMETER (ERROR=0.005)

      PARAMETER (HLICE=3.335E5)
      PARAMETER (GS = 9.81)
      PARAMETER (DICE=920.0)
      PARAMETER (DH2O=1000.0)
      PARAMETER (T0=273.15)

C  ###   LIMITS ON PARAMETER B: B < 5.5  (use parameter BLIM)  ####
C  ###   SIMULATIONS SHOWED IF B > 5.5 UNFROZEN WATER CONTENT  ####
C  ###   IS NON-REALISTICALLY HIGH AT VERY LOW TEMPERATURES    ####
C##################################################################
C
      BX = B
      IF ( B .GT. BLIM ) BX = BLIM
C------------------------------------------------------------------

C INITIALIZING ITERATIONS COUNTER AND ITERATIVE SOLUTION FLAG.
      NLOG=0
      KCOUNT=0

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C  IF TEMPERATURE NOT SIGNIFICANTLY BELOW FREEZING (T0), SH2O = SMC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      IF (TKELV .GT. (T0 - 1.E-3)) THEN

        FRH2O=SMC

      ELSE

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
       IF (CK .NE. 0.0) THEN

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCC OPTION 1: ITERATED SOLUTION FOR NONZERO CK CCCCCCCCCCC
CCCCCCCCCCCC IN KOREN ET AL, JGR, 1999, EQN 17 CCCCCCCCCCCCCCCCC
C
C INITIAL GUESS FOR SWL (frozen content)
        SWL = SMC-SH2O
C KEEP WITHIN BOUNDS.
        IF(SWL .GT. (SMC-0.02)) THEN
          SWL=SMC-0.02
c         SWL=MAX(0.,SMC-0.02)
        ENDIF
        IF(SWL .LT. 0.)  THEN
          SWL=0.
        ENDIF
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C  START OF ITERATIONS
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
        DO WHILE (NLOG .LT. 10 .AND. KCOUNT .EQ. 0)
         NLOG = NLOG+1
!	write(6,*) 'PSIS,GS,HLICE: ', PSIS,GS,HLICE
!	write(6,*) 'CK,SWL,SMCMAX,SMC,SWL,BX: ', 
!     +		CK,SWL,SMCMAX,SMC,SWL,BX
!	write(6,*) 'TKELV,T0: ', TKELV,T0
         DF = ALOG(( PSIS*GS/HLICE ) * ( ( 1.+CK*SWL )**2. ) *
     &        ( SMCMAX/(SMC-SWL) )**BX) - ALOG(-(TKELV-T0)/TKELV)
         DENOM = 2. * CK / ( 1.+CK*SWL ) + BX / ( SMC - SWL )
         SWLK = SWL - DF/DENOM
!	write(6,*) 'DF,DENOM,SWLK: ', DF,DENOM,SWLK
         DSWL=ABS(SWLK-SWL)
         SWL=SWLK
C KEEP WITHIN BOUNDS.
         IF(SWL .GT. (SMC-0.02)) THEN
           SWL=SMC-0.02
c          SWL=MAX(0.,SMC-0.02)
         ENDIF
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CC IF MORE THAN 10 ITERATIONS, USE EXPLICIT METHOD (CK=0 APPROX.)
CC WHEN DSWL LESS OR EQ. ERROR, NO MORE ITERATIONS REQUIRED.
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
         IF ( DSWL .LE. ERROR )  THEN
           KCOUNT=KCOUNT+1
         END IF
        END DO
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C  END OF ITERATIONS
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C LOWER BOUND FOR SWL (ICE CONTENT)
        IF(SWL .LT. 0.)  THEN
          SWL=0.
        ENDIF
C UPPER BOUND FOR SWL ALREADY APPLIED WITHIN DO-BLOCK
        FRH2O = SMC - SWL
C
CCCCCCCCCCCCCCCCCCCCCCCC END OPTION 1 CCCCCCCCCCCCCCCCCCCCCCCCCCC

       ENDIF

       IF (KCOUNT .EQ. 0) THEN
!         Print*,'Flerchinger used. Iterations=',NLOG

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCC OPTION 2: EXPLICIT SOLUTION FOR FLERCHINGER EQ. i.e. CK=0 CCCCCCCC
CCCCCCCCCCCCC IN KOREN ET AL., JGR, 1999, EQN 17  CCCCCCCCCCCCCCC
C
        FK=(((HLICE/(GS*(-PSIS)))*((TKELV-T0)/TKELV))**(-1/BX))*SMCMAX
        IF (FK .LT. 0.02) FK = 0.02
        FRH2O = MIN ( FK, SMC )
C
CCCCCCCCCCCCCCCCCCCCCCCCC END OPTION 2 CCCCCCCCCCCCCCCCCCCCCCCCCC

       ENDIF

      ENDIF

      RETURN
      END 

C   &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
       SUBROUTINE PUTVEG(TLM0D,TPH0D,DLMD,DPHD,HLAT,HLON,
     &                   FVEG0,SM,SICE,FVEG1)
C   **************************************************************
C   * Interpolate NESDIS vegetation fraction product (five-year  *
C   * climatology with 0.144 degree resolution from 89.928S,180W * 
C   * to 89.928N, 180E)                                          *
C   * F. Chen 07/96                                              *
C   **************************************************************

      INCLUDE "parmeta"
C
      PARAMETER  (L0=15680*10600)
C
      PARAMETER  (RES=0.00892857)
C
      DIMENSION FVEG0(15680,10600), FVEG1(IM,JM)  
      DIMENSION HLAT(IM,JM),HLON(IM,JM)
      DIMENSION SM(IM,JM),SICE(IM,JM)
C      INTEGER IPOPT(20), JPDS(25), JGDS(22), KGDS0(22), KGDS1(22)
C     +      , KPDS0(25), KPDS1(25), BITFLG1(1)
C      CHARACTER GDS1(42)
C      LOGICAL BIT0(15680,10600), BIT1(IM,JM)
CFEI      DATA IG/96/

C   This subroutine AVERAGES the value stored in FVEG0 TO the FVEG1 array.
C   Special effort is made to ensure that islands are taken care of when
C   not resolved on the 0.144 x 0.144 deg. grid.
C  *** Define the search limit for isolated island point 
        NLIM=10*(1+AINT(RES/DPHD))
C  *** Define the Eta averaging box size, NBOX=0 gives nearest neighbor
        NBOX1=NINT(MAX(DLMD,DPHD)/RES)
        NBOX=NBOX1
C        print*,' im,jm=',im,jm,'NBOX=',NBOX,'DPHD',DPHD,'NLIM',NLIM,
C     &         'DLMD',DLMD

        DO J = 1,JM
        DO I = 1,IM

Cmp 	added for workstation
	HLON(I,J) = 360.0 - HLON(I,J)
	IF(HLON(I,J) .GT. 360.) HLON(I,J) = HLON(I,J) - 360.
Cmp

          IF((SM(I,J).GT.0.5).OR.(SICE(I,J).EQ.1.0)) THEN
            FVEG1(I,J) = 0.0
          ELSE
            DX=(HLON(I,J) - 240) / RES
            INDX = NINT(DX)
C  ***  Here, 179.928 is the starting longitude (180.072) + one grid cell 
C       width (0.144) so that the first index is one NOT 0.
            IF(INDX.LT.1) THEN 
              DX=(HLON(I,J) + 180.072) / RES
              INDX = NINT(DX)
            ENDIF
            DY=(HLAT(I,J) + 59.9911) / RES
            INDY = NINT(DY)
C  *** Get area-average value of FVEG1 from input grid FVEG0, for 
C      finer Eta grid, this becomes nearest-neighbour 
            ICON1=0
  100       CONTINUE
            IF(MOD(NBOX,2).EQ.0) THEN
              IF(DX.GT.REAL(INDX)) THEN
                NLO=MAX(1,INDX-NBOX/2+1)
                NHI=MIN(15680,INDX+NBOX/2)
              ELSE
                NLO=MAX(1,INDX-NBOX/2)
                NHI=MIN(15680,INDX+NBOX/2-1)
              ENDIF
              IF(DY.GT.REAL(INDY)) THEN
                MLO=MAX(1,INDY-NBOX/2+1)
                MHI=MIN(10600,INDY+NBOX/2) 
              ELSE
                MLO=MAX(1,INDY-NBOX/2)
                MHI=MIN(10600,INDY+NBOX/2-1)
              ENDIF
            ELSE
              NLO=MAX(1,INDX-NBOX/2)
              NHI=MIN(15680,INDX+NBOX/2)
              MLO=MAX(1,INDY-NBOX/2)
              MHI=MIN(10600,INDY+NBOX/2)
            ENDIF
C            NLO=MAX(1,INDX-NBOX)
C            NHI=MIN(15680,INDX+NBOX)
C            MLO=MAX(1,INDY-NBOX)
C            MHI=MIN(10600,INDY+NBOX)
            ICON=0
            VEGSUM=0.0
            DO N=NLO, NHI
              DO M=MLO, MHI
                IF(FVEG0(N,M).NE.0.0) THEN
                 ICON=ICON+1 
                 VEGSUM=VEGSUM+FVEG0(N,M)
                ENDIF
              ENDDO
            ENDDO
            IF(ICON.NE.0) THEN
              FVEG1(I,J)=VEGSUM/ICON
              NBOX=NBOX1
            ELSE
C *** Search for an isolated point 
              ICON1=ICON1+1
              NBOX=NBOX+1 
              IF(ICON1.LE.NLIM) THEN
                GO TO 100
              ELSE
                FVEG1(I,J)=0.55
                NBOX=NBOX1
                print *,"OH OH ",HLAT(I,J),HLON(I,J)
              ENDIF
            ENDIF
C ** End of land case
C          if(NBOX.NE.NBOX1) print*,' NBOX is NOT NBOX1,=',NBOX
          END IF  
          IF(FVEG1(I,J).LT.0.0.OR.FVEG1(I,J).GT.1.0) THEN 
           print*,' FVEG1 out of range, FVEG=',FVEG1(I,J)
          ENDIF
C ** End of IM,JM loops
        END DO  
        END DO  
        RETURN
        END

      SUBROUTINE SNO8GET(SNODEP,IYR,IMN,IDY,  INSNOAF,LIST,LUSAF)
C
C USAGE: Program to read in USAF gribbed snow/ice data on 1/8th bedient
C polar stereographic grid.  The gribbing program has already reversed
C the coordinates in the N-S direction so now the (1,1) point is at
C the 'lower left' corner.
C
      INTEGER KPDS(25), KGDS(22), JPDS(25), JGDS(22)
      REAL SNODEP(512,512), ICE(512,512)  
      LOGICAL BITMAP(512,512), LUSAF
C
C     PROCESS USAF N.H. SNOW/ICE ANAL (FROM AFGWC VIA SPN), GRIBBED
C     USAF SNOW/ICE ANAL IS DAILY AND HIGH RES (45 KM)             
C                                                                  
C  COMBINE THE TWO SEPARATE ICE/SNOW FIELDS INTO ONE FIELD.  
C  SNOW IS IN METERS.  ICE FLAG OF '1' IS CONVERTED TO A VALUE
C  OF '11' IN SNODEP FIELD.
C                                                                  
      JPDS = -1
	 CALL BAOPEN(INSNOAF,'snowdepth.grb',IRETBA)
Cmp      CALL GETGBOPL(INSNOAF,0,512*512,0,JPDS,JGDS,KF,KNUM,KPDS,KGDS,
      CALL GETGB(INSNOAF,0,512*512,0,JPDS,JGDS,KF,KNUM,KPDS,KGDS,
     &     BITMAP,ICE,IRET1)
      WRITE(6,*) 'AFTER GETGB FOR AF ICE, IRET=', IRET1
C
      JPDS = -1
Cmp      CALL GETGBOPL(INSNOAF,0,512*512,1,JPDS,JGDS,KF,KNUM,KPDS,KGDS,
      CALL GETGB(INSNOAF,0,512*512,1,JPDS,JGDS,KF,KNUM,KPDS,KGDS,
     &     BITMAP,SNODEP,IRET2)
      WRITE(6,*) 'AFTER GETGB FOR AF SNOW, IRET=', IRET2
C
      IYR2D = KPDS(8)
      IMN = KPDS(9)
      IDY = KPDS(10)
      ICENT = KPDS(21)
      IF(IYR2D.LT.100) THEN
       IYR = (ICENT - 1) * 100 + IYR2D
      ELSE
       IYR = ICENT * 100
      ENDIF
C
      LUSAF = IRET1.EQ.0 .AND. IRET2.EQ.0
      WRITE(6,*) 'LUSAF=', LUSAF
      IF (.NOT.LUSAF) RETURN
C
      DO 20 I = 1, 512
        DO 10 J = 1, 512
          IF (ABS(ICE(I,J)-1.) .LT. 0.0001) SNODEP(I,J) = 11.
 10     CONTINUE
 20   CONTINUE
      RETURN
      END

      subroutine eta_boco
c
c *** Creates the eta boundary condition file.
c
c *** Original code obtained from U. of Athens and modified at FSL.
c
      implicit none
c
      include 'ecommons.h'
c
      real*4 
     .    pdba(lb)  ,tba(lb,lm)  ,qba(lb,lm)  ,uba(lb,lm)  ,vba(lb,lm)
     .   ,pdbb(lb)  ,tbb(lb,lm)  ,qbb(lb,lm)  ,ubb(lb,lm)  ,vbb(lb,lm)          
     .   ,pdb (lb,2),tb (lb,lm,2),qb (lb,lm,2),ub (lb,lm,2),vb (lb,lm,2)  
     .   ,q2b(lb,lm,2),cwmb(lb,lm,2)
     .   ,pdb2(lb,2),tb2(lb,lm,2),qb2(lb,lm,2),ub2(lb,lm,2),vb2(lb,lm,2)
     .   ,rtboco,run
c
      integer*4 itboco,ibc,nibc,idat(3),ihrst,i,j,k,l,len,n
c
      character*255 fname1,fname2,fname
      character*8   ftime
      character*3   ced
c
      real*4 epsq2
      parameter (epsq2=0.2)
c_______________________________________________________________________________
c
      print *,' '
      print *,'Creating eta boundary condition files...'
	print *, 'these are dimensioned as lb, which is= ', lb
	print *, 'kb,im,jm,imjm,imt,jmt= ',kb,im,jm,imjm,imt,jmt
c
      len=index(init_out,' ')-1
      if (init_out(len:len) .ne. '/') then
         len=len+1
         init_out(len:len)='/'
      endif
c
c *** Open boundary condition file.
c     Bndy conditions will be written sequentially into one file (NCEP style).
c
      write(ftime,'(4i2.2)') mod(iyear,100),imonth,idate,istrtim
Cmp      l=len+13
	l=len+9
Cmp      fname(1:l)=init_out(1:len)//'bndy.'//ftime
      fname(1:l)=init_out(1:len)//'bndy.file'
      print *,'Open BC file  : ',fname(1:l)
      open(2,file=fname(1:l),status='unknown',form='unformatted')
c
c *** Loop through for all boco files.
c
      rtboco=1./(tboco*3600.)                                             
      itboco=nint(tboco)
      nibc=nhour/itboco
      do ibc=1,nibc
c
         if (ibc .eq. 1) then
            write(ced,'(i3.3)') (ibc-1)*itboco
            l=len+14
            fname1(1:l)=init_out(1:len)//'preproc.bc.'//ced
c
            print *,'Read from file: ',fname1(1:l)
            open(1,file=fname1(1:l),status='old',form='unformatted')
            read(1) run,idat,ihrst,pdb,tb,qb,ub,vb
            close(1)
	write(6,*) 'done reading from file'
         else
            do k=1,2
               do i=1,lb
                  pdb(i,k)=pdb2(i,k)
               enddo
               do j=1,lm
               do i=1,lb
                  tb(i,j,k)=tb2(i,j,k)
                  qb(i,j,k)=qb2(i,j,k)
                  ub(i,j,k)=ub2(i,j,k)
                  vb(i,j,k)=vb2(i,j,k)
               enddo
               enddo
            enddo
         endif
c
         write(ced,'(i3.3)') ibc*itboco
         l=len+14
         fname2(1:l)=init_out(1:len)//'preproc.bc.'//ced
c
         print *,'Read from file: ',fname2(1:l)
         open(1,file=fname2(1:l),status='old',form='unformatted')
         read(1) run,idat,ihrst,pdb2,tb2,qb2,ub2,vb2
         close(1)
c
         do n=1,lb
            pdbb(n)=pdb (n,1)
            pdba(n)=pdb2(n,1)
         enddo
c
         do l=1,lm
         do n=1,lb
            tbb(n,l)=tb (n,l,1)
            tba(n,l)=tb2(n,l,1)
            qbb(n,l)=qb (n,l,1)
            qba(n,l)=qb2(n,l,1)
            ubb(n,l)=ub (n,l,1)
            uba(n,l)=ub2(n,l,1)
            vbb(n,l)=vb (n,l,1)
            vba(n,l)=vb2(n,l,1)
         enddo
         enddo
c
         do n=1,lb                                                 
            pdb(n,1)=pdbb(n)                                                
            pdb(n,2)=(pdba(n)-pdbb(n))*rtboco                                 
         enddo
c
         do l=1,lm                              
         do n=1,lb                                                 
            tb(n,l,1)=tbb(n,l)                                              
            qb(n,l,1)=qbb(n,l)                                              
            ub(n,l,1)=ubb(n,l)                                              
            vb(n,l,1)=vbb(n,l)                                              
c                                                                       
            tb(n,l,2)=(tba(n,l)-tbb(n,l))*rtboco                              
            qb(n,l,2)=(qba(n,l)-qbb(n,l))*rtboco                              
            ub(n,l,2)=(uba(n,l)-ubb(n,l))*rtboco                              
            vb(n,l,2)=(vba(n,l)-vbb(n,l))*rtboco                             
         enddo
         enddo
c
         write(ftime,'(4i2.2)') mod(iyear,100),imonth,idate,istrtim
Cmp         l=len+13
	l=len+9
Cmp         fname(1:l)=init_out(1:len)//'bndy.'//ftime
         fname(1:l)=init_out(1:len)//'bndy.file'
         print *,'Write to file : ',fname(1:l)
         open(2,file=fname(1:l),status='unknown',form='unformatted')
         if (ibc .eq. 1) write(2) run,idat,ihrst,tboco
         write(2) float(ibc-1)*tboco
         write(2) pdb
         write(2) tb
	write(6,*) 'pdb(1) ', pdb(1,1),pdb(1,2)
	write(6,*) 'pdb(lb/2) ', pdb(lb/2,1),pdb(lb/2,2)
	write(6,*) 'pdb(last) ', pdb(lb,1),pdb(lb,2)
	write(6,*) 't(1,lm/2) ', tb(1,lm/2,1),tb(1,lm/2,2)
	write(6,*) 't(lb,lm/2) ', tb(lb,lm/2,1),tb(lb,lm/2,2)
         write(2) qb
         write(2) ub
         write(2) vb
C	write(6,*) 'T Q U V '
C	do i=1,lb
C	write(6,633) i,tb(i,10,1),qb(i,10,1)*1.e6,ub(i,10,1),vb(i,10,1),
C     +                ( ub(i,10,1)**2.+ vb(i,10,1)**2. ) ** 0.5
C	enddo
  633	format(I3,1x,5(f6.1,1x))
Cmp         do k=1,2
         do j=1,lm
         do i=1,lb
            q2b(i,j,1)=epsq2
            q2b(i,j,2)=0.
            cwmb(i,j,1)=0.
            cwmb(i,j,2)=0.
         enddo
         enddo
Cmp         enddo
         write(2) q2b
         write(2) cwmb 
c
      enddo
      write(2) float(nibc)*tboco
Cmp
Cmp	duplicate last tendency
        write(6,*) 'duping last tendency with some modification'

C       tendencies dont matter here, but the value does.
c
C       want to dump the terminal value here, not the "before" value!
C
         do n=1,lb
            pdb(n,1)=pdba(n)
            pdb(n,2)=(pdba(n)-pdbb(n))*rtboco
         enddo
c
         do l=1,lm
         do n=1,lb
            tb(n,l,1)=tba(n,l)
            qb(n,l,1)=qba(n,l)
            ub(n,l,1)=uba(n,l)
            vb(n,l,1)=vba(n,l)
c
            tb(n,l,2)=(tba(n,l)-tbb(n,l))*rtboco
            qb(n,l,2)=(qba(n,l)-qbb(n,l))*rtboco
            ub(n,l,2)=(uba(n,l)-ubb(n,l))*rtboco
            vb(n,l,2)=(vba(n,l)-vbb(n,l))*rtboco
         enddo
         enddo
c
	write(2) pdb
         write(2) tb
         write(2) qb
         write(2) ub
         write(2) vb
 	 write(2) q2b
         write(2) cwmb


	write(6,*) 'pdb(1) ', pdb(1,1),pdb(1,2)
	write(6,*) 'pdb(last) ', pdb(lb,1),pdb(lb,2)
	write(6,*) 't(1,lm/2) ', tb(1,lm/2,1),tb(1,lm/2,2)
	write(6,*) 't(lb,lm/2) ', tb(lb,lm/2,1),tb(lb,lm/2,2)
C	write(6,*) 'u(20,lm/2) ', ub(20,lm/2,1),ub(20,lm/2,2)
C	write(6,*) 'v(20,lm/2) ', vb(20,lm/2,1),vb(20,lm/2,2)
cmp

      print *,'Close BC file : ',fname(1:l)
      close(2)
c
      return
      end                                        

c===============================================================================
c
      subroutine tableq(ttblq,rdp,rdthe,pl,thl,sthe,the0)
c
c *** Generate values for finer look-up tables used in convection.
c
      parameter (itb=152,jtb=440)
      parameter (thh=325.,ph=105000.
     .          ,pq0=379.90516
     .          ,a1=610.78,a2=17.2693882,a3=273.16,a4=35.86
     .          ,r=287.04,cp=1004.6,eliwv=2.683e6,eps=1.e-9)
Cmp	change eps from 1.e-10 to 1.e-9 (make more like operational)
c
      real*4 ttblq(jtb,itb)
     .      ,told (jtb),theold(jtb),the0(itb),sthe(itb)
     .      ,y2t  (jtb),thenew(jtb),apt (jtb),aqt (jtb),tnew(jtb)
c_______________________________________________________________________________
c
c *** Coarse look-up table for saturation point.
c
      kthm=jtb
      kpm=itb
      kthm1=kthm-1
      kpm1=kpm-1
c
      dth=(thh-thl)/real(kthm-1)
      dp =(ph -pl )/real(kpm -1)
c
      rdp=1./dp
      th=thl-dth
c
c *** Coarse look-up table for t(p) from constant the.
c
      p=pl-dp
      do kp=1,kpm
         p=p+dp
         th=thl-dth
         do kth=1,kthm
            th=th+dth
            ape=(100000./p)**(r/cp)
            qs=pq0/p*exp(a2*(th-a3*ape)/(th-a4*ape))
            told(kth)=th/ape
            theold(kth)=th*exp(eliwv*qs/(cp*told(kth)))
         enddo
c
         the0k=theold(1)
         sthek=theold(kthm)-theold(1)
         theold(1   )=0.
         theold(kthm)=1.
c
         do kth=2,kthm1
            theold(kth)=(theold(kth)-the0k)/sthek
            if (theold(kth)-theold(kth-1) .lt. eps)
     .         theold(kth)=theold(kth-1)+eps
c
         enddo
c
         the0(kp)=the0k
         sthe(kp)=sthek
c
         thenew(1  )=0.
         thenew(kthm)=1.
         dthe=1./real(kthm-1)
         rdthe=1./dthe
c
         do kth=2,kthm1
            thenew(kth)=thenew(kth-1)+dthe
         enddo
c
         y2t(1   )=0.
         y2t(kthm)=0.
c
         call spline(jtb,kthm,theold,told,y2t,kthm,thenew,tnew,apt,aqt)
c
         do kth=1,kthm
            ttblq(kth,kp)=tnew(kth)
            write(6000,*)kth,kp,ttblq(kth,kp)
         enddo
c
      enddo
c
      return
      end
c

	SUBROUTINE process_gaus(im,jm,tlm0d,tph0d,dlmd,dphd,sm,stc,smc,
     +	sst,sice,si,GGSTC1,GGSTC2,GGSMC1,GGSMC2,SSTRAW,SNOWRAW,GGLAND,
     +	GGICE,KGDS)


	parameter (nx=192,ny=94)
	parameter (nsoil=4)
	parameter(dtr=3.14159/180.,r2d=1./dtr)


CC	read and fill these 8 arrays...process rest in another sub

        real GGSTC1(nx,ny),GGSTC2(nx,ny)
	real GGSMC1(nx,ny),GGSMC2(nx,ny)
	real SSTRAW(nx,ny),SNOWRAW(nx,ny)
	real GGLAND(nx,ny),GGICE(nx,ny)

	real, allocatable:: tmp(:)

	real sm(im,jm),si(im,jm),sice(im,jm)
	real stc(im,jm,nsoil),smc(im,jm,nsoil),sst(im,jm)

	real rlat,rlon,xpts(im,jm),ypts(im,jm)
C	real glat(im,jm),glon(im,jm),rout(im,jm),sfcgrid(im,jm,6)
	real glat(im,jm),glon(im,jm)

	character*256 sfc_file

C        logical*1 ltmp(nx,ny)
        integer ICOUNT,I,ixp,jyp

	      integer kgds(200),kpds(200),len,kerr
     .         ,nwords
     .         ,IRETO,IRET1,JPDS(200),JGDS(200),KNUM

        logical*1 BITMAP(nx*ny)


C	Define eta grid lat/lon
C
        WBD=-(float(IM)-1.)*DLMD
        SBD=(-(float(JM)-1.)/2.)*DPHD

	write(6,*) 'wbd, sbd= ', wbd,sbd

	 tph0=tph0d*dtr
      wb=wbd*dtr
      sb=sbd*dtr
      dlm=dlmd*dtr
      dph=dphd*dtr
      tdlm=dlm+dlm
      tdph=dph+dph
      tph=sb-dph
      ctph0=cos(tph0)
       stph0=sin(tph0)

      do j=1,jm
         tlm=wb-tdlm+mod(j+1,2)*dlm
         tph=tph+dph
         stph=sin(tph)
         ctph=cos(tph)
c
        do i=1,im
            tlm=tlm+tdlm
            sinphi=ctph0*stph+stph0*ctph*cos(tlm)
            glat(i,j)=asin(sinphi)
            coslam=ctph*cos(tlm)/(cos(glat(i,j))*ctph0)
     .            -tan(glat(i,j))*tan(tph0)
            coslam=min(coslam,1.)
            fact=1.
            if (tlm .gt. 0.0) fact=-1.
            glon(i,j)=-tlm0d*dtr+fact*acos(coslam)
        glat(i,j)=glat(i,j)*r2d
        glon(i,j)=glon(i,j)*r2d
C
        if (glon(i,j).lt.0) glon(i,j)=glon(i,j)+360.

	glon(i,j)=360.-glon(i,j)

         enddo
      enddo

CCC
CC	compute gaussian points corresponding to output e-grid	
CC
C
	call gauss_ijonce(kgds,-1,im*jm,-9999.,XPTS,YPTS,
     +			glon,glat,numret)
	write(6,*) 'numret from gauss_ijonce: ', numret


CC
CC	At this point have all of the pieces.  Begin by creating a SICE mask
CC

C 20010806  WHY IS SNOWRAW USED RATHER THAN GGICE TO GENERATE SICE????

	do J=1,NY
	do I=1,NX
	if (SNOWRAW(I,J) .gt. 0 .and. GGLAND(I,J) .eq. 0 .and. 
     +		GGICE(I,J) .eq. 0) then
	write(6,*) 'snow & water...possible ice ', I,J
	endif
	enddo
	enddo

	call reansnowint(SNOWRAW,nx,ny,im,jm,glat,glon,xpts,ypts,sm,si)
	call reaniceint(GGICE,nx,ny,im,jm,glat,glon,xpts,ypts,sm,sice)

        write(6,*) 'si from reaniceint'
        do J=jm,1,-JM/50
        write(6,372) (si(I,J),I=1,im,2)
        enddo

        write(6,*) 'sea ice from reaniceint'
        do J=jm,1,-JM/50
        write(6,372) (sice(I,J),I=1,im,2)
  372   format(50(f2.0))
        enddo

	DO J=1,JM
	DO I=1,IM
	 if (sm(I,J) .gt. 0.9 .and. SICE(I,J) .gt. 0.5) then
	  SI(I,J)=1.
	elseif (sm(I,J) .lt. 0.5) then

C	divide by 1000 to put in m, multiply by 5 to make snow depth
C	instead of liquid equiv
C
	si(I,J)=si(I,J)*(5./1000)

C
C	try to avoid bogus increase of ice mask!
C
	elseif (sm(I,J) .gt. 0.5 .and. SI(I,J) .gt. 0. .and. 
     +		SICE(I,J) .eq. 0) then
	write(6,*) 'water & snow ', i,j,si(I,J)

Ctoolittle	if (si(I,J) .eq. 25) then

	if (si(I,J) .ge. 25) then
	  SICE(I,J)=1.
	  SI(I,J)=1.
	else
	  SI(I,J)=0.
	endif

	endif

	ENDDO	
	ENDDO

	call reansoilint(GGSMC1,nx,ny,im,jm,glat,glon,xpts,ypts,
     +				ggland,sice,sm,smc(1,1,1))
	call reansoilint(GGSMC2,nx,ny,im,jm,glat,glon,xpts,ypts,
     +				ggland,sice,sm,smc(1,1,2))
	call reansoilint(GGSTC1,nx,ny,im,jm,glat,glon,xpts,ypts,
     +				ggland,sice,sm,stc(1,1,1))
	call reansoilint(GGSTC2,nx,ny,im,jm,glat,glon,xpts,ypts,
     +				ggland,sice,sm,stc(1,1,2))
!	call reansoilice(GGSTC1,nx,ny,im,jm,glat,glon,xpts,ypts,
!     +				ggice,sice,sm,stc(1,1,1))
!	call reansoilice(GGSTC2,nx,ny,im,jm,glat,glon,xpts,ypts,
!     +			ggice,sice,sm,stc(1,1,2))


	do N=1,nsoil
	do J=1,JM
	do I=1,IM
	if (STC(I,J,N) .eq. 0) stc(I,J,N)=273.15
!	if (SMC(I,J,N) .eq. 0) smc(I,J,N)=273.15
	enddo
	enddo
	enddo

	do KK=3,4
	 do J=1,jm
	  do I=1,im
		STC(I,J,KK)=STC(I,J,2)
		SMC(I,J,KK)=SMC(I,J,2)
	  enddo
	 enddo
	enddo

!	write(6,*) 'what is ggland?? ' , nx,ny
	do J=1,ny/2,2
!	write(6,611) (ggland(I,J),I=1,NX,8)
	enddo
  611	format(40f4.0)

	call reanseaint(SSTRAW,GGLAND,sm,sice,nx,ny,im,jm,glat,glon,
     +			xpts,ypts,sst)


	return
	end

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

	subroutine reansoilint(ginput,nx,ny,im,jm,glat,glon,xpts,ypts,
     +					rtest,sice,sm,output)

	real ginput(nx,ny),tmpo(nx,ny),glat(im,jm),glon(im,jm)
	real xpts(im,jm),ypts(im,jm),output(im,jm),sm(im,jm),
     +			sice(im,jm),rtest(nx,ny)
     


	tmpo=ginput

	output=-99.

  64	format(10(f5.1,1x))
  75	format(10(f6.1,1x))

	do J=1,jm
	do I=1,im

        if((sm(i,j).gt.0.5).or.(sice(i,j).eq.1.0)) then
c                           set non land-mass values
          output(i,j) = 0.0
        else
c                           set land-mass values
	y=ypts(i,j)
	x=xpts(i,j)
	  iy = y
          ix = x
          iyp1 = iy + 1
          ixp1 = ix + 1
c  First calculate the bilinear weights assuming a constant dx and dy
          wxy =     (ixp1-x) * (iyp1 - y)
          wxp1y =   (x-ix)   * (iyp1 - y)
          wxp1yp1 = (x-ix)   * (y-iy)
          wxyp1 = (ixp1 - x) * (y-iy)
c  Take care of the wrap around the 0 meridan when necessary
          if(ix.eq.nx) ixp1 = 1
c  Only use land mass points (ggsli=1) for the interpolation
C
C	here rtest is land
C
          if(rtest(ix,iy).eq.0.0) wxy = 0.0
          if(rtest(ixp1,iy).eq.0.0) wxp1y = 0.0
          if(rtest(ixp1,iyp1).eq.0.0) wxp1yp1 = 0.0
          if(rtest(ix,iyp1).eq.0.0) wxyp1 = 0.0
          sum = wxy + wxp1y + wxp1yp1 + wxyp1
          if(sum.eq.0.0) then
c  The eta land point is surrounded by gaussian grid non land
c  Look for nearest gaussian grid land point and assign it to the
c  Eta grid point. Find nearest at this latitude
            do jfnd = iy,nx
            do ifnd = ix,ny
            if(tmpo(ifnd,jfnd).gt.0.0) then
                wxy = 1.0
                sum = 1.0
                ix = ifnd
                iy = jfnd
                go to 3356
            end if
            end do
            do ifnd = ix,1,-1
            if(tmpo(ifnd,jfnd).gt.0.0) then
                wxy = 1.0
                sum = 1.0
                ix = ifnd
                iy = jfnd
                go to 3356
            end if
            end do
            end do
!       print *,"Oh Oh can't find a land point at:",glat(i,j),glon(i,j)
!       print *,((tmpo(ii,jj),ii=ix,ix+3),jj=iy,iy+2)
3356        continue
          end if
          wxy = wxy / sum
          wxp1y = wxp1y / sum
          wxp1yp1 = wxp1yp1 / sum
          wxyp1 = wxyp1 / sum
          output(i,j) = wxy     * tmpo(ix,iy)     +
     &                 wxp1y   * tmpo(ixp1,iy)   +
     &                 wxp1yp1 * tmpo(ixp1,iyp1) +
     &                 wxyp1   * tmpo(ix,iyp1)
	if (output(i,j) .eq. 0) 
     +		write(6,*) 'BAD OUTPUT in REANSOILINT', I,J
        end if




	enddo
	enddo

   65	format(30f6.1)

	return
	end

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

	subroutine reanseaint(tmpo,rland,sm,sice,nx,ny,im,jm,glat,glon,
     +				xpts,ypts,output)

	real ginput(nx*ny),tmpo(nx,ny),glat(im,jm),glon(im,jm)
	real xpts(im,jm),ypts(im,jm),output(im,jm),rland(nx,ny)
	real sm(im,jm),sice(im,jm)
     

	output=-99.


  64	format(10(f5.1,1x))
  75	format(10(f6.1,1x))

	do J=1,jm
	do I=1,im

C
        if((sm(i,j).lt.0.5).or.(sice(i,j).eq.1.0)) then
c                           set non land-mass values
Cmp          output(i,j) = 0.0
          output(i,j) = 273.15
        else
c                           set land-mass values
	y=ypts(i,j)
	x=xpts(i,j)
	  iy = y
          ix = x
          iyp1 = iy + 1
          ixp1 = ix + 1
c  First calculate the bilinear weights assuming a constant dx and dy
          wxy =     (ixp1-x) * (iyp1 - y)
          wxp1y =   (x-ix)   * (iyp1 - y)
          wxp1yp1 = (x-ix)   * (y-iy)
          wxyp1 = (ixp1 - x) * (y-iy)
c  Take care of the wrap around the 0 meridan when necessary
          if(ix.eq.nx) ixp1 = 1
c  Only use water points (rland=0) for the interpolation
          if(rland(ix,iy).eq.1.0) wxy = 0.0
          if(rland(ixp1,iy).eq.1.0) wxp1y = 0.0
          if(rland(ixp1,iyp1).eq.1.0) wxp1yp1 = 0.0
          if(rland(ix,iyp1).eq.1.0) wxyp1 = 0.0
          sum = wxy + wxp1y + wxp1yp1 + wxyp1
          if(sum.eq.0.0) then
!	write(6,*) 'dont want to be here'
c  The eta land point is surrounded by gaussian grid non land
c  Look for nearest gaussian grid land point and assign it to the
c  Eta grid point. Find nearest at this latitude
            do jfnd = iy,nx
            do ifnd = ix,ny
C            if(tmpo(ifnd,jfnd).gt.0.0) then
           if(rland(ifnd,jfnd).eq.0.0) then
                wxy = 1.0
                sum = 1.0
                ix = ifnd
                iy = jfnd
                go to 3356
            end if
            end do
            do ifnd = ix,1,-1
            if(rland(ifnd,jfnd).eq.0.0) then
                wxy = 1.0
                sum = 1.0
                ix = ifnd
                iy = jfnd
                go to 3356
            end if
            end do
            end do
       print *,"Oh Oh can't find a land point at:",glat(i,j),glon(i,j)
       print *,((tmpo(ii,jj),ii=ix,ix+3),jj=iy,iy+2)
3356        continue
          end if
          wxy = wxy / sum
          wxp1y = wxp1y / sum
          wxp1yp1 = wxp1yp1 / sum
          wxyp1 = wxyp1 / sum
          output(i,j) = wxy     * tmpo(ix,iy)     +
     &                 wxp1y   * tmpo(ixp1,iy)   +
     &                 wxp1yp1 * tmpo(ixp1,iyp1) +
     &                 wxyp1   * tmpo(ix,iyp1)
        end if

	enddo
	enddo

	write(6,*) 'OUTPUT SST'

	do J=jm,1,-jm/30
	write(6,65) (output(i,j),i=1,im,im/15)
	enddo
   65	format(30f6.1)


	return

	end

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

	subroutine reansnowint(tmpo,nx,ny,im,jm,glat,glon,xpts,ypts,
     +				        sm,output)

	real ginput(nx*ny),tmpo(nx,ny),glat(im,jm),glon(im,jm)
	real xpts(im,jm),ypts(im,jm),output(im,jm),sm(im,jm)

	output=-99.

!	write(6,*) 'input snow field: '

	do J=1,ny/2
!	write(6,632) (tmpo(I,J),I=nx/2,nx,5)
	enddo
  632	format(50(f4.0,1x))

! 	write(6,*) 'end input snow:'

  64	format(10(f5.1,1x))
  75	format(10(f6.1,1x))

	do J=1,jm
	do I=1,im

C
C	interpolate blindly with regard to land/sea?
C
C        if((sm(i,j).gt.0.5).or.(sice(i,j).eq.1.0)) then
C        if((sm(i,j).gt.0.5)) then
c                           set non land-mass values
C          output(i,j) = 0.0
C        else
c                           set land-mass values
	y=ypts(i,j)
	x=xpts(i,j)
	  iy = y
          ix = x
          iyp1 = iy + 1
          ixp1 = ix + 1
c  First calculate the bilinear weights assuming a constant dx and dy
          wxy =     (ixp1-x) * (iyp1 - y)
          wxp1y =   (x-ix)   * (iyp1 - y)
          wxp1yp1 = (x-ix)   * (y-iy)
          wxyp1 = (ixp1 - x) * (y-iy)
c  Take care of the wrap around the 0 meridan when necessary
          if(ix.eq.nx) ixp1 = 1
c  Only use land mass points (ggsli=1) for the interpolation
C          if(tmpo(ix,iy).eq.0.0) wxy = 0.0
C          if(tmpo(ixp1,iy).eq.0.0) wxp1y = 0.0
C          if(tmpo(ixp1,iyp1).eq.0.0) wxp1yp1 = 0.0
C          if(tmpo(ix,iyp1).eq.0.0) wxyp1 = 0.0
          sum = wxy + wxp1y + wxp1yp1 + wxyp1
          if(sum.eq.0.0) then
!	write(6,*) 'dont want to be here'
c  The eta land point is surrounded by gaussian grid non land
c  Look for nearest gaussian grid land point and assign it to the
c  Eta grid point. Find nearest at this latitude
            do jfnd = iy,nx
            do ifnd = ix,ny
            if(tmpo(ifnd,jfnd).gt.0.0) then
                wxy = 1.0
                sum = 1.0
                ix = ifnd
                iy = jfnd
                go to 3356
            end if
            end do
            do ifnd = ix,1,-1
            if(tmpo(ifnd,jfnd).gt.0.0) then
                wxy = 1.0
                sum = 1.0
                ix = ifnd
                iy = jfnd
                go to 3356
            end if
            end do
            end do
       print *,"Oh Oh can't find a land point at:",glat(i,j),glon(i,j)
       print *,((tmpo(ii,jj),ii=ix,ix+3),jj=iy,iy+2)
3356        continue
          end if
          wxy = wxy / sum
          wxp1y = wxp1y / sum
          wxp1yp1 = wxp1yp1 / sum
          wxyp1 = wxyp1 / sum
          output(i,j) = wxy     * tmpo(ix,iy)     +
     &                 wxp1y   * tmpo(ixp1,iy)   +
     &                 wxp1yp1 * tmpo(ixp1,iyp1) +
     &                 wxyp1   * tmpo(ix,iyp1)
Cmp
!	if (output(i,j) .gt. 0 .and. sm(i,j) .eq. 0) then
C
C
!	if (tmpo(ix,iy) .ne. 100. .and. tmpo(ixp1,iy) .ne. 100 .and.
!     +	tmpo(ixp1,iyp1) .ne. 100 .and. tmpo(ix,iyp1) .ne. 100 
!     +	.AND. tmpo(ix,iy) .ne. 25. .and. tmpo(ixp1,iy) .ne. 25. .and.
!     +	tmpo(ixp1,iyp1) .ne. 25. .and. tmpo(ix,iyp1) .ne. 25.) then
!	write(6,*) 'would have created ice at ', I,J
!	write(6,*) 'leaving isolated sea ice at ', I,J
!	write(6,*) 'largest input: ', amax1(tmpo(ix,iy),tmpo(ixp1,iy),
!     +	tmpo(ixp1,iyp1),tmpo(ix,iyp1))
!	output(i,j)=0.
!	else
!	write(6,*) 'legitimate sea ice at ', I,J
!	endif
C
C
!	endif

C        end if

	enddo
	enddo

	write(6,*) 'output from reansnowint'

	do J=jm,1,-jm/30
	write(6,65) (output(i,j),i=1,im,im/15)
	enddo
   65	format(30f6.1)

	return
	end

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

	subroutine reansoilice(ginput,nx,ny,im,jm,glat,glon,xpts,ypts,
     +					rtest,sice,sm,output)

	real ginput(nx,ny),tmpo(nx,ny),glat(im,jm),glon(im,jm)
	real xpts(im,jm),ypts(im,jm),output(im,jm),sm(im,jm),
     +			sice(im,jm),rtest(nx,ny)
     


	tmpo=ginput

  64	format(10(f5.1,1x))
  75	format(10(f6.1,1x))

	do J=1,jm
	do I=1,im

C        if((sm(i,j).gt.0.5).or.(sice(i,j).eq.1.0)) then
c                           set non land-mass values
C          output(i,j) = 0.0
C        else
c                           set land-mass values

	if (sice(i,j) .eq. 1.0) then

	y=ypts(i,j)
	x=xpts(i,j)
	  iy = y
          ix = x
          iyp1 = iy + 1
          ixp1 = ix + 1
c  First calculate the bilinear weights assuming a constant dx and dy
          wxy =     (ixp1-x) * (iyp1 - y)
          wxp1y =   (x-ix)   * (iyp1 - y)
          wxp1yp1 = (x-ix)   * (y-iy)
          wxyp1 = (ixp1 - x) * (y-iy)
c  Take care of the wrap around the 0 meridan when necessary
          if(ix.eq.nx) ixp1 = 1
c  Only use land mass points (ggsli=1) for the interpolation
C
C	here rtest is ice
C	
          if(rtest(ix,iy).eq.0.0) wxy = 0.0
          if(rtest(ixp1,iy).eq.0.0) wxp1y = 0.0
          if(rtest(ixp1,iyp1).eq.0.0) wxp1yp1 = 0.0
          if(rtest(ix,iyp1).eq.0.0) wxyp1 = 0.0
          sum = wxy + wxp1y + wxp1yp1 + wxyp1
          if(sum.eq.0.0) then
c  The eta land point is surrounded by gaussian grid non land
c  Look for nearest gaussian grid land point and assign it to the
c  Eta grid point. Find nearest at this latitude
            do jfnd = iy,nx
            do ifnd = ix,ny
            if(rtest(ifnd,jfnd).eq.1.0) then
                wxy = 1.0
                sum = 1.0
                ix = ifnd
                iy = jfnd
                go to 3356
            end if
            end do
            do ifnd = ix,1,-1
            if(rtest(ifnd,jfnd).eq.1.0) then
                wxy = 1.0
                sum = 1.0
                ix = ifnd
                iy = jfnd
                go to 3356
            end if
            end do
            end do
       print *,"Oh Oh can't find a land point at:",glat(i,j),glon(i,j)
       print *,((tmpo(ii,jj),ii=ix,ix+3),jj=iy,iy+2)
                wxy=1.0
                sum=1.0
                tmpo(ix,iy)=260.0
3356        continue
          end if
          wxy = wxy / sum
          wxp1y = wxp1y / sum
          wxp1yp1 = wxp1yp1 / sum
          wxyp1 = wxyp1 / sum
          output(i,j) = wxy     * tmpo(ix,iy)     +
     &                 wxp1y   * tmpo(ixp1,iy)   +
     &                 wxp1yp1 * tmpo(ixp1,iyp1) +
     &                 wxyp1   * tmpo(ix,iyp1)
        end if

	enddo
	enddo

   65	format(30f6.1)

	return
	end

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

	subroutine reaniceint(tmpo,nx,ny,im,jm,glat,glon,xpts,ypts,
     +				        sm,output)

	real tmpo(nx,ny),glat(im,jm),glon(im,jm)
	real xpts(im,jm),ypts(im,jm),output(im,jm),sm(im,jm)

	output=-99.

!	write(6,*) 'input ice field: '

	do J=1,ny/2
!	write(6,632) (tmpo(I,J),I=nx/2,nx,5)
	enddo
  632	format(50(f4.0,1x))

!	write(6,*) 'end input snow:'

  64	format(10(f5.1,1x))
  75	format(10(f6.1,1x))

	do J=1,jm
	do I=1,im

C
C	interpolate blindly with regard to land/sea?
C
C        if((sm(i,j).gt.0.5).or.(sice(i,j).eq.1.0)) then
        if((sm(i,j).lt.0.5)) then
C                           set non land-mass values
          output(i,j) = 0.0
        else
c                           set land-mass values
	y=ypts(i,j)
	x=xpts(i,j)
	  iy = y
          ix = x
          iyp1 = iy + 1
          ixp1 = ix + 1
c  Take care of the wrap around the 0 meridan when necessary
          if(ix.eq.nx) ixp1 = 1

          output(i,j) =  tmpo(ix,iy)     
Cmp
	endif

	enddo
	enddo

	write(6,*) 'OUTPUT ICE MASK'

	do J=jm,1,-jm/30
	write(6,65) (output(i,j),i=1,im,im/15)
	enddo
   65	format(30f6.1)

	return
	end

      SUBROUTINE SST14K (SST,SM,GLAT,GLON)
C
      IMPLICIT REAL (A-H, O-Z)
C
      INCLUDE "parmeta"
C
      PARAMETER  (IMY=1041,JMY=441)
C
      PARAMETER  (H90=90.0,H360=360.0,D5=5.E-1,D00=0.0,H1=1.0)
      PARAMETER  (RAD2D=57.29578E0,PI=3.141592654)
C
C
C
      DIMENSION    SST14   (IMY,JMY)
C
      DIMENSION  SST(IM,JM), SM(IM,JM), GLAT(IM,JM), GLON(IM,JM)
      DIMENSION HLON(IM,JM)
C
C
      DATA   INSST/44/
C
C**************************  BEGIN EXECUTION ***********************
C
C
C  READ HI RESOLUTION 14 KM OPC SST ANALYSIS, CONVERT To KELVIN
C
      DO 25 I = 1, IMY
       READ (INSST,ERR=200,END=210) (SST14(I,J),J=1,JMY)
   25 CONTINUE
      CALL C2K(IMY,JMY,SST14)
C
C PUT LONGITUDE IN CORRECT ORDER
C
      DO J = 1,JM
      DO I = 1,IM
       HLON(I,J) = 2.0*PI - GLON(I,J)
      ENDDO
      ENDDO
C
C
C----  INTERPOLATE 1/8 DEG GLOBAL SATELLITE SST TO ETA GRID  -------
C
      DO J = 1,JM
      DO I = 1,IM
       IF((GLAT(I,J)*RAD2D).LT.65.0.AND.(GLAT(I,J)*RAD2D).GT.10.0.AND.
     &  (HLON(I,J)*RAD2D).LT.325.0.AND.(HLON(I,J)*RAD2D).GT.195.0)
     &  CALL ZTERPG(I,J,SST14,SST,GLAT,HLON)
      ENDDO
      ENDDO
C
C   REACHING HERE MEANS 14KM SST READ OK
C
      RETURN
C
C   REACHING HERE MEANS SOMETHING IS WRONG
C
  200 CONTINUE      !  SOME KIND OF ERROR READING FILE
      WRITE(6,555) INSST
  210 CONTINUE      !  HIT UNEXPECTED END O' FILE
      WRITE(6,556) INSST
  555 FORMAT ('0', 'ERROR OCCURRED WHEN READING IN 14 KM SST        ',
     1             'ON UNIT', I3, ': SKIPPING 14 KM SST FIELD.')
  556 FORMAT ('0', 'HIT UNEXPECTED END OF FILE READING 14K SST',
     1             'ON UNIT', I3, ': SKIPPING 14 KM SST FIELD.')
      RETURN
      END

	SUBROUTINE VFRAC(im,jm,glat,glon,TLM0D,TPH0D,DLMD,DPHD,SM,
     +  SICE,VEGFRC)

	real*4 glat(IM,JM), glon(IM,JM)
	real*4 TLM0D,TPH0D,DLMD,DPHD
	real*4 sm(im,jm),sice(im,jm),vegfrc(im,jm)
	real*4 dum2(im,jm),dum2b(im,jm)
	integer*4 JULD,MON2,MON1,day1,day2,JULM(13)
        real*4 wght1,wght2,rday,dtr
	INTEGER IDAT(3)
Chou 20080202
        LOGICAL LVEG
	REAL*4 VEGFRM(im,jm)     ! monthly veg greeness	

      data JULM/0,31,59,90,120,151,181,212,243,273,304,334,365/

       INTEGER KPDS(200),KGDS(200),JPDS(200),JGDS(200),KF,KNUM
C      REAL*4 FPAR1(2500,1250),FPAR2(2500,1250),FSVE

       REAL FPAR1(15680,10600),FPAR2(15680,10600),FSVE
       INTEGER RECORDLEN

C       LOGICAL BITMAP(2500,1250)

        common /mytime/idat

C    FOURTH, MONTHLY GREEN VEG FRACTION, INTERPOLATE TO DAY OF YEAR.
C    THE MONTHLY FIELDS ASSUMED VALID AT 15TH OF MONTH.
C    VALUES RANGE FROM 0.001 TO 1.0 OVER LAND, 0.0 OVER WATER.
C    INTERPOLATE IN SPACE.
C
C    READ FROM A FILE THAT HAS 13 RECORDS, ONE PER MONTH WITH
C    JANUARY OCCURRING BOTH AS RECORD 1 AND AGAIN AS RECORD 13,
C    THE LATTER TO SIMPLIFY TIME INTERPOLATION FOR DAYS
C    BETWEEN DEC 16 AND JAN 15. WE TREAT JAN 1 TO JAN 15
C    AS JULIAN DAYS 366 TO 380 BELOW, I.E WRAP AROUND YEAR.
C *** THE FOLLOWING PART WAS REVISED BY F. CHEN 7/96 TO REFLECT
C        A NEW NESDIS VEGETATION FRACTION PRODUCT (FIVE-YEAR
C        CLIMATOLOGY WITH 0.144 DEGREE RESOLUTION
C        FROM 89.928S, 180W TO 89.928N, 180E)
C
       REWIND 38
C
C ****  DO TIME INTERPOLATION ****
       JULD=JULM(IDAT(1))+IDAT(2)
       IF(JULD.LE.15) JULD=JULD+365
       MON2=IDAT(1)
       IF(IDAT(2).GT.15) MON2=MON2+1
       IF(MON2.EQ.1) MON2=13
       MON1=MON2-1
C **** ASSUME DATA VALID AT 15TH OF MONTH
       DAY2=JULM(MON2)+15
       DAY1=JULM(MON1)+15
       RDAY=JULD
       WGHT1=(DAY2-RDAY)/(DAY2-DAY1)
       WGHT2=(RDAY-DAY1)/(DAY2-DAY1)
C
       RECORDLEN = 4*15680
       OPEN(38,FILE='/lustre_xc50/gustavo_sueiro/Oper/worketa/eta/fix/'
     &               //'FCOVER_rec_1999-2014.bin',
     &               ACCESS='direct',FORM='UNFORMATTED',RECL=RECORDLEN)
       DO J=1,10600
          READ(38,REC=J) FPAR1(1:15680,J)
       ENDDO
       CLOSE(38)
      
       OPEN(39,FILE='/lustre_xc50/gustavo_sueiro/Oper/worketa/eta/fix/'
     &               //'FCOVER_rec_1999-2014.bin',
     &               ACCESS='direct',FORM='UNFORMATTED',RECL=RECORDLEN)
       DO J=1,10600
          READ(39,REC=J) FPAR2(1:15680,J)
       ENDDO
       CLOSE(39)
C
       DO JJ=1,10600
        DO I=1,15680
         FSVE=WGHT1*FPAR1(I,JJ)+WGHT2*FPAR2(I,JJ)
         FPAR1(I,JJ)=FSVE
        END DO
       END DO
c
C ** SPACE INTERPOLATION OF FPAR1 TO E GRID
	dtr=acos(-1.)/180.
        glat=glat/dtr
        glon=glon/dtr
       WRITE(6,*) 'lat and lon for PUTVEG ', glat(im/2,jm/2),
     &             glon(im/2,jm/2)
       CALL PUTVEG(TLM0D,TPH0D,DLMD,DPHD,GLAT,GLON,
     &             FPAR1,SM,SICE,vegfrc)
       WRITE(6,*) 'veg fracs ', vegfrc(im/2,jm/2),vegfrc(im/2+5,jm/2+5)

Chou  CREATE FILE of MONTHLY VEG GREENESS INTERPOLATEd TO Egrid in IM,JM
       LVEG=.TRUE.  
       OPEN(83,file='VGREEN_12mo.dat',form='unformatted',
     &        status='unknown')

       IF(LVEG) then

       OPEN(38,FILE='/lustre_xc50/gustavo_sueiro/Oper/worketa/eta/fix/'
     &               //'FCOVER_rec_1999-2014.bin',
     &               ACCESS='direct',FORM='UNFORMATTED',RECL=RECORDLEN)

       JMS=0
C       JME=10600

       DO imo=1,12
          
       DO J= 1 ,10600
          READ(38,REC=J+JMS) FPAR1(1:15680,J)
       ENDDO
       
C interpolate to Egrid.
       CALL PUTVEG(TLM0D,TPH0D,DLMD,DPHD,GLAT,GLON,
     &             FPAR1,SM,SICE,vegfrm)
     
       CALL PUTVEG(TLM0D,TPH0D,DLMD,DPHD,GLAT,GLON,
     &             FPAR1,SM,SICE,vegfrm)

       write(83) vegfrm

       JMS=JMS+10600
C       JME=JME+10600      
       ENDDO  ! END imo Loop
 
       CLOSE(38)
      
       ENDIF
Chou

       RETURN
       END

      SUBROUTINE READSFC(HLAT,HLON,SM,SICE,SMC,STC,TG)
C     ******************************************************************
C
C	Needed inputs:
C
C	HLAT(IM,JM), HLON(IM,JM)
C	SM(IM,JM), SICE(IM,JM)
C
C	OUTPUTS:
C
C	SMC(IM,JM,NSOIL),STC(IM,JM,NSOIL),TG(IM,JM)
C
C----------------------------------------------------------------------
      integer,parameter::real_32=selected_real_kind(6,30)
      INCLUDE "parmeta"
      INCLUDE "parmsoil"
C----------------------------------------------------------------------
       REAL SICE (IM,JM), SM(IM,JM),SMC(IM,JM,NSOIL),STC(IM,JM,NSOIL)
       REAL HLAT(IM,JM),HLON(IM,JM)
                             D I M E N S I O N
     &  IGDATE(4)
C
       REAL(REAL_32),ALLOCATABLE,DIMENSION(:)::GLATS
       REAL(REAL_32),ALLOCATABLE,DIMENSION(:,:)::GGTG,GGSLI,GGRID1
       REAL(REAL_32),ALLOCATABLE,DIMENSION(:,:,:)::GGSMC2,GGSTC2

C	real*8 etime
C
       CHARACTER*32 GLABEL
C-----------------------------------------------------------------------
      DPR=180./3.141592654
C
C	btime=etime()
	open(unit=33,file='sfcanl',form='unformatted',
     +		access='sequential')	
Csomelinux	open(unit=33,file='sfcanl',form='unformatted',
Csomelinux     +		access='sequential',convert='big_endian')	
      READ (33) 
      READ (33) GFHR,IGDATE,NGLONS,NGLATS,NUM
      print *,' READSFC: nglats,nglons = ',gfhr,igdate,nglats,nglons,num
      ALLOCATE(GGRID1(NGLONS,NGLATS))
      ALLOCATE(GLATS(NGLATS))
      ALLOCATE(GGSMC2(NGLONS,NGLATS,2))
      ALLOCATE(GGSTC2(NGLONS,NGLATS,2))
      ALLOCATE(GGTG(NGLONS,NGLATS))
      ALLOCATE(GGSLI(NGLONS,NGLATS))
C

	CALL GAULAT(glats,nglats)

C	write(6,*) 'back from GAULAT'
	do J=1,nglats,4
C	write(6,*) 'J,glats(J)= ', J,glats(J)
	enddo


C
C NOW READ IN THE FIELDS, NOTE WE NEED THE GLOBAL SEA,LAND ICE MASK
C TO DO A PROPER INTERPOLATION.
C FIRST TWO RECORDS NOW READ IN ECONVK
c     OPEN(33,FILE='fort.33',
c    &     FORM='UNFORMATTED',STATUS='OLD',IOSTAT=IRET)
C
      print *,'ok after gfhr in sfcanl'
C  BYPASS THE SURFACE TEMPERATURE RECORD
      READ (33) GGRID1
      print *,'ok after rec 1 in sfcanl'
C  READ AND SAVE THE TWO-LAYER SOIL MOISTURE RECORDS
      READ (33) GGSMC2
      print *,'ok after rec 2 in sfcanl'
C  BYPASS THE SNOW DEPTH RECORD
      READ (33) GGRID1
      print *,'ok after rec 3 in sfcanl'
C  READ AND STORE THE THE SOIL TEMPERATURES (TWO-LAYERS)
      READ (33) GGSTC2
      print *,'ok after rec 4 in sfcanl'
C  READ AND STORE THE DEEP LAYER SOIL TEMPERATURE
      READ (33) GGTG
      print *,'ok after rec 5 in sfcanl'
C  BYPASS 5 MORE RECORDS AND THEN READ AND STORE THE SEA,LAND ICE RECORD
C  BYPASSING Z0,CONV. CLD FRACT.,CONV. CLD BASE,CONV CLD TOP, AND ALBEDO
      DO KRD = 1,6
      READ (33) GGSLI
      END DO
      print *,'ok after rec 6-12 in sfcanl'

C	read_tim=etime()-btim

C		write(6,*) 'read time ', read_tim

C	btim=etime()
C	write(6,*) 'some gautoeta input arguments'
C	write(6,*) 'GLATS(25) ', glats(25)
C	write(6,*) 'nglats,nglons= ', nglats,nglons
C	write(6,*) 'HLAT,HLON: ', HLAT(25,25),HLON(25,25)
C	write(6,*) 'SM,SICE : ', SM(25,25),sice(25,25)
C	write(6,*) 'GGSLI,GGSMC2 ', GGSLI(25,25),GGSMC2(25,25,1)
      CALL GAUTOETA(GLATS,NGLATS,NGLONS,HLAT,HLON,SM,SICE,GGSLI,
     &              GGSMC2(1,1,1),SMC(1,1,1))
      CALL GAUTOETA(GLATS,NGLATS,NGLONS,HLAT,HLON,SM,SICE,GGSLI,
     &              GGSTC2(1,1,1),STC(1,1,1))
      CALL GAUTOICE(GLATS,NGLATS,NGLONS,HLAT,HLON,SM,SICE,GGSLI,
     &              GGSTC2(1,1,1),STC(1,1,1))
Cmp
C	write(6,*) 'gaussian soil level 1'
	do J=nglats,1,-30
C	write(6,666) (GGSTC2(I,J,1),I=1,nglons,40)
	enddo
C	write(6,*) 'gaussian soil level 2'
	do J=nglats,1,-30
C	write(6,666) (GGSTC2(I,J,2),I=1,nglons,40)
	enddo
  666	format(10(f5.1,1x))
Cmp
      DO KK=2,NSOIL
       CALL GAUTOETA(GLATS,NGLATS,NGLONS,HLAT,HLON,SM,SICE,GGSLI,
     &              GGSMC2(1,1,2),SMC(1,1,KK))
       CALL GAUTOETA(GLATS,NGLATS,NGLONS,HLAT,HLON,SM,SICE,GGSLI,
     &              GGSTC2(1,1,2),STC(1,1,KK))
       CALL GAUTOICE(GLATS,NGLATS,NGLONS,HLAT,HLON,SM,SICE,GGSLI,
     &              GGSTC2(1,1,2),STC(1,1,KK))
      ENDDO
Cmp
C	write(6,*) 'layer 1 STC '
	do J=JM,1,-4
C	write(6,633) (STC(I,J,1),I=1,IM,IM/18)
	enddo
C	write(6,*) 'layer 4 STC '
	do J=JM,1,-4
C	write(6,633) (STC(I,J,4),I=1,IM,IM/18)
	enddo
  633	format(20(f4.0,1x))
C
C NOW SET LOWER BOUNDARY CONDITION ON SUB-SURFACE
C TEMPERATURE, TREAT UNDER SEA-ICE AFTER CALL
      CALL GAUTOETA(GLATS,NGLATS,NGLONS,HLAT,HLON,SM,SICE,GGSLI,
     &              GGTG,TG)
C
      DEALLOCATE(GGRID1)
      DEALLOCATE(GLATS)
      DEALLOCATE(GGSMC2)
      DEALLOCATE(GGSTC2)
      DEALLOCATE(GGTG)
      DEALLOCATE(GGSLI)
C-----------------------------------------------------------------------
                             RETURN
                             END

C-CP
      SUBROUTINE C2K(M,N,A)
C-CP
C-CP CONVERTS AN ARRAY OF TEMPERATURES FROM CENTIGRADE TO KELVIN
C-CP
      DIMENSION A(M,N)
C
      IMAX=M
      JMAX=N
C
      doout50: DO J =1,JMAX
      doin50: DO  I =1,IMAX
        A(I,J) = A(I,J) + 273.16
      END DO doin50
      END DO doout50
C
      RETURN
      END

C-CP
      SUBROUTINE ZTERPG(II,JJ,Z,ZOLD,HLAT,HLON)
C
C     II,JJ: INDICIES ON ETA GRID
C
      INCLUDE "parmeta"
C
C   IMX,JMX are the dimensions of the 14 KM SST FIELD
C
                        P A R A M E T E R
     1 (IMX=1041,JMX=441,IMXP=IMX+1)
                        P A R A M E T E R
     1 (HD5=0.125,H2=2.0,RAD2D=57.29578)
                        D I M E N S I O N
     1  Z(IMX,JMX),HLAT(IM,JM),HLON(IM,JM)
     2, ALAT(IMX,JMX),ALON(IMX,JMX),ZOLD(IM,JM)
C***
C*** RECALL THAT HLAT AND HLON ARE THE GEODETIC LATITUDE AND
C*** LONGITUDE OF THE ETA GRID H POINTS.  ALAT AND ALON ARE THE
C-CP GEODETIC LATITUDE AND LONGITUDE OF THE 1/8 DEG LAT/LON GRID.
C*** GOING TO REPLACE ZOLD(M,N) WITH AN INTERPOLATED VALUE OF Z
C*** ONLY WHERE VALUES GREATER THAN ZERO EXIST IN Z.
C***
      D11=1.0
      D12=1.0
      D21=1.0
      D22=1.0
      doout10: DO J=1,JMX
       doin10: DO I=1,IMX
C
C   10N,195E is the lat/lon of the SW corner point of the
C   14 km SST grid
C
      ALAT(I,J)=10.0 +(J-1)*HD5
      ALON(I,J)=195.0+(I-1)*HD5
      END DO doin10
      END DO doout10
      TLAT=HLAT(II,JJ)*RAD2D
      TLON=HLON(II,JJ)*RAD2D
      do20: DO J=1,JMX
      IF(TLAT.GT.ALAT(1,J)) CYCLE do20
      JPT=J
      GO TO 25
      END DO do20
      STOP50
   25 DO 50 I=1,IMXP
      ALON1=ALON(1,1)
      IF(I.LT.IMXP)ALON1=ALON(I,1)
      IF(TLON.GT.ALON1)GO TO 50
      IPT=I
      IPTM=IPT-1
      IF(IPT.EQ.IMXP)IPT=1
      IF(IPT.EQ.1)IPTM=IMX
      GO TO 60
   50 CONTINUE
      STOP601
   60 CONTINUE
      IF(JPT.EQ.1)JPT=2
      IF(IPT.EQ.1.AND.IPTM.LT.1)IPT=2
      DXT=ALON(IPT,JPT)-ALON(IPTM,JPT)
      DYT=ALAT(IPT,JPT)-ALAT(IPT,JPT-1)
      DX=(TLON-ALON(IPTM,JPT))/DXT
      DXR=(ALON(IPT,JPT)-TLON)/DXT
      DY=(TLAT-ALAT(IPT,JPT-1))/DYT
      DYR=(ALAT(IPT,JPT)-TLAT)/DYT
      ZTERP1=Z(IPTM,JPT-1)*DXR*DYR+
     1 Z(IPT,JPT-1)*DX*DYR+
     2 Z(IPTM,JPT)*DXR*DY+
     3 Z(IPT,JPT)*DX*DY
      IF (Z(IPTM,JPT-1).EQ.0.0) D11=0.0
      IF (Z(IPT ,JPT-1).EQ.0.0) D12=0.0
      IF (Z(IPTM,JPT  ).EQ.0.0) D21=0.0
      IF (Z(IPT ,JPT  ).EQ.0.0) D22=0.0
      IF (ZTERP1.EQ.0.0) THEN
      RETURN
      ELSE
      DENOM1=D11*DXR*DYR+
     1 D12*DX*DYR+
     2 D21*DXR*DY+
     3 D22*DX*DY
      ZOLD(II,JJ)=ZTERP1/DENOM1
      END IF
      RETURN
      END
